/*
 * TITLE:NFS
 * INFO:
 * CONVERSION TYPE
 *     GENE-PROTEIN:TPP_RAPID
 *     METABOLIC:MM
 */

#include "life.h"

void usr_fvec(double fvec[], double y[], double Gene, Parameter *p)
{
	double *constantPlayer	= p->val[1];
	double *Kb	= p->val[2];
	double *kx	= p->val[3];
	double *kp	= p->val[4];
	double *kpd	= p->val[5];
	double *km	= p->val[6];
	double *kmd	= p->val[7];
	double *Q	= p->val[8];
	double *Kmich	= p->val[9];

	fvec[  1] = constantPlayer[11] - (y[1] + y[19]);
	fvec[  2] = constantPlayer[12] - (y[2] + y[22]);
	fvec[  3] = constantPlayer[13] - (y[3] + y[20]);
	fvec[  4] = y[53] - (y[4] + y[31] + y[41]);
	fvec[  5] = y[54] - (y[5] + y[32] + y[40]);
	fvec[  6] = y[55] - (y[6] + y[18] + y[19] + y[20] + y[21]);
	fvec[  7] = y[56] - (y[7] + 4*y[22] + y[34] + y[35] + y[36] + y[45]);
	fvec[  8] = y[57] - (y[8] + y[23] + y[24] + y[34] + y[39] + y[45]);
	fvec[  9] = y[58] - (y[9] + y[21] + y[33] + y[44]);
	fvec[ 10] = constantPlayer[14] - (y[10] + y[25] + y[26] + y[31] + y[32] + y[37] + y[38] + y[40] + y[41]);
	fvec[ 11] = y[59] - (y[11] + y[24] + y[25] + y[29] + y[31] + y[33] + y[34]);
	fvec[ 12] = y[60] - (y[12] + y[26] + y[30] + y[32]);
	fvec[ 13] = constantPlayer[15] - (y[13] + y[27] + y[28] + y[29] + y[30] + y[42] + y[43]);
	fvec[ 14] = constantPlayer[16] - (y[14] + y[35]);
	fvec[ 15] = constantPlayer[17] - (y[15] + y[36]);
	fvec[ 16] = y[61] - (y[16] + y[38] + y[39] + y[41] + y[42] + y[44] + y[45]);
	fvec[ 17] = y[62] - (y[17] + y[37] + y[40] + y[43]);
	fvec[ 18] = Kb[13]*y[6]*constantPlayer[1] - y[18];
	fvec[ 19] = Kb[15]*y[6]*y[1] - y[19];
	fvec[ 20] = Kb[16]*y[6]*y[3] - y[20];
	fvec[ 21] = Kb[12]*y[6]*y[9] - y[21];
	fvec[ 22] = pow(Kb[17], 4)*pow(y[7], 4)*y[2] - y[22];
	fvec[ 23] = Kb[10]*y[8]*constantPlayer[5] - y[23];
	fvec[ 24] = Kb[9]*y[8]*y[11] - y[24];
	fvec[ 25] = Kb[5]*y[10]*y[11] - y[25];
	fvec[ 26] = Kb[6]*y[10]*y[12] - y[26];
	fvec[ 27] = Kb[2]*y[13]*y[46] - y[27];
	fvec[ 28] = Kb[1]*y[13]*y[48] - y[28];
	fvec[ 29] = Kb[3]*y[11]*constantPlayer[9]*y[27] - y[29];
	fvec[ 30] = Kb[4]*y[12]*y[28] - y[30];
	fvec[ 31] = Kb[7]*y[4]*constantPlayer[4]*y[25] - y[31];
	fvec[ 32] = Kb[8]*y[5]*y[26] - y[32];
	fvec[ 33] = Kb[11]*y[9]*constantPlayer[3]*y[11] - y[33];
	fvec[ 34] = Kb[14]*y[7]*y[24] - y[34];
	fvec[ 35] = Kb[27]*y[7]*y[14] - y[35];
	fvec[ 36] = Kb[26]*y[7]*y[15] - y[36];
	fvec[ 37] = Kb[24]*y[10]*y[17] - y[37];
	fvec[ 38] = Kb[25]*y[10]*y[16] - y[38];
	fvec[ 39] = Kb[28]*y[8]*y[16] - y[39];
	fvec[ 40] = Kb[18]*y[5]*y[37] - y[40];
	fvec[ 41] = Kb[19]*y[4]*constantPlayer[4]*y[38] - y[41];
	fvec[ 42] = Kb[22]*y[16]*constantPlayer[9]*y[27] - y[42];
	fvec[ 43] = Kb[23]*y[17]*y[28] - y[43];
	fvec[ 44] = Kb[20]*y[9]*constantPlayer[3]*y[16] - y[44];
	fvec[ 45] = Kb[21]*y[7]*y[39] - y[45];
	fvec[ 46] = -Q[1]*constantPlayer[19]*y[46]/(Kmich[1] + y[46])*constantPlayer[18]/(Kmich[2] + constantPlayer[18]) - Q[2]*constantPlayer[20]*y[48]/(Kmich[3] + y[48])*y[46]/(Kmich[4] + y[46]) - Q[4]*y[46]/(Kmich[7] + y[46]) + Q[7]*constantPlayer[21]/(Kmich[10] + constantPlayer[21]);
	fvec[ 47] = Q[1]*constantPlayer[19]*y[46]/(Kmich[1] + y[46])*constantPlayer[18]/(Kmich[2] + constantPlayer[18]) + 2*Q[2]*constantPlayer[20]*y[48]/(Kmich[3] + y[48])*y[46]/(Kmich[4] + y[46]) - Q[3]*y[53]*y[47]/(Kmich[5] + y[47])*constantPlayer[18]/(Kmich[6] + constantPlayer[18]) - Q[6]*y[47]/(Kmich[9] + y[47]);
	fvec[ 48] = -Q[2]*constantPlayer[20]*y[48]/(Kmich[3] + y[48])*y[46]/(Kmich[4] + y[46]) + Q[3]*y[53]*y[47]/(Kmich[5] + y[47])*constantPlayer[18]/(Kmich[6] + constantPlayer[18]) - Q[5]*y[48]/(Kmich[8] + y[48]);
	fvec[ 49] = km[1]*(y[22]/constantPlayer[12])*constantPlayer[6] + km[2]*(1 - y[19]/constantPlayer[11])*constantPlayer[6] + km[7]*(1 - y[35]/constantPlayer[16])*constantPlayer[6] - kmd[1]*y[49];
	fvec[ 50] = km[3]*(1 - y[20]/constantPlayer[13])*constantPlayer[7] + km[4]*(y[22]/constantPlayer[12])*constantPlayer[7] + km[8]*(1 - y[35]/constantPlayer[16])*constantPlayer[7] - kmd[2]*y[50];
	fvec[ 51] = km[5]*(1 - y[20]/constantPlayer[13])*constantPlayer[8] + km[6]*(y[22]/constantPlayer[12])*constantPlayer[8] + km[9]*(1 - y[35]/constantPlayer[16])*constantPlayer[8] - kmd[3]*y[51];
	fvec[ 52] = km[10]*(y[36]/constantPlayer[17])*constantPlayer[10] - kmd[4]*y[52];
	fvec[ 53] = kp[1]*y[49] + kx[4]*y[32] + kx[10]*y[40] - kpd[1]*y[4] - kx[3]*y[31] - kpd[14]*y[31] - kx[11]*y[41];
	fvec[ 54] = kx[3]*y[31] + kx[11]*y[41] - kpd[2]*y[5] - kx[4]*y[32] - kpd[15]*y[32] - kx[10]*y[40];
	fvec[ 55] = kp[2]*y[50] + kx[9]*y[34] + kx[13]*y[45] - kpd[3]*y[6] - kx[8]*y[18] - kpd[7]*y[18] - kpd[8]*y[19] - kpd[9]*y[20] - kx[7]*y[21] - kpd[10]*y[21];
	fvec[ 56] = kx[7]*y[21] + kx[8]*y[18] - kpd[4]*y[7] - 4*kpd[11]*y[22] - kx[9]*y[34] - kpd[17]*y[34] - kpd[20]*y[35] - kpd[21]*y[36] - kx[13]*y[45];
	fvec[ 57] = kp[3]*y[51] + kx[6]*y[33] + kx[7]*y[21] + kx[12]*y[44] - kpd[5]*y[8] - kx[5]*y[23] - kpd[12]*y[23] - kpd[13]*y[24] - kpd[17]*y[34] - kpd[24]*y[39];
	fvec[ 58] = kx[5]*y[23] - kpd[6]*y[9] - kx[7]*y[21] - kpd[10]*y[21] - kx[6]*y[33] - kpd[16]*y[33] - kx[12]*y[44];
	fvec[ 59] = kx[2]*y[30] - kx[1]*y[29];
	fvec[ 60] = kx[1]*y[29] - kx[2]*y[30];
	fvec[ 61] = kp[4]*y[52] + kx[15]*y[43] - kpd[18]*y[16] - kpd[23]*y[38] - kpd[24]*y[39] - kx[14]*y[42];
	fvec[ 62] = kx[14]*y[42] - kpd[19]*y[17] - kpd[22]*y[37] - kx[15]*y[43];
}

void usr_fjac(double fjac[][MAX_VAR_NUM], double y[], double Gene, Parameter *p)
{
	double *constantPlayer	= p->val[1];
	double *Kb	= p->val[2];
	double *kx	= p->val[3];
	double *kp	= p->val[4];
	double *kpd	= p->val[5];
	double *km	= p->val[6];
	double *kmd	= p->val[7];
	double *Q	= p->val[8];
	double *Kmich	= p->val[9];

	fjac[  1][  1] = -1;
	fjac[  1][ 19] = -1;
	fjac[  2][  2] = -1;
	fjac[  2][ 22] = -1;
	fjac[  3][  3] = -1;
	fjac[  3][ 20] = -1;
	fjac[  4][  4] = -1;
	fjac[  4][ 31] = -1;
	fjac[  4][ 41] = -1;
	fjac[  4][ 53] = 1;
	fjac[  5][  5] = -1;
	fjac[  5][ 32] = -1;
	fjac[  5][ 40] = -1;
	fjac[  5][ 54] = 1;
	fjac[  6][  6] = -1;
	fjac[  6][ 18] = -1;
	fjac[  6][ 19] = -1;
	fjac[  6][ 20] = -1;
	fjac[  6][ 21] = -1;
	fjac[  6][ 55] = 1;
	fjac[  7][  7] = -1;
	fjac[  7][ 22] = -4;
	fjac[  7][ 34] = -1;
	fjac[  7][ 35] = -1;
	fjac[  7][ 36] = -1;
	fjac[  7][ 45] = -1;
	fjac[  7][ 56] = 1;
	fjac[  8][  8] = -1;
	fjac[  8][ 23] = -1;
	fjac[  8][ 24] = -1;
	fjac[  8][ 34] = -1;
	fjac[  8][ 39] = -1;
	fjac[  8][ 45] = -1;
	fjac[  8][ 57] = 1;
	fjac[  9][  9] = -1;
	fjac[  9][ 21] = -1;
	fjac[  9][ 33] = -1;
	fjac[  9][ 44] = -1;
	fjac[  9][ 58] = 1;
	fjac[ 10][ 10] = -1;
	fjac[ 10][ 25] = -1;
	fjac[ 10][ 26] = -1;
	fjac[ 10][ 31] = -1;
	fjac[ 10][ 32] = -1;
	fjac[ 10][ 37] = -1;
	fjac[ 10][ 38] = -1;
	fjac[ 10][ 40] = -1;
	fjac[ 10][ 41] = -1;
	fjac[ 11][ 11] = -1;
	fjac[ 11][ 24] = -1;
	fjac[ 11][ 25] = -1;
	fjac[ 11][ 29] = -1;
	fjac[ 11][ 31] = -1;
	fjac[ 11][ 33] = -1;
	fjac[ 11][ 34] = -1;
	fjac[ 11][ 59] = 1;
	fjac[ 12][ 12] = -1;
	fjac[ 12][ 26] = -1;
	fjac[ 12][ 30] = -1;
	fjac[ 12][ 32] = -1;
	fjac[ 12][ 60] = 1;
	fjac[ 13][ 13] = -1;
	fjac[ 13][ 27] = -1;
	fjac[ 13][ 28] = -1;
	fjac[ 13][ 29] = -1;
	fjac[ 13][ 30] = -1;
	fjac[ 13][ 42] = -1;
	fjac[ 13][ 43] = -1;
	fjac[ 14][ 14] = -1;
	fjac[ 14][ 35] = -1;
	fjac[ 15][ 15] = -1;
	fjac[ 15][ 36] = -1;
	fjac[ 16][ 16] = -1;
	fjac[ 16][ 38] = -1;
	fjac[ 16][ 39] = -1;
	fjac[ 16][ 41] = -1;
	fjac[ 16][ 42] = -1;
	fjac[ 16][ 44] = -1;
	fjac[ 16][ 45] = -1;
	fjac[ 16][ 61] = 1;
	fjac[ 17][ 17] = -1;
	fjac[ 17][ 37] = -1;
	fjac[ 17][ 40] = -1;
	fjac[ 17][ 43] = -1;
	fjac[ 17][ 62] = 1;
	fjac[ 18][  6] = Kb[13]*constantPlayer[1];
	fjac[ 18][ 18] = -1;
	fjac[ 19][  1] = Kb[15]*y[6];
	fjac[ 19][  6] = Kb[15]*y[1];
	fjac[ 19][ 19] = -1;
	fjac[ 20][  3] = Kb[16]*y[6];
	fjac[ 20][  6] = Kb[16]*y[3];
	fjac[ 20][ 20] = -1;
	fjac[ 21][  6] = Kb[12]*y[9];
	fjac[ 21][  9] = Kb[12]*y[6];
	fjac[ 21][ 21] = -1;
	fjac[ 22][  2] = pow(Kb[17], 4)*pow(y[7], 4);
	fjac[ 22][  7] = 4*pow(y[7], 3)*pow(Kb[17], 4)*y[2];
	fjac[ 22][ 22] = -1;
	fjac[ 23][  8] = Kb[10]*constantPlayer[5];
	fjac[ 23][ 23] = -1;
	fjac[ 24][  8] = Kb[9]*y[11];
	fjac[ 24][ 11] = Kb[9]*y[8];
	fjac[ 24][ 24] = -1;
	fjac[ 25][ 10] = Kb[5]*y[11];
	fjac[ 25][ 11] = Kb[5]*y[10];
	fjac[ 25][ 25] = -1;
	fjac[ 26][ 10] = Kb[6]*y[12];
	fjac[ 26][ 12] = Kb[6]*y[10];
	fjac[ 26][ 26] = -1;
	fjac[ 27][ 13] = Kb[2]*y[46];
	fjac[ 27][ 27] = -1;
	fjac[ 27][ 46] = Kb[2]*y[13];
	fjac[ 28][ 13] = Kb[1]*y[48];
	fjac[ 28][ 28] = -1;
	fjac[ 28][ 48] = Kb[1]*y[13];
	fjac[ 29][ 11] = Kb[3]*constantPlayer[9]*y[27];
	fjac[ 29][ 27] = Kb[3]*y[11]*constantPlayer[9];
	fjac[ 29][ 29] = -1;
	fjac[ 30][ 12] = Kb[4]*y[28];
	fjac[ 30][ 28] = Kb[4]*y[12];
	fjac[ 30][ 30] = -1;
	fjac[ 31][  4] = Kb[7]*constantPlayer[4]*y[25];
	fjac[ 31][ 25] = Kb[7]*y[4]*constantPlayer[4];
	fjac[ 31][ 31] = -1;
	fjac[ 32][  5] = Kb[8]*y[26];
	fjac[ 32][ 26] = Kb[8]*y[5];
	fjac[ 32][ 32] = -1;
	fjac[ 33][  9] = Kb[11]*constantPlayer[3]*y[11];
	fjac[ 33][ 11] = Kb[11]*y[9]*constantPlayer[3];
	fjac[ 33][ 33] = -1;
	fjac[ 34][  7] = Kb[14]*y[24];
	fjac[ 34][ 24] = Kb[14]*y[7];
	fjac[ 34][ 34] = -1;
	fjac[ 35][  7] = Kb[27]*y[14];
	fjac[ 35][ 14] = Kb[27]*y[7];
	fjac[ 35][ 35] = -1;
	fjac[ 36][  7] = Kb[26]*y[15];
	fjac[ 36][ 15] = Kb[26]*y[7];
	fjac[ 36][ 36] = -1;
	fjac[ 37][ 10] = Kb[24]*y[17];
	fjac[ 37][ 17] = Kb[24]*y[10];
	fjac[ 37][ 37] = -1;
	fjac[ 38][ 10] = Kb[25]*y[16];
	fjac[ 38][ 16] = Kb[25]*y[10];
	fjac[ 38][ 38] = -1;
	fjac[ 39][  8] = Kb[28]*y[16];
	fjac[ 39][ 16] = Kb[28]*y[8];
	fjac[ 39][ 39] = -1;
	fjac[ 40][  5] = Kb[18]*y[37];
	fjac[ 40][ 37] = Kb[18]*y[5];
	fjac[ 40][ 40] = -1;
	fjac[ 41][  4] = Kb[19]*constantPlayer[4]*y[38];
	fjac[ 41][ 38] = Kb[19]*y[4]*constantPlayer[4];
	fjac[ 41][ 41] = -1;
	fjac[ 42][ 16] = Kb[22]*constantPlayer[9]*y[27];
	fjac[ 42][ 27] = Kb[22]*y[16]*constantPlayer[9];
	fjac[ 42][ 42] = -1;
	fjac[ 43][ 17] = Kb[23]*y[28];
	fjac[ 43][ 28] = Kb[23]*y[17];
	fjac[ 43][ 43] = -1;
	fjac[ 44][  9] = Kb[20]*constantPlayer[3]*y[16];
	fjac[ 44][ 16] = Kb[20]*y[9]*constantPlayer[3];
	fjac[ 44][ 44] = -1;
	fjac[ 45][  7] = Kb[21]*y[39];
	fjac[ 45][ 39] = Kb[21]*y[7];
	fjac[ 45][ 45] = -1;
	fjac[ 46][ 46] = -(Q[1]*constantPlayer[19]*(Kmich[1] + y[46]) - Q[1]*constantPlayer[19]*y[46])/pow((Kmich[1] + y[46]), 2)*constantPlayer[18]/(Kmich[2] + constantPlayer[18]) - (Q[2]*constantPlayer[20]*y[48]/(Kmich[3] + y[48])*(Kmich[4] + y[46]) - Q[2]*constantPlayer[20]*y[48]/(Kmich[3] + y[48])*y[46])/pow((Kmich[4] + y[46]), 2) - (Q[4]*(Kmich[7] + y[46]) - Q[4]*y[46])/pow((Kmich[7] + y[46]), 2);
	fjac[ 46][ 48] = -(Q[2]*constantPlayer[20]*(Kmich[3] + y[48]) - Q[2]*constantPlayer[20]*y[48])/pow((Kmich[3] + y[48]), 2)*y[46]/(Kmich[4] + y[46]);
	fjac[ 47][ 46] = (Q[1]*constantPlayer[19]*(Kmich[1] + y[46]) - Q[1]*constantPlayer[19]*y[46])/pow((Kmich[1] + y[46]), 2)*constantPlayer[18]/(Kmich[2] + constantPlayer[18]) + (Q[2]*constantPlayer[20]*y[48]/(Kmich[3] + y[48])*(Kmich[4] + y[46]) - Q[2]*constantPlayer[20]*y[48]/(Kmich[3] + y[48])*y[46])/pow((Kmich[4] + y[46]), 2)*2;
	fjac[ 47][ 47] = -(Q[3]*y[53]*(Kmich[5] + y[47]) - Q[3]*y[53]*y[47])/pow((Kmich[5] + y[47]), 2)*constantPlayer[18]/(Kmich[6] + constantPlayer[18]) - (Q[6]*(Kmich[9] + y[47]) - Q[6]*y[47])/pow((Kmich[9] + y[47]), 2);
	fjac[ 47][ 48] = (Q[2]*constantPlayer[20]*(Kmich[3] + y[48]) - Q[2]*constantPlayer[20]*y[48])/pow((Kmich[3] + y[48]), 2)*y[46]/(Kmich[4] + y[46])*2;
	fjac[ 47][ 53] = -Q[3]*y[47]/(Kmich[5] + y[47])*constantPlayer[18]/(Kmich[6] + constantPlayer[18]);
	fjac[ 48][ 46] = -(Q[2]*constantPlayer[20]*y[48]/(Kmich[3] + y[48])*(Kmich[4] + y[46]) - Q[2]*constantPlayer[20]*y[48]/(Kmich[3] + y[48])*y[46])/pow((Kmich[4] + y[46]), 2);
	fjac[ 48][ 47] = (Q[3]*y[53]*(Kmich[5] + y[47]) - Q[3]*y[53]*y[47])/pow((Kmich[5] + y[47]), 2)*constantPlayer[18]/(Kmich[6] + constantPlayer[18]);
	fjac[ 48][ 48] = -(Q[2]*constantPlayer[20]*(Kmich[3] + y[48]) - Q[2]*constantPlayer[20]*y[48])/pow((Kmich[3] + y[48]), 2)*y[46]/(Kmich[4] + y[46]) - (Q[5]*(Kmich[8] + y[48]) - Q[5]*y[48])/pow((Kmich[8] + y[48]), 2);
	fjac[ 48][ 53] = Q[3]*y[47]/(Kmich[5] + y[47])*constantPlayer[18]/(Kmich[6] + constantPlayer[18]);
	fjac[ 49][ 19] = (-1/constantPlayer[11])*km[2]*constantPlayer[6];
	fjac[ 49][ 22] = 1/constantPlayer[12]*km[1]*constantPlayer[6];
	fjac[ 49][ 35] = (-1/constantPlayer[16])*km[7]*constantPlayer[6];
	fjac[ 49][ 49] = -kmd[1];
	fjac[ 50][ 20] = (-1/constantPlayer[13])*km[3]*constantPlayer[7];
	fjac[ 50][ 22] = 1/constantPlayer[12]*km[4]*constantPlayer[7];
	fjac[ 50][ 35] = (-1/constantPlayer[16])*km[8]*constantPlayer[7];
	fjac[ 50][ 50] = -kmd[2];
	fjac[ 51][ 20] = (-1/constantPlayer[13])*km[5]*constantPlayer[8];
	fjac[ 51][ 22] = 1/constantPlayer[12]*km[6]*constantPlayer[8];
	fjac[ 51][ 35] = (-1/constantPlayer[16])*km[9]*constantPlayer[8];
	fjac[ 51][ 51] = -kmd[3];
	fjac[ 52][ 36] = 1/constantPlayer[17]*km[10]*constantPlayer[10];
	fjac[ 52][ 52] = -kmd[4];
	fjac[ 53][  4] = -kpd[1];
	fjac[ 53][ 31] = -kx[3] - kpd[14];
	fjac[ 53][ 32] = kx[4];
	fjac[ 53][ 40] = kx[10];
	fjac[ 53][ 41] = -kx[11];
	fjac[ 53][ 49] = kp[1];
	fjac[ 54][  5] = -kpd[2];
	fjac[ 54][ 31] = kx[3];
	fjac[ 54][ 32] = -kx[4] - kpd[15];
	fjac[ 54][ 40] = -kx[10];
	fjac[ 54][ 41] = kx[11];
	fjac[ 55][  6] = -kpd[3];
	fjac[ 55][ 18] = -kx[8] - kpd[7];
	fjac[ 55][ 19] = -kpd[8];
	fjac[ 55][ 20] = -kpd[9];
	fjac[ 55][ 21] = -kx[7] - kpd[10];
	fjac[ 55][ 34] = kx[9];
	fjac[ 55][ 45] = kx[13];
	fjac[ 55][ 50] = kp[2];
	fjac[ 56][  7] = -kpd[4];
	fjac[ 56][ 18] = kx[8];
	fjac[ 56][ 21] = kx[7];
	fjac[ 56][ 22] = -4*kpd[11];
	fjac[ 56][ 34] = -kx[9] - kpd[17];
	fjac[ 56][ 35] = -kpd[20];
	fjac[ 56][ 36] = -kpd[21];
	fjac[ 56][ 45] = -kx[13];
	fjac[ 57][  8] = -kpd[5];
	fjac[ 57][ 21] = kx[7];
	fjac[ 57][ 23] = -kx[5] - kpd[12];
	fjac[ 57][ 24] = -kpd[13];
	fjac[ 57][ 33] = kx[6];
	fjac[ 57][ 34] = -kpd[17];
	fjac[ 57][ 39] = -kpd[24];
	fjac[ 57][ 44] = kx[12];
	fjac[ 57][ 51] = kp[3];
	fjac[ 58][  9] = -kpd[6];
	fjac[ 58][ 21] = -kx[7] - kpd[10];
	fjac[ 58][ 23] = kx[5];
	fjac[ 58][ 33] = -kx[6] - kpd[16];
	fjac[ 58][ 44] = -kx[12];
	fjac[ 59][ 29] = -kx[1];
	fjac[ 59][ 30] = kx[2];
	fjac[ 60][ 29] = kx[1];
	fjac[ 60][ 30] = -kx[2];
	fjac[ 61][ 16] = -kpd[18];
	fjac[ 61][ 38] = -kpd[23];
	fjac[ 61][ 39] = -kpd[24];
	fjac[ 61][ 42] = -kx[14];
	fjac[ 61][ 43] = kx[15];
	fjac[ 61][ 52] = kp[4];
	fjac[ 62][ 17] = -kpd[19];
	fjac[ 62][ 37] = -kpd[22];
	fjac[ 62][ 42] = kx[14];
	fjac[ 62][ 43] = -kx[15];
}
