#ifndef LIFE_H
#define LIFE_H 1

#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <sys/types.h>

/* 顼ؿ */
#include "logUtil.h"

/* NDFСؿ */
#include "ndf.h"

/* ե */
#define FILE_NUM	3
#define FILE_IN 	0
#define FILE_OUT	1
#define FILE_OUT2	2


/* Ƽﵬ */
#define MAX_SOLVER_NO 20	/* Сֹξ(åΤ) */
#define MAX_VAR_NUM 512		/* ѿκ󥵥 */
#define MAX_PARAM_KINDS 10	/* ѥ᡼μκ */
#define MAX_EVENT_NUM 50	/* ।٥Ȥκ */
#define MAX_P_SURVEY 5		/* ѥ᡼٥оݥѥ᡼κ */
#define MAX_LINE 512		/* ϥǡɤ߹߻κ */
#define	MAX_CDATA_NUM 11	/* ϥǡ1Ԥκǡ */
#define TINY 1.0E-30		/* ¿谷γƼ͡顼 */
#define INIT_FILE "initVal.txt"	/* ѥǡե̾ */
#define	CONSTANT_PLAYER	"constantPlayer"
#define MAX_P_GA 20


/* ǥե */
#define NR_TRIAL 20			/* Newton-Raphsonκ緫֤׻ */
#define NR_TOL_F 1.0E-12	/* Newton-Raphsonδؿ«Ƚ */
#define NR_TOL_X 1.0E-12	/* Newton-Raphsonβ«Ƚ */
#define NR_RATIO 1.1		/* θ */
#define NR_SENS_CW 0.001	/* ϡݴ٤ΤΥѥ᡼ʬ */
#define RK_EPS 1.0E-12		/* ŬRunge-KuttaãȽ */
#define Y_DEFAULT 1.0		/* ;άΥǥե */
#define NDF_RTOL 1.0E-12	/* NDFи */
#define NDF_ATOL 1.0E-6		/* NDFи */

/* Хѥޥ */
#ifdef	_HAVE_MAIN_ROUTINE_
#define	GLOBAL	/* blank */
#define	GLOBAL_VAL(v) = (v)
#else
#define	GLOBAL extern
#define	GLOBAL_VAL(v)	/* blank */
#endif

/*
 * ѥ᡼
 */
#include	"parameter.h"
	/* ȿΥѥ᡼˴ؤ빽¤ */
	typedef struct parameter {
		int     n_varNR;        /* ʬΥϢΩѿο */
		int     n_var;          /* ѿ */
		int     n_val[MAX_PARAM_NUM];
		double  val[MAX_PARAM_NUM][MAX_VAR_NUM];
	} Parameter;

	/* ѥ᡼ɤ߹Ѥι¤ */
	typedef struct {
		int		p_no;
		int		index;
		double	value;
	} start_val;

	/* ।٥ȳǼѹ¤ */
	typedef struct event {
		int		p_no;	/* ѥ᡼ֹ */
		int		index;	/* ǥå */
		double	time;	/*  */
		double	value;	/*  */
	} Event;

	/* ѥ᡼٥Ǽѹ¤ */
	typedef struct survey{
		int		p_no;	/* ѥ᡼ֹ */
		int		index;	/* ǥå */
		int		steps;	/* ƥå׿ */
		int		f_isArithmetic;	/* ѹ	/ */
		double	start_value;	/* ʡ͡ */
		double	change_value;	/*  */
	} Survey;

	/* GAѹ¤ */
	typedef struct lsga {
		int		p_no;	/* ѥ᡼ֹ */
		int		index;	/* ǥå */
		double	min_value;	/*ΰκǾ  */
		double	max_value;	/*	ΰκ */
	} Lsga;


	/* Х */
	GLOBAL int F_PSurvey GLOBAL_VAL(0);		/* ѥ᡼٥ON/OFFե饰 */
	GLOBAL int F_Parallel GLOBAL_VAL(0);	/* ׻ON/OFFե饰 */
	GLOBAL int F_Numerical_Jac GLOBAL_VAL(0);	/* ͥ䥳ӥON/OFFե饰 */
	GLOBAL int F_GA GLOBAL_VAL(0);				/* GA ON/OFFե饰 */
	GLOBAL Survey P_Survey[MAX_P_SURVEY];	/* ѥ᡼٥¤ */
	GLOBAL int P_SurveyNum GLOBAL_VAL(0);	/* ƱθĿ */
	GLOBAL Event Events[MAX_EVENT_NUM];		/* ।٥ȹ¤ */
	GLOBAL int EventsNum GLOBAL_VAL(0);		/* ƱθĿ */
	GLOBAL Lsga P_Ga[MAX_P_GA];				/* GAѹ¤ */
	GLOBAL int P_GaNum GLOBAL_VAL(0);		/* ƱθĿ */
	GLOBAL Parameter Param;		/* ѥ᡼¤Ρʥȡ */
	GLOBAL Parameter ParamP;	/* ѥ᡼¤Ρ */
	GLOBAL Parameter ParamT;	/* ѥ᡼¤Ρɸ */
	GLOBAL Parameter ParamB;	/* ѥ᡼¤Ρʥ١ */
	GLOBAL double GeneConc;		/* G-VALUE */
	GLOBAL int SolverNo;		/* Сֹ */
	GLOBAL FILE *Fp_out;		/* ϥեΥեݥ */
	GLOBAL int Nr_trial		GLOBAL_VAL(NR_TRIAL); 	/* Newton-Raphsonκ緫֤׻ */
	GLOBAL double Nr_tol_f	GLOBAL_VAL(NR_TOL_F); 	/* Newton-Raphsonδؿ«Ƚ */
	GLOBAL double Nr_tol_x	GLOBAL_VAL(NR_TOL_X); 	/* Newton-Raphsonβ«Ƚ */
	GLOBAL double Nr_ratio	GLOBAL_VAL(NR_RATIO); 	/* θ */
	GLOBAL double Nr_sens_cw 	GLOBAL_VAL(NR_SENS_CW);	/* ϡݴ٤ΤΥѥ᡼Ѳ */
	GLOBAL double Rk_eps	GLOBAL_VAL(RK_EPS); 	/* ŬRunge-KuttaȽ */
	GLOBAL double Y_default		GLOBAL_VAL(Y_DEFAULT); 		/* ;άΥǥե */
	GLOBAL double Ndf_rtol	GLOBAL_VAL(NDF_RTOL); 	/* NDFи */
	GLOBAL double Ndf_atol	GLOBAL_VAL(NDF_ATOL); 	/* NDFи */
	GLOBAL int StepNum;								/*  */
	GLOBAL double **SolutionMatrix;					/* β¸ѹ */

	/* եָƽдؿΥץȥ */
	int Set_data(double y[], double *t_start, double *t_end, double *h, double *dt_save,
			   	char **fname);
	int SolveDiffEqNormalRungeKutta(int nvar, double y[], double y_pre[],
			   	double *t, double *h, int f_event);
	int SolveDiffEqAdaptiveRungeKutta(int nvar, double y[], double y_pre[],
			   	double *t, double *h, double t_end, int f_event);
	int SetNRparam(double y[]);
	int CheckNRparam(double y[]);
	int Sensitivity(double y[], double y_pre[]);
	int SolveAlgebraicEq(double y[], double y_pre[]);
	int SolveSTDbyNR(double y[], double y_pre[]);
	void usr_fvec(double fvec[], double y[], double Gene, Parameter *p);
	void usr_fjac(double fjac[][MAX_VAR_NUM], double y[], double Gene, Parameter *p);
	int DoSolver(Parameter param_start, double h, double t_start, double t_end,
				   	double dt_save, double y_start[], double y[], double y_pre[]);
	char *GetCurrentTimeStr();

#endif /* !LIFE_H */
