#include <math.h>

#include "life.h"
#include "lsUsrFitness.h"

int LsUsrFitness(double **y, int num_row, int num_col, int ls_ret, double *fitness)
{
//        printf("num_row=%g\n",num_row);
	double point[4],kyoku[3];
        int i,j;

//        printf("enter LsUserFitness\n");
//        getchar();
        *fitness = 0;
        for(j=1;j<=3;j++)
                point[j]=0;
        for(j=1;j<=2;j++)
                kyoku[j]=0;

        if(ls_ret == -1){
                *fitness = -100;
                goto out;
        }
        for(i = 0; i < num_row; i++){
                point[1] = point[2];
                point[2] = point[3];
                point[3] =y[1][i];

                if((point[3] - point[2])/point[2] * (point[2] - point[1\
                        ])/point[1]<0 ) {
                        kyoku[1] = kyoku[2];
                        kyoku[2] = point[2];                           								               if(fabs(kyoku[1]-kyoku[2])>1.0 ) {
				*fitness += 1.0;                               								       }
                }

        }

  out:
//        printf("exit LsUserFitness\n");
        return 0;
}

void usr_fvec( double fvec[],double y[], double Gene, Parameter *p)
{
	double	*kx=p->val[1];
	double	*km=p->val[2];
	double	*kmd=p->val[3];
	double	*kp=p->val[4];
	double	*kpd=p->val[5];
	double	*Keq=p->val[6];
	double	*kother=p->val[7];
	double	*tr=p->val[8];
//	int i;

/*	printf("kx=%f\n",kx[2]);//0.27
	printf("km=%f\n",km[7]);//0.02
	printf("kmd=%f\n",kmd[7]);//0.1
	printf("kp=%f\n",kp[7]);//0.5
	printf("kpd=%f\n",kpd[24]);// 0.099684
	printf("Keq=%e\n",Keq[10]);//2.142422e+08
	printf("tr=%f\n",tr[1]);//0.24
	getchar();*/

	fvec[  1] = y[31]-y[1]-y[14]-y[15];
	fvec[  2] = y[32]-y[2]-y[14];
	fvec[  3] = y[33]-y[3]-y[15];
	fvec[  4] = y[34]-y[4]-y[16]-y[17];
	fvec[  5] = y[35]-y[5]-y[16]-y[17]-y[7]-y[19];
	fvec[  6] = y[36]-y[6]-y[17];
	fvec[  7] = y[37]-y[8]-y[18]-y[19]-y[20]-y[21]-y[22]-y[23];
	fvec[  8] = y[38]-y[9]-y[18]-y[19]-y[20]-y[21]-y[22]-y[23];
	fvec[  9] = y[39]-y[7]-y[19];
	fvec[ 10] = y[40]-y[10]-y[20];
	fvec[ 11] = y[41]-y[11]-y[21];
	fvec[ 12] = y[42]-y[12]-y[22]-y[23];
	fvec[ 13] = y[43]-y[13]-y[23];
	fvec[ 14] = y[14]-Keq[1]*y[1]*kother[1]*y[2];
	fvec[ 15] = y[15]-Keq[2]*y[1]*kother[1]*y[3];
	fvec[ 16] = y[16]-Keq[3]*y[4]*y[5];
	fvec[ 17] = y[17]-Keq[4]*y[6]*y[16];
	fvec[ 18] = y[18]-Keq[5]*y[8]*y[9];
	fvec[ 19] = y[19]-Keq[6]*y[18]*y[7];
	fvec[ 20] = y[20]-pow(Keq[7],10)*y[10]*pow(y[18],10);
	fvec[ 21] = y[21]-pow(Keq[8],10)*y[11]*pow(y[18],10);
	fvec[ 22] = y[22]-Keq[9]*y[18]*y[12];
	fvec[ 23] = y[23]-pow(Keq[10],10)*y[13]*pow(y[22],10);
	fvec[ 24] = +km[5]*(y[20]/1e-9)*kother[2]-kmd[1]*y[24];
	fvec[ 25] = +km[6]*(y[21]/1e-9)*kother[3]-kmd[2]*y[25];
	fvec[ 26] = +km[7]*(1.0-(y[23]/1e-9))*kother[4]-kmd[3]*y[26];
	fvec[ 27] = +km[1]*kother[5]-kmd[4]*y[27];
	fvec[ 28] = +km[2]*kother[6]-kmd[5]*y[28];
	fvec[ 29] = +km[3]*kother[7]-kmd[6]*y[29];
	fvec[ 30] = +km[4]*kother[8]-kmd[7]*y[30];
	fvec[ 31] = -kpd[8]*y[14]-kpd[9]*y[15]+kp[5]*y[28]-kpd[5]*y[1];
	fvec[ 32] = -kx[1]*y[14]-kpd[8]*y[14]+kp[1]*y[24]-kpd[1]*y[2];
	fvec[ 33] = -kx[2]*y[15]-kpd[17]*y[15]+kx[1]*y[14]-kpd[19]*y[3];
	fvec[ 34] = -kpd[21]*y[16]+kx[2]*y[15]-kpd[20]*y[4]-kpd[18]*y[17]-tr[1]*y[17];
	fvec[ 35] = -kpd[13]*y[16]+kp[2]*y[25]-kpd[2]*y[5]-kpd[10]*y[17]-tr[1]*y[17];
	fvec[ 36] = -kpd[10]*y[17]+kp[6]*y[29]-kpd[6]*y[6];
	fvec[ 37] = -kpd[11]*y[18]+kp[3]*y[26]-kpd[3]*y[8]-kpd[12]*y[19]-kpd[14]*y[20]-kpd[15]*y[21]-kpd[24]*y[22]-kpd[16]*y[23];
	fvec[ 38] = -kpd[11]*y[18]+kp[4]*y[27]-kpd[4]*y[9]-kpd[12]*y[19]-kpd[14]*y[20]-kpd[15]*y[21]-kpd[24]*y[22]-kpd[16]*y[23];
	fvec[ 39] = -kpd[23]*y[19]-kpd[22]*y[7]+tr[1]*y[17];
	fvec[ 40] = 0;
	fvec[ 41] = 0;
	fvec[ 42] = -kpd[24]*y[22]+kp[7]*y[30]-kpd[7]*y[12]-kpd[16]*y[23];
	fvec[ 43] = 0;
}

void usr_fjac(double  fjac[][MAX_VAR_NUM], double y[], double Gene, Parameter *p)
{
	
	double	*kx=p->val[1];
	double	*km=p->val[2];
	double	*kmd=p->val[3];
	double	*kp=p->val[4];
	double	*kpd=p->val[5];
	double	*Keq=p->val[6];
	double	*kother=p->val[7];
	double	*tr=p->val[8];

	/*	printf("kx=%f\n",kx[2]);//0.27
	printf("km=%f\n",km[7]);//0.02
	printf("kmd=%f\n",kmd[7]);//0.1
	printf("kp=%f\n",kp[7]);//0.5
	printf("kpd=%f\n",kpd[24]);// 0.099684
	printf("Keq=%e\n",Keq[10]);//2.142422e+08
	printf("tr=%f\n",tr[1]);//0.24
	getchar();*/

	fjac[  1][  1] = -1;
	fjac[  1][ 14] = -1;
	fjac[  1][ 15] = -1;
	fjac[  1][ 31] = 1;
	fjac[  2][  2] = -1;
	fjac[  2][ 14] = -1;
	fjac[  2][ 32] = 1;
	fjac[  3][  3] = -1;
	fjac[  3][ 15] = -1;
	fjac[  3][ 33] = 1;
	fjac[  4][  4] = -1;
	fjac[  4][ 16] = -1;
	fjac[  4][ 17] = -1;
	fjac[  4][ 34] = 1;
	fjac[  5][  5] = -1;
	fjac[  5][  7] = -1;
	fjac[  5][ 16] = -1;
	fjac[  5][ 17] = -1;
	fjac[  5][ 19] = -1;
	fjac[  5][ 35] = 1;
	fjac[  6][  6] = -1;
	fjac[  6][ 17] = -1;
	fjac[  6][ 36] = 1;
	fjac[  7][  8] = -1;
	fjac[  7][ 18] = -1;
	fjac[  7][ 19] = -1;
	fjac[  7][ 20] = -1;
	fjac[  7][ 21] = -1;
	fjac[  7][ 22] = -1;
	fjac[  7][ 23] = -1;
	fjac[  7][ 37] = 1;
	fjac[  8][  9] = -1;
	fjac[  8][ 18] = -1;
	fjac[  8][ 19] = -1;
	fjac[  8][ 20] = -1;
	fjac[  8][ 21] = -1;
	fjac[  8][ 22] = -1;
	fjac[  8][ 23] = -1;
	fjac[  8][ 38] = 1;
	fjac[  9][  7] = -1;
	fjac[  9][ 19] = -1;
	fjac[  9][ 39] = 1;
	fjac[ 10][ 10] = -1;
	fjac[ 10][ 20] = -1;
	fjac[ 10][ 40] = 1;
	fjac[ 11][ 11] = -1;
	fjac[ 11][ 21] = -1;
	fjac[ 11][ 41] = 1;
	fjac[ 12][ 12] = -1;
	fjac[ 12][ 22] = -1;
	fjac[ 12][ 23] = -1;
	fjac[ 12][ 42] = 1;
	fjac[ 13][ 13] = -1;
	fjac[ 13][ 23] = -1;
	fjac[ 13][ 43] = 1;
	fjac[ 14][  1] = -Keq[1]*kother[1]*y[2];
	fjac[ 14][  2] = -Keq[1]*y[1]*kother[1];
	fjac[ 14][ 14] = 1;
	fjac[ 15][  1] = -Keq[2]*kother[1]*y[3];
	fjac[ 15][  3] = -Keq[2]*y[1]*kother[1];
	fjac[ 15][ 15] = 1;
	fjac[ 16][  4] = -Keq[3]*y[5];
	fjac[ 16][  5] = -Keq[3]*y[4];
	fjac[ 16][ 16] = 1;
	fjac[ 17][  6] = -Keq[4]*y[16];
	fjac[ 17][ 16] = -Keq[4]*y[6];
	fjac[ 17][ 17] = 1;
	fjac[ 18][  8] = -Keq[5]*y[9];
	fjac[ 18][  9] = -Keq[5]*y[8];
	fjac[ 18][ 18] = 1;
	fjac[ 19][  7] = -Keq[6]*y[18];
	fjac[ 19][ 18] = -Keq[6]*y[7];
	fjac[ 19][ 19] = 1;
	fjac[ 20][ 10] = -pow(Keq[7],10)*pow(y[18],10);
	fjac[ 20][ 18] = -10*pow(Keq[7],10)*y[10]*pow(y[18],9);
	fjac[ 20][ 20] = 1;
	fjac[ 21][ 11] = -pow(Keq[8],10)*pow(y[18],10);
	fjac[ 21][ 18] = -10*pow(Keq[8],10)*y[11]*pow(y[18],9);
	fjac[ 21][ 21] = 1;
	fjac[ 22][ 12] = -Keq[9]*y[18];
	fjac[ 22][ 18] = -Keq[9]*y[12];
	fjac[ 22][ 22] = 1;
	fjac[ 23][ 13] = -pow(Keq[10],10)*pow(y[22],10);
	fjac[ 23][ 22] = -10*pow(Keq[10],10)*y[13]*pow(y[22],9);
	fjac[ 23][ 23] = 1;
	fjac[ 24][ 20] = .1e10*km[5]*kother[2];
	fjac[ 24][ 24] = -kmd[1];
	fjac[ 25][ 21] = .1e10*km[6]*kother[3];
	fjac[ 25][ 25] = -kmd[2];
	fjac[ 26][ 23] = -.1e10*km[7]*kother[4];
	fjac[ 26][ 26] = -kmd[3];
	fjac[ 27][ 27] = -kmd[4];
	fjac[ 28][ 28] = -kmd[5];
	fjac[ 29][ 29] = -kmd[6];
	fjac[ 30][ 30] = -kmd[7];
	fjac[ 31][  1] = -kpd[5];
	fjac[ 31][ 14] = -kpd[8];
	fjac[ 31][ 15] = -kpd[9];
	fjac[ 31][ 28] = kp[5];
	fjac[ 32][  2] = -kpd[1];
	fjac[ 32][ 14] = -kx[1]-kpd[8];
	fjac[ 32][ 24] = kp[1];
	fjac[ 33][  3] = -kpd[19];
	fjac[ 33][ 14] = kx[1];
	fjac[ 33][ 15] = -kx[2]-kpd[17];
	fjac[ 34][  4] = -kpd[20];
	fjac[ 34][ 15] = kx[2];
	fjac[ 34][ 16] = -kpd[21];
	fjac[ 34][ 17] = -kpd[18]-tr[1];
	fjac[ 35][  5] = -kpd[2];
	fjac[ 35][ 16] = -kpd[13];
	fjac[ 35][ 17] = -kpd[10]-tr[1];
	fjac[ 35][ 25] = kp[2];
	fjac[ 36][  6] = -kpd[6];
	fjac[ 36][ 17] = -kpd[10];
	fjac[ 36][ 29] = kp[6];
	fjac[ 37][  8] = -kpd[3];
	fjac[ 37][ 18] = -kpd[11];
	fjac[ 37][ 19] = -kpd[12];
	fjac[ 37][ 20] = -kpd[14];
	fjac[ 37][ 21] = -kpd[15];
	fjac[ 37][ 22] = -kpd[24];
	fjac[ 37][ 23] = -kpd[16];
	fjac[ 37][ 26] = kp[3];
	fjac[ 38][  9] = -kpd[4];
	fjac[ 38][ 18] = -kpd[11];
	fjac[ 38][ 19] = -kpd[12];
	fjac[ 38][ 20] = -kpd[14];
	fjac[ 38][ 21] = -kpd[15];
	fjac[ 38][ 22] = -kpd[24];
	fjac[ 38][ 23] = -kpd[16];
	fjac[ 38][ 27] = kp[4];
	fjac[ 39][  7] = -kpd[22];
	fjac[ 39][ 17] = tr[1];
	fjac[ 39][ 19] = -kpd[23];
	fjac[ 42][ 12] = -kpd[7];
	fjac[ 42][ 22] = -kpd[24];
	fjac[ 42][ 23] = -kpd[16];
	fjac[ 42][ 30] = kp[7];
}
