#ifndef _NDF_H_
#define _NDF_H_

#define NDF_EPSILON	2.2204460492503131E-16

/*
 * Ƹץѥƥ
 * ʬƥåο
 * e(i) <= max(rel * abs(y(i)), abs)
 * norm(e) <= max(rel * norm(y), abs)
 */
typedef struct _ndf_tolerance {
	double	rel;		/* еƸ	*/
	double	abs;		/* еƸ	*/
	int	normctrl;	/* Υ	*/
	int	positive;	/* 	*/
} ndf_tolerance_t;

/* for normctl & positive */
#define ON	1
#define OFF	0

/*
 * 䥳ӥץѥƥ
 * ξ硧	jfunc == NULL
 * 󤬴ؿξ硧	jconst== NULL
 */
typedef struct _ndf_jacobian {
	double	*jconst;			/* 䥳ӥ	*/
	int (*jfunc)(double t, double *y, double *j);	/* 䥳ӥؿ */
} ndf_jacobian_t;

/*
 * ̹ץѥƥ
 * ξ硧	mfunc == NULL
 * 󤬴ؿξ硧	mconst== NULL
 * ̵̷ʽۡ	M(t0, y0)y'(t0) = f(t0, y0)  y'(t0)
 */
typedef struct _ndf_dae {
	double	*mconst;			/* ̹		*/
	int (*mfunc)(double t, double *y, double *m);	/* ̹ؿ	*/
	int	ydepend;			/* ̹ y ¸	*/
	int	singular;			/* ̹§	*/
	double	*initslope;			/* ̵̷ʽ	*/
} ndf_dae_t;

/* for ydepend */
#define	NONE	0
#define	WEAK	1
#define	STRONG	2

/* for singular */
#define	YES	0
#define	NO	1
#define	MAYBE	2


/*
 * ƥåץץѥƥ
 */
typedef struct _ndf_step {
	double	maxsize;	/* ƥåץξ	*/
	double	initstep;	/* ƥåץ	*/
} ndf_step_t;

/*
 * BDFץѥƥ
 */
typedef struct _ndf_bdf {
	int	order;		/* BDF(NDF)μ(=1,2,...,5)	*/
	int	isbdf;		/* BDF / NDF (=on/off)		*/
} ndf_bdf_t;

/*
 * NDF¹ԥץ
 */
typedef struct _ndf_option {
	ndf_tolerance_t	tol;	/* Ƹץѥƥ		*/
	ndf_jacobian_t	jac;	/* 䥳ӥץѥƥ	*/
	ndf_dae_t	dae;	/* ̹ץѥƥ		*/
	ndf_step_t	step;	/* ƥåץץѥƥ	*/
	ndf_bdf_t	bdf;	/* BDFץѥƥ		*/
} ndf_option_t;


/*
 * NDF¹Ծ
 */
typedef struct _ndf_status {
	int	nsteps;		/* ƥåײ		*/
	int	nfailed;	/* Ԥ			*/
	int	nfevals;	/* ODEؿ f(t, y) Υ	*/
	int	npds;		/* df/dy 줿	*/
	int	ndecomps;	/* LUʬβ			*/
	int	nsolves;	/* ƥβο		*/
} ndf_status_t;

/*
 * 
 */
typedef struct _ndf_input {
	int	t0num;		/* 	*/
	double	*t0;		/* 			*/
	int	y0num;		/* ϢΩο	*/
	double	*y0;		/* 		*/
} ndf_input_t;

/*
 * 
 */
typedef struct _ndf_solution {
	int	tnum;		/* λ	*/
	double	*tt;		/* λ		*/
	double	*yy;		/* 			*/
} ndf_solution_t;


extern void ndf_init(ndf_option_t *option);
extern int ndf_solve(ndf_input_t *in, ndf_solution_t *sol, int (*odefunc)(double t, double *y, double *f), ndf_option_t *option, ndf_status_t *stats);
extern void ndf_term(ndf_solution_t *sol);



#endif /* _NDF_H_ */
