#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>

#include "logUtil.h"
#include "pdiff.h"


#define MAX_FNAME 30
#define BLOCK_NUM 8
#define BUFFSIZE 65536
#define PARAM_NULL -9.999E-99	/* DAEեΥǡ̵ */

/* ϥե */
#define FILE_NUM	6
#define FILE_D	0	/* DAEե() */
#define FILE_F	1	/* 桼ؿե() */
#define FILE_P	2	/* ѥ᡼ե() */
#define FILE_T	3	/* Fluxե() */
#define FILE_G	4	/* GHpreե() */
#define FILE_S	5	/* S-system桼ؿե() */

/* ƥݥե̾ */
#define FNAME_HEAD	"head.tmp"
#define FNAME_USEDP	"usedp.tmp"
#define FNAME_CONST	"const.tmp"
#define FNAME_VAR	"var.tmp"
#define FNAME_MID	"mid.tmp"
#define FNAME_AEQ	"aeq.tmp"
#define FNAME_DEQ	"deq.tmp"
#define FNAME_PARAM	"param.tmp"
#define FNAME_SV	"s_fvec.tmp"
#define FNAME_SJ	"s_fjac.tmp"
#define FNAME_TMP	"tmp.tmp"

/* ѿΥ٥ */
#define CONSTANT_PLAYER	"constantPlayer"

/* ѿǼn_var) */
typedef struct _variable {
	int		index;
	char	*tag;		/* ʪ̾ */
	double	val;
	int		f_isX;		/* x or y ե饰 */
	int		f_isUsed;	/* orԻѥե饰 */
} Variable_T;

/* ̥ѥ᡼Ǽʳƥѥ᡼κ祤ǥå */
typedef struct _parameter {
	char	*tag;		/* ƥ */
	double	val;
	int		f_isUsed;	/* orԻѥե饰 */
} Parameter_T;

/* ऴȥѥ᡼ǡǼʥѥ᡼+1 */
typedef struct _parambase {
	char		*label;		/* kakb  */
	int			max_index;	/* 祤ǥå */
	int			f_isUsed;	/* orԻѥե饰 */
	Parameter_T	*param;		/* ParameterؤΥݥ */
} ParamBase_T;

/* n_mid or n_varX+n_varY) */
typedef struct _expression {
	int		f_isXorT;	/* Xѿ or Totalμ ξtrue */
	char	*name;		/* ɽξϺչ(٥) */
	char	*expr;
	Node_T	*root;
} Expression_T;

/*  */
typedef struct _eqsystem {
	int				n_var;			/* ѿ */
	int				n_varX;			/* x ѿο */
	int				n_varY;			/* y ѿο */
	int				n_const;		/* Ͽ줿ο */
	int				n_mid;			/* ɽο */
	int				n_equation;			/* ο(ޤɽ) */
	int				n_param;		/* ѥ᡼μ(ʬ+1) */
	Variable_T		*var;			/* ѿؤΥݥ */
	Expression_T	*mid;			/* ɽؤΥݥ */
	Expression_T	*equation;		/* ؤΥݥ */
	ParamBase_T		*param_base;	/* ParamBaseؤΥݥ */
} EqSystem_T;

extern int Read_data(EqSystem_T *mySystem, char **fname);
extern int Divide_variable(char *str_var, char *str_name, char *str_idx);
extern int FindParamBaseAddr(char *target);
extern void DbgPrintEqSystem();
extern int Make_diff(Node_T *my_node, char *target, int f_isCType);
extern int Make_node (Node_T **root, char *expr);
extern void Del_tree (Node_T *my_node);
extern int Set_expr(Node_T *root, int f_isCType);
extern Node_T *Seek_root(Node_T *my_node);
extern int Trim_tail(char *line);
extern int Write_usrfunc(EqSystem_T *mySystem, char **fname, int f_isCType);
extern int Write_paramFile(EqSystem_T *mySystem, char **fname);
extern int Write_usage(EqSystem_T *mySystem, char **fname);
extern int Write_flux(EqSystem_T *mySystem, char **fname, int f_isCType);
extern int Write_header(FILE *fp_out, int f_isCFunc);
extern void Write_param_label(ParamBase_T *param_base, int n_param, FILE *fp_out);
extern int Set_Ssystem(EqSystem_T *mySystem, char **fname);

extern EqSystem_T EQ_SYSTEM;
