/* ################ output.cpp #################################################
 *
 *
 *
 */
#include "checkdae.h"

static char *checkCcomment(char *str);

/*---------------------- Write_usrfunc -------------------------------------
 * 桼ؿν񤭽Фf_isCTypeϰĤƤ롣
 */
int
Write_usrfunc(EqSystem_T *mySystem, char **fname, int f_isCType)
{
	int i, j, n_equation;
	char target[BUFFSIZE];
	FILE *fp_out;

	n_equation = mySystem->n_equation;

	if((fp_out = fopen(fname[FILE_F], "w")) == NULL){
		log_sys("#  Cannot open %s\n", fname[FILE_F]);
		goto err;
	}

	if (Write_header(fp_out, f_isCType)) goto err;

	fprintf(fp_out,"\n#include \"life.h\"\n\n");
	fprintf(fp_out,"void usr_fvec(double fvec[], double y[], ");
	fprintf(fp_out,"double Gene, Parameter *p)\n{\n");

	/* ѥѥ᡼٥ν񤭽Ф*/
	Write_param_label(mySystem->param_base, mySystem->n_param, fp_out);

	fprintf(fp_out,"\n");

	/* fvecν񤭽Ф */
	for (i=0; i<n_equation; i++) {
		fprintf(fp_out, "\tfvec[%3d] = %s;\n", i+1,
					   	mySystem->equation[i].root->expr);
	}

	fprintf(fp_out,"}\n\n");

	fprintf(fp_out,"void usr_fjac(double fjac[][MAX_VAR_NUM], double y[], ");
	fprintf(fp_out,"double Gene, Parameter *p)\n{\n");

	/* ѥѥ᡼٥ν񤭽Ф*/
	Write_param_label(mySystem->param_base, mySystem->n_param, fp_out);

	fprintf(fp_out,"\n");

	/* fjacν񤭽Ф */
	for (i=0; i<n_equation; i++) {
		for (j=0; j<mySystem->n_varX + mySystem->n_varY; j++) {
			sprintf(target, "y[%d]", j+1);
			if (strstr(mySystem->equation[i].root->expr, target) == 0) continue;
			if (Make_diff(mySystem->equation[i].root, target, f_isCType)) goto err;
			if (strlen(mySystem->equation[i].root->diff) == 0) continue;
			fprintf(fp_out, "\tfjac[%3d][%3d] = %s;\n", i+1, j+1,
						   	mySystem->equation[i].root->diff);
		}
	}

	fprintf(fp_out,"}\n");

	fclose(fp_out); fp_out = NULL;

	return 0;

err:
	log_sys("## Error in Write_usrfunc.\n");
	if (fp_out != NULL) fclose(fp_out);
	return -1;
}

/*---------------------- Write_paramFile -------------------------------------
 * ѥ᡼եν񤭽Ф
 */
int
Write_paramFile(EqSystem_T *mySystem, char **fname)
{
	int i, j, n_var, n_varX, n_varY, n_param;
	char str_val[BUFFSIZE];
	double val;
	FILE *fp_out;

	n_var = mySystem->n_var;
	n_varX = mySystem->n_varX;
	n_varY = mySystem->n_varY;
	n_param = mySystem->n_param;

	if((fp_out = fopen(fname[FILE_P], "w")) == NULL){
		log_sys("#  Cannot open %s\n", fname[FILE_P]);
		goto err;
	}

	fprintf(fp_out,"##### Model ################\n");
	if (Write_header(fp_out, false)) goto err;
	fprintf(fp_out,"N_VAR   ;%4d; # num of variables(all)\n", n_varX+n_varY);
	fprintf(fp_out,"N_ALGEBR;%4d; # num of variables(Algebraic Eq)\n", n_varX);

	/* ͤν񤭽Ф */
	fprintf(fp_out,"\n#Y_START ; index; initial_value; tag #comment\n");
	for (i=0; i<n_var; i++) {
		if (mySystem->var[i].f_isUsed == 0) continue;
		val = mySystem->var[i].val;
		if (val >= 0.0) {	/* ͤ */
			sprintf(str_val, "%12.4e", val);
		} else {	/* ͤåȤƤʤ */
			sprintf(str_val, "%12s", " ");
		}
			fprintf(fp_out,"Y_START ;%4d;%s;  %s\t#\n",
						   mySystem->var[i].index, str_val, mySystem->var[i].tag);
	}

	/* ѥ᡼ν񤭽Ф */
	fprintf(fp_out,"\n#PARAM;name;index;val;val_start;num_survey;D/R/S;change-val;GA_min;GA_max;tag #comment\n");
	for (i=0; i<n_param; i++) {
		if (mySystem->param_base[i].f_isUsed == 0) continue;
		for (j=0; j<mySystem->param_base[i].max_index; j++) {
			if (mySystem->param_base[i].param[j].f_isUsed) {
				val = mySystem->param_base[i].param[j].val;
				if (val != PARAM_NULL) {	/* ͤ */
					sprintf(str_val, "%12.4g", val);
				} else {
					sprintf(str_val, "%12s", " ");
				}
				fprintf(fp_out,"PARAM   ;%-14s;%4d;%s;;0;D;;;; %s\t#\n",
					mySystem->param_base[i].label, j+1, str_val,
					mySystem->param_base[i].param[j].tag);
			} else {
				fprintf(fp_out,"PARAM   ;%-14s;%4d;%12s;;0;D;;;; %s\t# Not Used!!\n",
					mySystem->param_base[i].label, j+1, "1",
					mySystem->param_base[i].param[j].tag);
			}
		}
	}
	fprintf(fp_out,"\n#T_EVENT ; name; index; time; value; #comment\n\n");

	fprintf(fp_out,"\n######## Don't edit the following lines. ######\n");
	for (i=0; i<n_param; i++) {
		if (mySystem->param_base[i].f_isUsed == 0) continue;
		fprintf(fp_out,"PARAM_NAME ;%-15s #\n", mySystem->param_base[i].label);
	}

	fclose(fp_out); fp_out = NULL;

	return 0;

err:
	log_sys("## Error in Write_paramFile.\n");
	if (fp_out != NULL) fclose(fp_out);
	return -1;
}

#if 0
/*---------------------- Write_usage -------------------------------------
 * Usage եν񤭽Ф
 */
int
Write_usage(EqSystem_T *mySystem, char **fname)
{
	int i, j, n_var, n_varX, n_varY, n_param, f_done=false;
	char str_val[BUFFSIZE];
	double val;
	FILE *fp_out;

	n_var = mySystem->n_var;
	n_varX = mySystem->n_varX;
	n_varY = mySystem->n_varY;
	n_param = mySystem->n_param;

	if((fp_out = fopen(fname[FILE_U], "w")) == NULL){
		log_sys("#  Cannot open %s\n", fname[FILE_U]);
		goto err;
	}

	fprintf(fp_out,"##### Model ################\n");
	if (Write_header(fp_out, false)) goto err;

	/* ѿν񤭽Ф */
	fprintf(fp_out,"\n## Constant Players ##\n");
	if(mySystem->param_base[0].f_isUsed) {
		for (i=0; i<mySystem->param_base[0].max_index; i++) {
			val = mySystem->param_base[0].param[i].val;
			if (val >= 0.0) {	/* ͤ */
				sprintf(str_val, "%12g", val);
			} else {
				sprintf(str_val, "%12s", " ");
			}
			fprintf(fp_out, "constantPlayer[%3d] = %s; %s\n", i+1, str_val,
							mySystem->param_base[0].param[i].tag);
		}
	} else {
		fprintf(fp_out,"\tThere is no constantPlayer.\n");
	}

	/* ѿν񤭽Ф */
	fprintf(fp_out,"\n## Variables ##\n");
	if (n_varX > 0) {
		fprintf(fp_out,"# Algebraic Equation : %d #\n", n_varX);
	} else {
		fprintf(fp_out,"# Differential Equation : %d #\n", n_varY);
	}
	for (i=0; i<n_var; i++) {
		if (mySystem->var[i].f_isUsed == 0) continue;
		if (!mySystem->var[i].f_isX && n_varX > 0 && !f_done) {
			fprintf(fp_out,"# Differential Equation : %d #\n", n_varY);
			f_done = true;
		}
		val = mySystem->var[i].val;
		if (val >= 0.0) {	/* ͤ */
			sprintf(str_val, "%g", val);
		} else {	/* ͤåȤƤʤ */
			sprintf(str_val, "%s", "");
		}
		fprintf(fp_out,"%c[%s]\t= %s;\n", mySystem->var[i].f_isX ? 'x' : 'y',
						   mySystem->var[i].tag, str_val);
	}

	/* ѥ᡼ν񤭽Ф */
	fprintf(fp_out,"\n## Parameters ##");
	for (i=0; i<n_param; i++) {
		if (mySystem->param_base[i].f_isUsed == 0) continue;
		fprintf(fp_out,"\n### %s ###\n", mySystem->param_base[i].label);
		for (j=0; j<mySystem->param_base[i].max_index; j++) {
			if (mySystem->param_base[i].param[j].f_isUsed) {
				val = mySystem->param_base[i].param[j].val;
				if (val >= 0.0) {	/* ͤ */
					sprintf(str_val, "%12g", val);
				} else {
					sprintf(str_val, "%12s", " ");
				}
				fprintf(fp_out,"%s[%3d] = %s; %s\n",
					mySystem->param_base[i].label, j+1, str_val,
					mySystem->param_base[i].param[j].tag);
			} else {
				fprintf(fp_out,"%s[%3d] = %s; %s Not Used!!\n",
					mySystem->param_base[i].label, j+1, str_val,
					mySystem->param_base[i].param[j].tag);
			}
		}
	}

	fclose(fp_out); fp_out = NULL;

	return 0;

err:
	log_sys("## Error in Write_usage.\n");
	if (fp_out != NULL) fclose(fp_out);
	return -1;
}
#endif

/*---------------------- Write_flux -------------------------------------
 * 桼ؿν񤭽Фf_isCTypeϰĤƤ롣
 */
int
Write_flux(EqSystem_T *mySystem, char **fname, int f_isCType)
{
	int i, cnt_t, cnt_f, n_mid;
	char str_label[BUFFSIZE];
	FILE *fp_out;

	n_mid = mySystem->n_mid;

	if((fp_out = fopen(fname[FILE_T], "w")) == NULL){
		log_sys("#  Cannot open %s\n", fname[FILE_T]);
		goto err;
	}

	if (Write_header(fp_out, f_isCType)) goto err;

	fprintf(fp_out,"\n#include \"life.h\"\n\n");
	fprintf(fp_out,"void usr_flux(double total[], double flux[], double y[], ");
	fprintf(fp_out,"double Gene, Parameter *p)\n{\n");

	/* ѥѥ᡼٥ν񤭽Ф*/
	Write_param_label(mySystem->param_base, mySystem->n_param, fp_out);

	fprintf(fp_out,"\n");

	/* ν񤭽Ф */
	for (i=0, cnt_t=0, cnt_f=0; i<n_mid; i++) {
		if (mySystem->mid[i].f_isXorT) {
			cnt_t++;
			strcpy(str_label, "total");
		} else {
			cnt_f++;
			strcpy(str_label, "flux");
		}
		fprintf(fp_out, "\t%s[%3d] = %s; /* %s */\n", str_label, i+1,
					   	mySystem->mid[i].root->expr, mySystem->mid[i].name);
	}

	if (cnt_t == 0) fprintf(fp_out,"\n\t/* No Total expression. */\n");
	if (cnt_f == 0) fprintf(fp_out,"\n\t/* No Flux expression. */\n");
	
	fprintf(fp_out,"}\n\n");

	fclose(fp_out); fp_out = NULL;

	return 0;

err:
	log_sys("## Error in Write_flux.\n");
	if (fp_out != NULL) fclose(fp_out);
	return -1;
}

/*---------------------- Write_header -------------------------------------
 * إåν񤭽Ф
 * f_isCFunc=true  : C쥿פΥ
 * f_isCFunc=false : '#'ǤϤ륳
 */
int
Write_header(FILE *fp_out, int f_isCFunc)
{
	char tline[BUFFSIZE], *aline;
	FILE *fp_in;


	if (f_isCFunc) fprintf(fp_out, "/*\n");

	/* header ν񤭽Ф */
	if((fp_in = fopen(FNAME_HEAD, "r")) == NULL){
		log_sys("#  Cannot open %s\n", FNAME_HEAD);
		goto err;
	}
	while (fgets(tline, sizeof tline, fp_in)) {
		if (f_isCFunc) {
			aline = checkCcomment(tline);
			if (aline) fprintf(fp_out, " * %s", aline);
			if (aline) free((void *)aline);
		} else {
			fprintf(fp_out, "# %s", tline);
		}
	}

	if (f_isCFunc) fprintf(fp_out, " */\n");

	fclose(fp_in); fp_in = NULL;

	return 0;

err:
	if (fp_in != NULL) fclose(fp_in);
	return -1;
}

/*---------------------- Write_param_label -------------------------------------
 * 桼ؿѥѥ᡼٥񤭽Ф
 */
void
Write_param_label(ParamBase_T *param_base, int n_param, FILE *fp_out)
{
	int i, cnt;

	for (i=0, cnt=0; i<n_param; i++) {
		if (param_base[i].f_isUsed == 0) continue;
		fprintf(fp_out, "\tdouble *%s\t= p->val[%d];\n",
					   	param_base[i].label, ++cnt);
	}
}

/*---------------- checkCcomment ------------------------------------------
 *	ʸC쥿פΥȤγϵڤӽλʸõ֤˲ɲä롣
 *	ʸΰݤΥݥ󥿡֤ΤǥγϸƤӽФ¦ǹԤ
 */
static char
*checkCcomment(char *str)
{
	char *cpt;
	char *cpa, pre='0';
	int cnt = 0;
	char aline[BUFFSIZE];

	cpt = str;
	cpa = aline;
	for (; *cpt; ) {
		if ((*cpt == '/' && pre == '*') || (*cpt == '*' && pre == '/')) {
			*(cpa++) = '_';
			cnt++;
			*(cpa++) = *(cpt++);
			cnt++;
		} else {
			pre = *cpt;
			*(cpa++) = *(cpt++);
			cnt++;
		}
		if (cnt > BUFFSIZE-2) goto err;
	}
	
	*cpa = '\0';

	return strdup(aline);

err:
	log_sys("#  Too long!! leng=%d, Max=%d\n", cnt, BUFFSIZE);
	log_sys("## Error in checkCcomment.\n");
	return NULL;
}
