//  ƼեMathFileList.txt˽äXMLե礹롣
//	
//	integratedata -IMathFileList.txt -ODBMathModel.xml [-d*]
//
//	MathFileList.txt 礹٤ե̾ȤΥե뤬
//	XMLեǤ뤫ݤΥե饰1ԤȤ礹եο¤٤롣
//
//		flag,file-name	:	"%d,%s\n"
//
//	ꥹȤˤե뤬ʤñ礷ʤ
//	ƥեϤॿ̾ϥե̾(ĥҤϾʤ)Ȥ롣
//	°ͤȤtype="xml" or type="txt" γĥҤꤹ롣
//
#include <stdio.h>
#include <string.h>

// 顼ؿ
#include "logUtil.h"

#define BUFFSIZE 65536

static int name_split( char *name, char *base, char *suffix);

//----------------main------------------------------------------
//
int main(int argc, char *argv[])
{
	int i, fcount=0, f_cnt = 0;
	char tline[BUFFSIZE];
	char fname_i[FILENAME_MAX];
	char fname_o[FILENAME_MAX];
	char fname_t[FILENAME_MAX];
	char name_base[FILENAME_MAX];
	char name_suffix[FILENAME_MAX];
	FILE *fp_i, *fp_o, *fp_t;
	
#ifdef DBG
	// open debug-log file.
	if(log_dbginit(argc, argv)) {
		printf("Cannot open dbgLog file!!");
		goto	err;
	}
#endif

	// open sys-log file.
	if(log_sysinit(argc, argv)) {
		printf("Cannot open sysLog file!!");
		goto	err;
	}

	// ץβ
	for (i = 0; i < argc; i++) {
		if (argv[i][0] == '-') {
			switch (argv[i][1]) {
			case 'I':
				fcount++;
				strcpy(fname_i, &argv[i][2]);
				break;
			case 'O':
				fcount++;
				strcpy(fname_o, &argv[i][2]);
				break;
			case 'd':
				break;
			default:
				log_sys("Invalid argument !!\n");
				goto	err;
			}
		}
	}
	if (fcount != 2) {
		log_sys("This program needs 2 input files. But now it has %d file(s).\n", fcount);
		goto	err;
	}

	// ϥե򥪡ץ󤹤
	if((fp_o = fopen(fname_o, "w")) == NULL){
		log_sys("Cannot open %s\n", fname_o);
		goto	err;
	}
	fprintf(fp_o, "<?xml version=\"1.0\" encoding=\"Shift_JIS\"?>\n");
	fprintf(fp_o, "<DBMathModel>\n");

	// ꥹȥե򥪡ץ󤹤
	if((fp_i = fopen(fname_i, "r")) == NULL){
		log_sys("Cannot open %s\n", fname_i);
		goto	err;
	}
	while(fgets(tline, sizeof tline, fp_i)) {
		sscanf(tline, "%s", fname_t);
		if((fp_t = fopen(fname_t, "r")) == NULL){
			log_sys("Cannot open %s\n", fname_t);
		} else {
			sscanf(fname_t, "%s.%s", name_base, name_suffix);
			if (name_split(fname_t, name_base, name_suffix)) {
				fprintf(fp_o, "<%s type=\"%s\">\n", name_base, name_suffix);
				fprintf(fp_o, "<!--\n");
				f_cnt++;
				while(fgets(tline, sizeof tline, fp_t)) {
					fprintf(fp_o, "\t");
					fprintf(fp_o, "%s", tline);
				}
				fprintf(fp_o, "\n-->\n");
				fprintf(fp_o, "</%s>\n", name_base);
				fclose(fp_t);
			} else {
				log_sys("Cannot read tag-name.\n");
				goto err;
			}
		}
	}
	fprintf(fp_o, "</DBMathModel>\n");
	fclose(fp_i);
	fclose(fp_o);

	if (f_cnt) {
		log_sys("Finish successfully!!\n");
	} else {
		log_sys("There is no datum for integration.\n");
		goto err;
	}

	return 0;

err:;
	log_sys("### ERROR!!\n");
	return -1;
}

//----------------- name_split -------------------------
//	ե̾(name) base  suffix ʬ򤷤֤
//	꥿ͤȤ base Ĺ֤
//
static int name_split(char *name, char *base, char *suffix)
{
	char *cp, *cpb, *cps;
	int flag = 0, n_cnt = 0;

	cp = name;
	cpb = base;
	cps = suffix;
	for (; *cp; ) {
		if (*cp == '\n' || *cp == '\0') {
			break;
		} else if (*cp =='.') {
			flag = 1;
			cp++;
		} else {
			if (flag) {
				*(cps++) = *(cp++);
			} else {
				n_cnt++;
				*(cpb++) = *(cp++);
			}
		}
	}
	*cpb = *cps = '\0';
	return n_cnt;
}

			
