/*
 * "R & B": Real-coded GAs & Bit-string GAs
 *
 * MPI module header file
 */
#ifndef _GA_MPI_H_
#define _GA_MPI_H_

#include <mpi.h>

#include "randb.h"
#include "logUtil.h"

/*
 * Macros
 */
/* send tag */
#define NORMAL_TAG		1
#define	FITNESS_ONLY	2
#define	END_TAG			3

/* MPI time information */
typedef struct infompitime {
	double	startTime;	/* Ȥ */
	double	tempTime;	/* ¸ */
} InfoMpiTime_T;



/*
 * Decralations of a function 
 */

/*-----
 * GetMpiProcInfoؿ
 * 	ޥ/졼֤Ȥ˻
 *	ΥץΥ󥯾
 */
extern int GetMpiProcInfo(InfoMpiProc_T *mpi_info);

/*-----
 * TypeParamStruct
 *      ޥե뤫ɤ߹ѥ᡼
 *      ۤ뤿ι¤
 */
extern int TypeParamStruct(GaParam_T *ga_param, MPI_Datatype *mpi_param);

/*-----
 * DistributeParamsؿ
 *	ޥΤ߻
 *	ե뤫ɤѥ᡼ƤΥ졼֤
 */
extern int DistributeParams(GaParam_T *ga_param, MPI_Datatype datatype);

/*-----
 * AcceptParamsؿ
 *	졼֤Τ߻
 *	ޥۤѥ᡼
 *	ѥ᡼¤GaParam_T򹹿
 */
extern int AcceptParams(GaParam_T *ga_param, MPI_Datatype datatype);

/*-----
 * DistributeVariableRegionؿ
 *      ޥΤ߻
 *      ޥե뤫ɤ߹
 *      ѿΰƤΥ졼֤
 */
extern int DistributeVariableRegion(GaParam_T *ga_param);

/*-----
 * AcceptVariableRegionؿ
 *      졼֤Τ߻
 *      ޥۤѿΰǼ
 */
extern int AcceptVariableRegion(GaParam_T *ga_param);

/*-----
 * TypeIslandStruct
 * 	åȤ줿ѥ᡼
 * 	MPI_Type_structˤꡢѤ
 * 	¤Τ
 */
extern int TypeIslandStruct(const GaParam_T *ga_param, GaIsland_T *island, MPI_Datatype *mpi_island);

/*-----
 * SendIslandؿ
 *	ޥ/졼֤Ȥ˻
 * 	ꤵ줿ꤵ줿ץ
 */
extern int SendIsland(GaIsland_T *island, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm); 
/*-----
 * RecvIslandؿ
 *	ޥ/졼֤Ȥ˻
 * 	1ǻꤵ줿Хåե˥ԡ
 */
extern int RecvIsland(GaIsland_T *buf, MPI_Datatype datatype, int src, int tag, MPI_Comm comm, MPI_Status *stat);

#endif /* _GA_MPI_H_ */

