/*
 *"R & B": Real-coded GAs & Bit-string GAs
 *
 * integrate module
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "logUtil.h"
#include "randb.h"
#include "utl_rand.h"
#include "utl_alloc.h"

/***********************
 * Public functions    *
 ***********************/

/*-----
 * IntegrateIslandsؿ
 *      DIGAΥ르ꥺ˱褤Ԥ
 *      ͡EXIT_NORMAL, EXIT_ERROR
 *      GaParam_T*(I), GaGene_T**(I/O)
 */
int IntegrateIslands(const GaParam_T *ga_param, GaIsland_T *islands)
{
	int 	i;
	int		island_id;
	int		gene_id;
	int		num_island;
	int		island_pop;
	int		rv  = EXIT_ERROR;
	GaIsland_T	temp_island;

#ifdef DBG
	DBGW(10, ("IntegrateIslands enter.\n"));
#endif /* DBG */

	num_island = ga_param->gaTypeParam.numIsland;
	island_pop = ga_param->gaTypeParam.islandPopulation;

	/* 0ܤ礹 */
	for(i = 0; i < island_pop; i++){
		if (i < num_island){
			temp_island.residents[i] = 
				islands[i].residents[islands[i].sortedIndex[0]];
		} else {
			island_id = GenIntRand(0, num_island);
			gene_id = GenIntRand(0, island_pop);
			temp_island.residents[i] 
				= islands[island_id].residents[islands[island_id].sortedIndex[gene_id]];
		}
	}

	memcpy(islands[0].residents, temp_island.residents, island_pop * sizeof(GaGene_T));

	SortByFitness(&(islands[0]));
	
	rv = EXIT_NORMAL;

#ifdef DBG
	DBGW(10, ("IntegrateIslands exit(0)\n"));
#endif /* DBG */

	return rv;
}


/*-----
 * AjustParamsAfterIntegrateؿ
 *      塤Ĵɬפʥѥ᡼Ĵ(1ˤ)
 *	͡EXIT_NORMAL
 *	GaParam_T*(O)
 */
int AjustParamsAfterIntegrate(GaParam_T *ga_param)
{
#ifdef DBG
	DBGW(10, ("AjustParamsAfterIntegrate enter.\n"));
#endif /* DBG */

	ga_param->gaTypeParam.numIsland = 1;

#ifdef DBG
	DBGW(10, ("AjustParamsAfterIntegrate exit(0)\n"));
#endif /* DBG */

	return EXIT_NORMAL;
}

