/*
"R & B": Real-coded GAs & Bit-string GAs
 
randb.h
 */

#ifndef _RANDB_H_
#define _RANDB_H_

#include <stdio.h>
#ifdef WIN32
//#define FILENAME_MAX 	512
#define	MAXNAMLEN		512
#define DBL_MAX			1.797693e+308

#include "getopt.h"
#else  /* WIN32 */
#include <dirent.h>
#include <values.h>
#include <unistd.h>
#endif /* WIN32 */

/*
 * Macros
 */

/* Max value of a number of variables(ѹ) */
/* ѿο(õ֤μ)κ */
#ifdef LIFE
#include "life.h"
#define NUM_VARIABLE_MAX MAX_P_GA
#else /* LIFE */
#define NUM_VARIABLE_MAX	20
#endif /* LIFE */

#define NUM_OPTION_MAX	128
/* BGAξΰĹκ */
#define BGA_GENE_MAX		400
/* θοκ */	
#define	ISLAND_POP_MAX		1000

/* Max value of a number of variables(ѹԲ) */
/* Ƥοκ */	
#define NUM_PARENT_MAX		(NUM_VARIABLE_MAX + 2)
/* MGGκݤȯҸοκ */
#define NUM_MGG_MAX			(ISLAND_POP_MAX - 2)


/* Return type index */
#define	EXIT_NORMAL	0	/* ｪλ */
#define EXIT_ERROR	-1	/* 顼λ */ 
#define EXIT_HELP	2	/* إץץ */


/*
 * Definitions of a structure
 */

/* Information of a gene */
typedef struct gagene {
	double	fitness;				/* Ŭ */
	union {
		double	gene_r[NUM_VARIABLE_MAX];	/* RGAǤΰ */
		char	gene_b[BGA_GENE_MAX];		/* BGAǤΰ */
	}; 
} GaGene_T;

/* Structure of a island */
typedef struct gaisland {
	int		population;						/* ο͸*/
	int		sortedIndex[ISLAND_POP_MAX];	/* Ŭٽ˥Ȥ줿ǥå */
	GaGene_T residents[ISLAND_POP_MAX];		/* η */
	int		*emigrants;						/* 󥰤Ǥΰܽ */
	GaGene_T *immigrants;					/* 󥰤Ǥΰܽ */
} GaIsland_T;

/* Encode type index */
#define	REAL	1	/* ¿GA */
#define	BINARY	2	/* Хʥꥳǥ(BGA) */
#define GRAY	3	/* 쥤ǥ(BGA) */

/* Encode parameters */
typedef struct gaencodeparam {
	int		encodeType;			/* 󥳡ɤΥ */
	int		numVariable;		/* ѿο */
	int		quantumNumber;		/* ̻Ҳ */
	int		geneLength;			/* Ĺ */
} GaEncodeParam_T;


/* GA type index */
#define	DGA		1	/* ʬGA */
#define DIGA	2	/* ʬGA */

/* Immigration switch index */
#define RANDOM_SWAP 	1 	/* ॹåפˤܽ */
#define	RANDOM_RING		2	/* 󥰤ˤܽ */
#define IMMIGRATION_OFF	3	/* ̵ܽ */

/* Ga type parameters */
typedef struct gatypeparam {
	int	gaType;					/* GAμ¹Է */
	int	maxGeneration;			/*  */
	int	totalPopulation;		/* ο */
	int	numIsland;				/* ο */
	int	islandPopulation;		/* θο */
	int	immigrationSwitch;		/* ̵ܽͭ */
	int	immigrationInterval;	/* ֳܽ */
	int	numImmigrants;			/* ܽο */
	int	integrateGeneration;	/*  */
	double	finValue;			/* λȽ */
	double	immigrationRate;	/* ܽΨ */
} GaTypeParam_T;


/* Digenesis type index */
#define	NORMAL_DIGENESIS	1	/* ̾ˡ */
#define	MGG					2	/* MGG */

/* Selection type index */
#define ROULETTE	1	/* 롼å */
#define TOURNAMENT	2	/* ȡʥ */
#define	RANDOM		3	/*  */

/* Digenesis parameters */
typedef struct digenesisparam {
	int	digenesisType;		/* ǥ */
	int	numElite;			/* ꡼ȿ */
	int	selectionType;		/* § */
	int	tournamentSize;		/* ȡʥȥ */
	int numMGGChildren;		/* MGGȯҤθο */
} DigenesisParam_T;


/* Crossover type index */
#define BLX				1	/* BLX(RGA) */
#define UNDX			2	/* UNDX(RGA) */
#define	UNDXM			3	/* UNDXM(RGA) */
#define SPX				4	/* SPX(RGA) */
#define NPOINTS			5	/* N POINTS CROSSOVER(BGA) */
#define NO_CROSSOVER	6	/* ̵ */

/* Crossover parameters */
typedef struct crossoverparam {
	int		crossoverType;	/* ˡ */
	int		numParent;		/* 򺵤ѤƤο */
	int		m;				/* UNDXmǻ, n򺵤˻ */
	double	alpha;			/* Ƥθˡǻ */
	double	beta;			/* UNDX,UNDXmǻ */
} CrossoverParam_T;


/* Mutation type index */
#define REGION_UNI		1	/* ΰѰ(RGA) */
#define FIXED_UNI		2	/* Ѱ(RGA) */
#define	FIXED_NORMAL	3	/* Ѱ(RGA) */
#define VARIABLE_UNI	4	/* Ѱ(RGA) */
#define	VARIABLE_NORMAL	5	/* Ѱ(RGA) */
#define BIT_REVERSE		6	/* ӥåȿž */
#define NO_MUTATION		7	/* Ѱ̵ */

/* Mutation parameters */
typedef struct mutationparam {
	int		mutationType;	/* Ѱˡ */
	double	mutationRate;	/* ѰΨ */
	double	fixedWidth;		/* ()Ѱۤ(ɸк)*/
} MutationParam_T;


/* IO parameters */
typedef struct gaioparam {
	char	paramFileName[FILENAME_MAX];		/* ϥѥ᡼ե̾ */	
	char	regionFileName[FILENAME_MAX];		/* ѿϰ̾ */
	char	individualFileName[FILENAME_MAX];	/* λե̾ */
	char	outputFileName[FILENAME_MAX];	/* ϥե̾ */
	FILE	*outputFile;		/* ϥեؤΥݥ */
} GaIoParam_T;


/* Variable region */
typedef struct variableregion {
	int		arraySize;		/* 礭 */
	double	minArray[NUM_VARIABLE_MAX];		/* ѿκǾͤ */
	double	maxArray[NUM_VARIABLE_MAX];		/* ѿκͤ */
	double	delta[NUM_VARIABLE_MAX];
} VariableRegion_T;


/* Best gene */
typedef struct bestgene {
	GaGene_T	gaGene;					/* ɸ */
	int			obtainedGeneration; 	/*  */
} BestGene_T;

/* Command line */
typedef struct comline {
	int		argc;
	char	**argv;
} ComLine_T;

/* MPI processes information */
typedef struct infompiproc {
	int		myProcRank;	/* ΥץΥ */
	int		numProcs;	/* MPI󤹤ץο */
	char	hostname[MAXNAMLEN]; 	/* Υۥ̾ */
} InfoMpiProc_T;

/* All of GA parameters */
typedef struct gaparam {
	GaEncodeParam_T		gaEncodeParam;
	GaTypeParam_T		gaTypeParam;
	DigenesisParam_T	digenesisParam;
	CrossoverParam_T	crossoverParam;
	MutationParam_T		mutationParam;
	GaIoParam_T			ioParam;
	VariableRegion_T	variableRegion;
	ComLine_T			comLine;
	BestGene_T			bestGene;
	InfoMpiProc_T		mpiInfo;		/* MPIǤǤΤ߻ */
} GaParam_T;

/*
 * Prottype declaration fo functions
 */

/*
 * Parameter Module(gaParam.cpp)
 */

/*-----
 * InitializeParamؿ
 * 	ѥ᡼¤GaParam_T
 *	ͤ0ˡݥ󥿤NULL˽
 *	㳰ȤơbestGenefitness-DBL_MAX˥åȤ
 */
extern int InitializeParam(GaParam_T *ga_param);

/*-----
 * SetCommandLineInfoؿ
 * 	ޥɥ饤ξ򥻥å
 */
extern int SetCommandLineInfo(ComLine_T *com_line, int argc, char **argv);

/*-----
 * AdminCommandLineؿ
 *	ޥɥ饤GaIoParam_TιιԤ
 */
extern int AdminCommandLine(GaIoParam_T *io_param, int argc, char **argv);

/*-----
 * SetRegionFromFileؿ
 *	ѿΰեɤߡͤ򥻥åȤ
 *	ޤΥ쥳ɤοҤĹȤƥåȤ
 */
extern int SetRegionFromFile(GaParam_T *ga_param);

/*-----
 * SetParamsFromFileؿ
 *	ե뤫ѥ᡼ɤ߹ߡ
 *	GaParam_T˥åȤ
 */
extern int SetParamsFromFile(GaParam_T *ga_param);

/*-----
 * SetDelta
 */
extern int SetDelta(GaParam_T *ga_param);

/*
 * Digenesis Module(digenesis.cpp)
 */

/*-----
 * NormalExecuteؿ
 *	̾ˡGA¹Ԥ
 */
extern int NormalExecute(GaParam_T *ga_param);      

/*-----
 * MGGExecuteؿ
 *	MGGGA¹Ԥ
 */     
extern int MGGExecute(GaParam_T *ga_param);

/*
 * MPI Digenesis module(mpiDigenesis.cpp)
 */

/*-----
 * NormalExecuteMpiؿ
 * 	NormalExecuteؿMPI
 */
extern int NormalExecuteMpi(GaParam_T *ga_param);

/*-----
 * MGGExecuteMpiؿ
 * 	MGGExecuteؿMPI
 */
extern int MGGExecuteMpi(GaParam_T *ga_param);

/*
 * Island Operation Module(islandOPR.cpp)
 */

/*-----
 * GenerateInitialPopulationؿ
 *	Τȯ
 */
extern int GenerateInitialPopulation(GaIsland_T *island, GaEncodeParam_T *ga_encode_param, VariableRegion_T *variable_region);

/*-----
 * IslandFitnessؿ
 * 	λꤵ줿ϰϤθΤŬ٤׻
 */
extern int IslandFitness(const GaParam_T *ga_param, GaIsland_T *island, int begin, int end);

/*-----
 * IslandCrossoverؿ
 *	λꤵ줿ϰϤθΤ򺵤ˤ֤
 */
extern int IslandCrossoverNormal(GaParam_T *ga_param, GaIsland_T *island, int begin, int end);

/*-----
 * IslandMggDigenesisؿ
 *	λꤵ줿ϰϤθΤMGG˴Ť֤
 */
extern int IslandMggDigenesis(GaParam_T *ga_param, GaIsland_T *island);

/*-----
 * IslandMutationؿ
 *	λꤵ줿ϰϤθΤѰۤԤ
 */
extern int IslandMutation(GaParam_T *ga_param, GaIsland_T *island, int begin, int end);

/*
 * Selection Module(selection.cpp)
 */

/*-----
 * SelectParentؿ
 * 	Ŭڤ˰ʲ3ĤδؿƤӡ	
 * 	̤Ф줿Ƥֹ֤
 */
extern int SelectParent(const GaParam_T *ga_param, const GaIsland_T *island, int *parents_no);

/*-----
 * SelectRouletteؿ
 * 	롼åǿƤ
 */
extern int SelectRoulette(const GaIsland_T *island, int num_select, int *parents_no);

/*-----
 * SelectTounamentؿ
 * 	ȡʥǿƤ
 */
extern int SelectTournament(const GaIsland_T *island, int num_select, int tournament_size, int *parents_no);

/*------
 * SelectRandomؿ
 * 	Ŭ٤̵뤷ƥ()˿Ƥ
 */
extern int SelectRandom(const GaIsland_T *island, int num_select, int *parents_no);



/*
 * Crossover Module(crossover.cpp)
 */

/*-----
 * Crossoverؿ
 *	GaParam_T˻ꤵ줿ˡ3ǻꤵ줿
 *   	Ƥǡ򺹤ԤҸΤ֤
 */
extern int Crossover(const GaParam_T *ga_param, const GaGene_T *island, const int *parents_no, GaGene_T *child);


/*
 * Mutation Module(mutation.cpp)
 */

/*-----
 * Mutationؿ
 *	ꤵ줿ˡǡѰۤԤ줿Τ֤
 */
extern int Mutation(const GaParam_T *ga_param, GaGene_T *gene, const GaGene_T *island_bestgene, GaGene_T *out_gene);


/*
 * Immigration Module(immigration.cpp)
 */

/*-----
 * MakeImmigrationBuffer
 */
extern int MakeImmigrationBuffer(const GaParam_T *ga_param, GaIsland_T *island);

/*-----
 * FreeImmigrationBuffer
 */
void FreeImmigrationBuffer(const GaParam_T *ga_param, GaIsland_T *islands);

/*-----
 * Immigrateؿ
 * 	֤ΰܽԤ
 */
extern int Immigrate(const GaParam_T *ga_param, GaIsland_T *islands);


/*
 * Integrate Module(integrate.cpp)
 */

/*-----
 * IntegrateIslandsؿ
 *	DIGAΥ르ꥺ˱褤Ԥ
 */
extern int IntegrateIslands(const GaParam_T *ga_param, GaIsland_T *islands);

/*-----
 * AjustParamsAfterIntegrateؿ
 *	塤Ĵɬפʥѥ᡼Ĵ
 */
extern int AjustParamsAfterIntegrate(GaParam_T *ga_param);


/*
 * IO Module(ioModule.cpp)
 */

/*-----
 * SetIndividualFromFileؿ
 * 	Τե뤫ɤ߹
 */
extern int SetIndividualFromFile(GaParam_T *ga_param, GaIsland_T *islands);

/*-----
 * PrintExecuteParametersؿ
 *	GA¹ԤݤΥѥ᡼ɽ
 */
extern int PrintExecuteParameters(const GaParam_T *ga_param, FILE *fp);

/*-----
 * PrintBestGeneAtPresentؿ
 *	ɸΤɽ
 */
extern int PrintBestGeneAtPresent(int generation, GaParam_T *ga_param);

/*-----
 * PrintFileAllؿ
 *	GaParam_T¤Τǻꤵ줿ϥե
 *	ξΤξϤ
 */
extern int PrintFileAll(int generation, GaParam_T *ga_param, GaIsland_T *islands);

/*-----
 * PrintResultؿ
 *	õλ塤̤ɽ
 */
extern int PrintResult(GaParam_T *ga_param);


/*
 * Fitness evaluation Module
 */

/*-----
 * Fitnessؿ
 *	Ϳ줿ΤŬ٤֤
 */
extern int Fitness(const GaParam_T *ga_param, const GaGene_T *ga_gene, double *fitness);

/*-----
 * SortByFitnessؿ
 * 	Ŭ٤ˤꡤθΤ򥽡
 */
extern int SortByFitness(GaIsland_T *island);

/*-----
 * RecordBestGeneؿ
 * 	ޤǤκɸΤŬ٤ȸγκɸΤ
 * 	Ŭ٤ӤɤΤäθΤ¸
 * 	)ȸ˻Ȥ
 */
extern int RecordBestGene(int generation, GaIsland_T *islands, int num_island, BestGene_T *best_gene);

#endif /* _RANDB_H_ */
