/**************************************************************
 *	TMCƖxVXei߂QPj
 *
 *		java util(Ro[g)
 *
 *	Copyright (C) 2000 %%MAKER%%
 **************************************************************/
#ifndef lint
static char SccsId[] = "%Z%META21 %M% %I% %D% %U%";
#endif

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <jni.h>
#include "ju_conv.h"
#include "c_dbg.h"


static int Ju_free_X(MM_DATA_t *mmd, char*rec);


/*****************************************************************************
 * ֐
 *	JU_obj2classname: Java object -> Java class name
 * @\
 *	java objectÃIuWFNg̃NX߂
 * 
 *	char		*clsname	I : tB[h
 *	MM_DATA_t	 **retmmd	O : MM_DATA
 * ֐l
 *	 0:	
 *	-1:	ُ
 * 
 *****************************************************************************/
int
JU_obj2classname(JNIEnv *env, jobject obj, char *retstr, int len)
{
	jmethodID mid;
	jclass classclass;
	jobject classclassclass;
	jclass classclassclassclass;
	jstring classname;
	jboolean jbool;
	size_t isize, osize;
	jint ji;
	const char *inptr, *jc;
	char *outptr;
	int i;

	DBG(60, ("JU_obj2classname : %d\n", obj));
	classclass = (*env)->GetObjectClass(env, obj);
	mid = (*env)->GetMethodID(env, classclass, "getClass", "()Ljava/lang/Class;");
	if (!mid) {
		LOG_ERR(("no mid getClass\n"));
		goto err;
	}
	classclassclass = (jstring)(*env)->CallObjectMethod(env, obj, mid);
	if (!classclassclass) {
		LOG_ERR(("no classclassclass\n"));
		goto err;
	}
	classclassclassclass = (*env)->GetObjectClass(env, classclassclass);
	mid = (*env)->GetMethodID(env, classclassclassclass, "getName", "()Ljava/lang/String;");
	if (!mid) {
		LOG_ERR(("no method getName\n"));
		goto err;
	}
	classname = (jstring)(*env)->CallObjectMethod(env, classclass, mid);
	if (!classname) {
		LOG_ERR(("no method getName\n"));
		goto err;
	}

	if (JU_GetCharSJIS(env, classname, retstr, len)) {
		LOG_ERR(("JU_GetCharSJIS\n"));
		goto err;
	}
	for (i=0; i<len; i++) {
		if (retstr[i]=='\0')
			break;
		if (retstr[i]=='.')
			retstr[i] = '/';
	}
	
	return 0;
err:
	return -1;
}

/*****************************************************************************
 * ֐
 *	JU_clsname2mmd: Java class name -> MM_DATA
 * @\
 *	javał̃NXMM_DATA߂
 * 
 *	char		*clsname	I : NX
 *	MM_DATA_t	**retmmd	O : MM_DATA
 * ֐l
 *	 0:	
 *	-1:	ُ
 * 
 *****************************************************************************/
int
JU_clsname2mmd(char *clsname, MM_DATA_t **retmmd)
{
	int i;
	int max = ju_get_MM_LEN();

	for (i=0; i < max; i++) {
		MM_DATA_t	*mmdata = ju_get_MM_data_byindex(i);

		if (!strcmp(clsname, mmdata->clsname)) {
			*retmmd = mmdata;
			goto find;
		}
	}
	DBG(50, ("JU_clsname2mmd: can't find %s\n", clsname));
	return -1;
find:
	DBG(50, ("JU_clsname2mmd: find %d %s\n", *retmmd, clsname));
	return 0;
}

/*****************************************************************************
 * ֐
 *	JU_strname2mmd: C structure name -> MM_DATA
 * @\
 *	Cł̍\̖MM_DATA߂
 * 
 *	char		*strname	I : \̖
 *	MM_DATA_t	**retmmd	O : MM_DATA
 * ֐l
 *	 0:	
 *	-1:	ُ
 * 
 *****************************************************************************/
int
JU_strname2mmd(char *strname, MM_DATA_t **retmmd)
{
	int i;
	int max = ju_get_MM_LEN();

	for (i=0; i < max; i++) {
		MM_DATA_t	*mmdata = ju_get_MM_data_byindex(i);
		char		*cp = NULL, wk[256];

		/* NX\̖𐶐 */
		cp = (char*)strrchr( mmdata->clsname, '/' );
		strcpy( wk, cp ? (cp + 1) : mmdata->clsname );
		strcat( wk, "_t" );

		if (!strcmp(strname, wk)){
			*retmmd = mmdata;
			goto find;
		}
	}
	DBG(50, ("JU_strname2mmd: can't find %s\n", strname));
	return -1;
find:
	DBG(50, ("JU_strname2mmd: find %d %s\n", *retmmd, strname));
	return 0;
}

/*****************************************************************************
 * ֐
 *	JU_fldname2md: tB[h+MM_DATA_t -> M_DATA_t
 * @\
 *	tB[hMM_DATAM_DATA߂
 * 
 *	MM_DATA_t	*mmd		I : MM_DATA
 *	char		*fldname	I : tB[h
 *	M_DATA_t	**retmd		O : M_DATA
 * ֐l
 *	 0:	
 *	-1:	ُ
 * 
 *****************************************************************************/
int
JU_fldname2md(MM_DATA_t *mmd, char *fldname, M_DATA_t **retmd)
{
	int i;
	M_DATA_t *md = mmd->mdata;
	for (i=0; i<mmd->fld_n; i++) {
		if (!strcmp(md[i].name, fldname)) {
			*retmd = &md[i];
			goto find;
		}
	}
	return -1;
find:
	return 0;
}

/*****************************************************************************
 * ֐
 *	JU_mid2sig: M_XXXjavǎ^̃VOl`ɕϊ
 * @\
 *	M_XXXjavǎ^̃VOl`ɕϊ
 * 
 *	int		mid		I : M_XXX
 *	char		*optstr;	I : IvV
 *	char		*ret;		O : ԋp
 *	int		retlen		I : ԋpobt@
 * ֐l
 *	0 :	   VOl`
 *	-1:	   G[
 * 
 *****************************************************************************/
int
JU_mid2sig(int mid, char *optstr, char *ret, int retlen)
{
	switch (mid) {
	case M_STR:
		strncpy(ret, "Ljava/lang/String;", retlen);
		break;
	case M_BYTE:
		strncpy(ret, "B", retlen);
		break;
	case M_SHRT:
		strncpy(ret, "S", retlen);
		break;
	case M_INT:
		strncpy(ret, "I", retlen);
		break;
	case M_LONG:
		strncpy(ret, "J", retlen);
		break;
	case M_BOOL:
		strncpy(ret, "Z", retlen);
		break;
	case M_ARRY:
		snprintf(ret, retlen, "[L%s;", optstr);		       
		break;
	case M_BOOLARRY:
		strncpy(ret, "[Z", retlen);
		break;
	case M_BARRY:
		strncpy(ret, "[B", retlen);
		break;
	case M_SARRY:
		strncpy(ret, "[S", retlen);
		break;
	case M_IARRY:
		strncpy(ret, "[I", retlen);
		break;
	case M_LARRY:
		strncpy(ret, "[J", retlen);
		break;
	case M_STRARRY:
		strncpy(ret, "[Ljava/lang/String;", retlen);
		break;
	case M_SUBSTRCT:
		snprintf(ret, retlen, "L%s;", optstr);
		break;
	default:
		goto err;
		break;
	}
	return 0;
err:
	return -1;
}

/*****************************************************************************
 * ֐
 *	JU_setnum: 64bit value -> structure+offset+length
 * @\
 *	\̂̒̐ltB[hɐݒ肷
 * 
 *	void		*p		I : \̐擪|C^
 *	int		offset		I : ItZbg
 *	int		dlen		I : f[^
 *	long long	val		I : ݒl
 * ֐l
 *	 0:	
 *	-1:	ُ
 * 
 *****************************************************************************/
int
JU_setnum(char *p, int offset, int dlen, long long val)
{
	DBG(60, ("p=%d offset=%d dlen=%d val=%lld\n", p, offset, dlen, val));
	switch (dlen) {
	case 1:
		*((char *)(p+offset)) = val;
		break;
	case 2:
		*((short *)(p+offset)) = val;
		break;
	case 4:
		*((int *)(p+offset)) = val;
		break;
	case 8:
		*((long long *)(p+offset)) = val;
		break;
	default:
		goto err;
	}
	return 0;
err:
	return -1;
}

/*****************************************************************************
 * ֐
 *	JU_getnum: structure+offset+length -> 64bit value
 * @\
 *	\̂̒̐l64bitŕԂ
 * 
 *	void		*p		I : \̐擪|C^
 *	int		offset		I : ItZbg
 *	int		dlen		I : f[^
 *	long long	*retval		O : ԋpl
 * ֐l
 *	 0:	
 *	-1:	ُ
 * 
 *****************************************************************************/
int
JU_getnum(char *p, int offset, int dlen, long long *retval)
{
	long long val;

	switch (dlen) {
	case 1:
		val = *((char *)(p+offset));
		break;
	case 2:
		val = *((short *)(p+offset));
		break;
	case 4:
		val = *((int *)(p+offset));
		break;
	case 8:
		val = *((long long *)(p+offset));
		break;
	default:
		goto err;
	}
	*retval = val;
	return 0;
err:
	return -1;
}


/*****************************************************************************
 * ֐
 *	JU_convert_j2c: java object -> C structure
 * @\
 *	javãIuWFNgC̍\̂ւ̕ϊ
 * 
 *	JNIENV_t	*env
 *	MM_DATA_t	*mmdata		I : NX/\̃f[^
 *	jobject		obj		I : java object
 *	void		*ret		O : \̂ւ̃|C^
 * ֐l
 *	 0:	
 *	-1:	ُ
 * 
 *	retobj͎gp邱(JU_free)
 *****************************************************************************/
int
JU_convert_j2c(JNIEnv *env, MM_DATA_t *mmdata, jobject obj, void *retv, char spc)
{
	char		*ret = (char*)retv;
	int i, j, k;
	M_DATA_t *md = mmdata->mdata;
	jclass class;
	jfieldID fid;
	long long val;
	
	/* R[hϊp */
	jstring js;
	int utflen;
	jboolean jbool;
	size_t osize;
	jint ji;
	char * jc, *jo;
	char *outptr;
	char *tmpchar;
	jthrowable ex = NULL;
	
	/* \̔zϊp */
	jarray ja;
	int sz, sza;
	char *array = NULL;
	MM_DATA_t *a_mmd;
	jobject a_elem;
	char sig[128];
	jbooleanArray bool_a;
	jbyteArray byte_a;
	jshortArray short_a;
	jintArray int_a;
	jlongArray long_a;

	char *substrct;
	
	DBG(60, ("JU_convert_j2c: start(%d, %s)\n", mmdata, mmdata->clsname));
	memset(ret, 0, mmdata->struct_size);
	
	class =(*env)->FindClass(env, mmdata->clsname);
	if (!class) {
		LOG_ERR(("no class '%s'\n", mmdata->clsname));
		goto err;
	}
	
	DBG(60, ("JU_convert_j2c: fieldnum=%d\n", mmdata->fld_n));
	for (i=0; i<mmdata->fld_n; i++) {
		if (JU_mid2sig(md[i].type, md[i].arryclsname, sig, sizeof(sig))) {
			goto err;
		}
		DBG(60, ("sig=%s\n", sig));
		fid = (*env)->GetFieldID(env, class, md[i].name, sig);
		if (!fid) {
			LOG_ERR(("no fid class[%s] field_name[%s] sig(%s)\n", mmdata->clsname, md[i].name, sig));
			goto err;
		}
		switch (md[i].type) {
		case M_STR:
			js = (*env)->GetObjectField(env, obj, fid);
			jo = (char*)ret+md[i].offset;
			osize = md[i].len;
			memset(jo, spc, osize);
			DBG(30, ("output string len = %d js=%d\n", osize, js));
			if (!js) {
				break;
			}
			utflen = (*env)->GetStringUTFLength(env, js);
			DBG(30, ("input UTF len = %d\n", utflen));
			if (utflen<=0) {
				break;
			}
			if (JU_GetCharSJIS(env, js, jo, osize)) {
				LOG_ERR(("JU_GetCharSJIS err\n"));
				goto err;
			}
#if 0
			for (j=0, k=0; j<osize; j++) {
				/* '\0'ȍ~' 'ɕϊ */
				if (k || jo[j]=='\0') {
					jo[j] = ' ';
					k++;
				}
			}
#endif
			(*env)->DeleteLocalRef(env, js);
			break;
		case M_BOOL:
			val = (long long)(*env)->GetBooleanField(env, obj, fid);
			if (JU_setnum(ret, md[i].offset, md[i].len, val)) {
				goto err;
			}
			break;
		case M_BYTE:
			val = (long long)(*env)->GetByteField(env, obj, fid);
			if (JU_setnum(ret, md[i].offset, md[i].len, val)) {
				goto err;
			}
			break;
		case M_SHRT:
			val = (long long)(*env)->GetShortField(env, obj, fid);
			if (JU_setnum(ret, md[i].offset, md[i].len, val)) {
				goto err;
			}
			break;
		case M_INT:
			val = (long long)(*env)->GetIntField(env, obj, fid);
			if (JU_setnum(ret, md[i].offset, md[i].len, val)) {
				goto err;
			}
			break;
		case M_LONG:
			val = (*env)->GetLongField(env, obj, fid);
			if (JU_setnum(ret, md[i].offset, md[i].len, val)) {
				goto err;
			}
			break;
		case M_ARRY:
			ja = (jarray)(*env)->GetObjectField(env, obj, fid);
			if (ja==NULL) {
				DBG(60, ("array is null\n"));
				break;
			}
			sz = (*env)->GetArrayLength(env, ja);
			DBG(60, ("M_ARRY sz=%d\n", sz));
			if (sz==0)
				break;
			if (JU_clsname2mmd(md[i].arryclsname, &a_mmd)) {
				goto err;
			}
			array = calloc(a_mmd->struct_size, sz);
			DBG(60, ("ALLOC %d, %dbytes\n", array, a_mmd->struct_size*sz));
			if (!array) {
				goto err;
			}
			for (j=0; j<sz; j++) {
				a_elem = (*env)->GetObjectArrayElement(env, ja, j);
				if (!a_elem)
					continue;
				if (JU_convert_j2c(env, a_mmd, a_elem,
						   array+a_mmd->struct_size*j, spc)) {
					goto err;
				}
				/***** a_elemDeleteLocalRef́AċAR[ */
				/***** ōs			      */
				/* (*env)->DeleteLocalRef(env, a_elem); */
				a_elem = NULL;
			}
			*((char **)((char*)ret+md[i].offset)) = array;
			(*env)->DeleteLocalRef(env, ja);
			break;
		case M_BOOLARRY:
			bool_a = (jbyteArray)(*env)->GetObjectField(env, obj, fid);
			if (bool_a == NULL)
				break;
			sz = md[i].arry_n;
			sza = (*env)->GetArrayLength(env, bool_a);
			if (sza != sz) {
				LOG_MSG(("class(%s) booleanArray field(%s)"
					    " invalid size (java=%delems,c=%delems)\n",
					    mmdata->clsname, md[i].name, sza, sz));
				memset(ret+md[i].offset, 0, sizeof(char)*sz);
				break;
			}
			(*env)->GetBooleanArrayRegion(env, bool_a, 0, md[i].arry_n,
						      (jboolean*)(ret+md[i].offset));
			(*env)->DeleteLocalRef(env, bool_a);
			break;
		case M_BARRY:
			byte_a = (jbyteArray)(*env)->GetObjectField(env, obj, fid);
			if (byte_a == NULL)
				break;
			sz = md[i].arry_n;
			sza = (*env)->GetArrayLength(env, byte_a);
			if (sza != sz) {
				LOG_MSG(("class(%s) byteArray field(%s)"
					 " invalid size (java=%delems,c=%delems)\n",
					 mmdata->clsname, md[i].name, sza, sz));
				memset(ret+md[i].offset, 0, sizeof(char)*sz);
				break;
			}
			(*env)->GetByteArrayRegion(env, byte_a, 0, md[i].arry_n, ret+md[i].offset);
			(*env)->DeleteLocalRef(env, byte_a);
			break;
		case M_SARRY:
			short_a = (jshortArray)(*env)->GetObjectField(env, obj, fid);
			if (short_a == NULL)
				break;
			sz = md[i].arry_n;
			sza = (*env)->GetArrayLength(env, short_a);
			if (sza != sz) {
				LOG_MSG(("class(%s) shortArray field(%s)"
					    " invalid size (java=%delems,c=%delems)\n",
					    mmdata->clsname, md[i].name, sza, sz));
				memset(ret+md[i].offset, 0, sizeof(short)*sz);
				break;
			}
			(*env)->GetShortArrayRegion(env, short_a, 0, md[i].arry_n,
						    (jshort*)(ret+md[i].offset));
			(*env)->DeleteLocalRef(env, short_a);
			break;
		case M_IARRY:
			int_a = (jintArray)(*env)->GetObjectField(env, obj, fid);
			if (int_a == NULL)
				break;
			sz = md[i].arry_n;
			sza = (*env)->GetArrayLength(env, int_a);
			if (sza != sz) {
				LOG_MSG(("class(%s) intArray field(%s)"
					    " invalid size (java=%delems,c=%delems)\n",
					    mmdata->clsname, md[i].name, sza, sz));
				memset(ret+md[i].offset, 0, sizeof(int)*sz);
				break;
			}
			(*env)->GetIntArrayRegion(env, int_a, 0, md[i].arry_n,
						  (jint*)(ret+md[i].offset));
			(*env)->DeleteLocalRef(env, int_a);
			break;
		case M_LARRY:
			long_a = (jlongArray)(*env)->GetObjectField(env, obj, fid);
			if (long_a == NULL)
				break;
			sz = md[i].arry_n;
			sza = (*env)->GetArrayLength(env, long_a);
			if (sza != sz) {
				LOG_MSG(("class(%s) longArray field(%s)"
					    " invalid size (java=%delems,c=%delems)\n",
					    mmdata->clsname, md[i].name, sza, sz));
				memset(ret+md[i].offset, 0, sizeof(long long)*sz);
				break;
			}
			(*env)->GetLongArrayRegion(env, long_a, 0, md[i].arry_n,
						   (jlong*)(ret+md[i].offset));
			(*env)->DeleteLocalRef(env, long_a);
			break;
			
		case M_SUBSTRCT:
			a_elem = (jarray)(*env)->GetObjectField(env, obj, fid);
			if (a_elem==NULL) {
				DBG(60, ("Substructure is null\n"));
				break;
			}
			if (JU_clsname2mmd(md[i].arryclsname, &a_mmd)) {
				goto err;
			}
			substrct = ret+md[i].offset;
			if (JU_convert_j2c(env, a_mmd, a_elem, substrct, spc)) {
				goto err;
			}
			/* (*env)->DeleteLocalRef(env, a_elem); */
			a_elem = NULL;
			break;
		default:
			goto err;
		}
	}
	(*env)->DeleteLocalRef(env, obj);
	return 0;
err:
	if (array) {
		free(array);
	}
	if (a_elem)
		(*env)->DeleteLocalRef(env, a_elem);
	return -1;
}

/*****************************************************************************
 * ֐
 *	JU_convert_c2j: C structure -> java object
 * @\
 *	C̍\̂javãIuWFNgւ̕ϊ
 * 
 *	JNIENV_t	*env
 *	MM_DATA_t	*mmdata		I : NX/\̃f[^
 *	void		*strct		I : \̂ւ̃|C^
 *	jobject		*obj		O : java object
 * ֐l
 *	 0:	
 *	-1:	ُ
 * 
 *	
 *****************************************************************************/
int
JU_convert_c2j(JNIEnv *env, MM_DATA_t *mmdata, void *strctv, jobject *obj)
{
	char		*strct = strctv;
	jvalue *val = NULL;
	int objcount = 0;
	jmethodID mid;
	jobject retobj=NULL;
	jclass class=NULL;
	jfieldID fid;
	long long num;
	M_DATA_t *md = mmdata->mdata;
	int i, j, k;
	
	/* R[hϊp */
	char tmpustr[256];
	size_t isize, osize;
	char *inptr;
	char *outptr;
	int strc;
	
	/* zϊp */
	M_DATA_t *a_md;
	long long a_num;
	char *a_rec;
	int sz;
	jobjectArray array = NULL;
	jobject a_elem = NULL;
	jclass a_class = NULL;
	jfieldID a_fid;
	MM_DATA_t *a_mmd;
	char sig[256];
	jbooleanArray bool_a;
	jbyteArray byte_a;
	jshortArray short_a;
	jintArray int_a;
	jlongArray long_a;

	DBG(60, ("JU_convert_c2j clsname=(%d, %s)\n", mmdata, mmdata->clsname));
	class = (*env)->FindClass(env, mmdata->clsname);
	DBG(60, ("JU_convert_c2j classID=%d\n", class));
	if (!class) {
		LOG_ERR(("no clsname found (%s)\n", mmdata->clsname));
		goto err;
	}
	retobj = (*env)->AllocObject(env, class);
	DBG(60, ("JU_convert_c2j retobj=%d\n", retobj));
	mid = (*env)->GetMethodID(env, class, "<init>",
				  "()V");
	DBG(60, ("JU_convert_c2j constructor MethodID=%d\n", mid));
	(*env)->CallVoidMethod(env, retobj, mid);
	DBG(60, ("JU_convert_c2j do pre-loop\n"));
	for (i=0; i<mmdata->fld_n; i++) {
		switch (md[i].type) {
		case M_STR:
			objcount++;
			DBG(60, ("objcpunt++ (%d)\n", objcount));
			break;
		default:
			break;
		}
	}
	DBG(60, ("string num=%d\n", objcount));
	val = (jvalue*)calloc(objcount, sizeof(jvalue));
	DBG(60, ("ALLOC %d %dbytes\n", val, objcount*sizeof(jvalue)));
	if (!val) {
		LOG_ERR(("Can't malloc %d size\n", objcount*sizeof(jvalue)));
		goto err;
	}
	
	for (strc=0, i=0; i<mmdata->fld_n; i++) {
		if (JU_mid2sig(md[i].type, md[i].arryclsname, sig, sizeof(sig))) {
			goto err;
		}
		fid = (*env)->GetFieldID(env, class, md[i].name, sig);
		if (!fid) {
			LOG_ERR(("no field class(%s) field(%s) sig(%s)\n",
				    mmdata->clsname, md[i].name, sig));
			goto err;
		}
		switch (md[i].type) {
		case M_STR:
			isize = md[i].len;
			inptr = (char*)strct+md[i].offset;
			/* "abcabc\0hoge" -> "abcabc	" */
			for (j=0, k=0; j<isize; j++) {
				/* '\0'ȍ~' 'ɕϊ */
				if (k || inptr[j]=='\0') {
					inptr[j] = ' ';
					k = 1;
				}
			}
			/* "abcabc\0hoge" -> "abcabc\0\0\0\0\0" */
			for (j = isize-1; j >= 0; j--) {
				/* ̂قSpace */
				if (inptr[j]==' ') {
					inptr[j] = '\0';
				} else {
					break;
				}
			}
			osize=sizeof(tmpustr);
			outptr = tmpustr;
			if (JU_NewStringSJIS(env, inptr, isize, &val[strc].l)) {
				LOG_ERR(("ConvertError sjis to utf-8 [%s][%s]\n",
				       mmdata->clsname, md[i].name));
				goto err;
			}
			(*env)->SetObjectField(env, retobj, fid, val[strc].l);
			strc++;
			break;
		case M_BOOL:
			if (JU_getnum(strct, md[i].offset, md[i].len, &num)) {
				goto err;
			}
			if (num)
				(*env)->SetBooleanField(env, retobj, fid, JNI_TRUE);
			else
				(*env)->SetBooleanField(env, retobj, fid, JNI_FALSE);
			break;
		case M_BYTE:
			if (JU_getnum(strct, md[i].offset, md[i].len, &num)) {
				goto err;
			}
			(*env)->SetByteField(env, retobj, fid, (jbyte)num);
			break;
		case M_SHRT:
			if (JU_getnum(strct, md[i].offset, md[i].len, &num)) {
				goto err;
			}
			(*env)->SetShortField(env, retobj, fid, (jshort)num);
			break;
		case M_INT:
			if (JU_getnum(strct, md[i].offset, md[i].len, &num)) {
				goto err;
			}
			(*env)->SetIntField(env, retobj, fid, (jint)num);
			break;
		case M_LONG:
			if (JU_getnum(strct, md[i].offset, md[i].len, &num)) {
				goto err;
			}
			(*env)->SetLongField(env, retobj, fid, (jlong)num);
			break;
		case M_ARRY:
			/* not yet impl. */
			if (JU_fldname2md(mmdata, md[i].arrynumname, &a_md)) {
				LOG_ERR(("JU_fldname2md err arrynumname=%s\n", md[i].arrynumname));
				goto err;
			}
			DBG(50, ("M_ARRY: anumname=%s a_md=%d offset=%d len=%d\n",
				 md[i].arrynumname, a_md, a_md->offset, a_md->len));
			if (JU_getnum(strct, a_md->offset, a_md->len, &a_num)) {
				LOG_ERR(("JU_getnum error a_md=%d offset=%d len=%d\n", a_md->offset, a_md->len));
				goto err;
			}
			DBG(50, ("M_ARRY: anum=%lld\n", a_num));
			if (a_num==0LL) {
				DBG(50, ("no record\n"));
				break;
			}
			a_rec = *((char**)(strct+md[i].offset));
			DBG(50, ("a_rec=%d\n", a_rec));
			if (a_rec==NULL)
				break;
			sz = a_num;
			if (JU_clsname2mmd(md[i].arryclsname, &a_mmd)) {
				goto err;
			}
			a_class = (*env)->FindClass(env, md[i].arryclsname);
			if (!a_class) {
				LOG_ERR(("no clsname found (%s)\n", mmdata->clsname));
				goto err;
			}
			DBG(50, ("ARRAY class=%s size=%d a_class=%d\n", md[i].arryclsname, sz, a_class));
			array = (*env)->NewObjectArray(env, sz, a_class, NULL);
			for (j=0; j<sz; j++) {
				if (JU_convert_c2j(env, a_mmd,
						   a_rec+(a_mmd->struct_size*j),
						   &a_elem)) {
					LOG_ERR(("sub-record convert error(%d/%d)\n", j, sz));
					goto err;
				}
				(*env)->SetObjectArrayElement(env, array, j, a_elem);
				(*env)->DeleteLocalRef(env, a_elem);
				a_elem = NULL;
			}
		arrayend:
			(*env)->SetObjectField(env, retobj, fid, array);
			if (array)
				(*env)->DeleteLocalRef(env, array);
			if (a_class) {
				(*env)->DeleteLocalRef(env, a_class);
			}
			array = NULL;
			a_class = NULL;
			break;
		case M_BOOLARRY:
			bool_a = (jbooleanArray)(*env)->NewBooleanArray(env, md[i].arry_n);
			if (!bool_a) {
				LOG_ERR(("NewBooleanArray class(%s) field(%s) n(%d) err\n",
					    mmdata->clsname, md[i].name, md[i].arry_n));
				goto err;
			}
			(*env)->SetBooleanArrayRegion(env, bool_a, 0, md[i].arry_n,
						      (jboolean*)(strct+md[i].offset));
			(*env)->SetObjectField(env, retobj, fid, bool_a);
			(*env)->DeleteLocalRef(env, bool_a);
			break;
		case M_BARRY:
			byte_a = (jbyteArray)(*env)->NewByteArray(env, md[i].arry_n);
			if (!byte_a) {
				LOG_ERR(("NewByteArray class(%s) field(%s) n(%d) err\n",
					    mmdata->clsname, md[i].name, md[i].arry_n));
				goto err;
			}
			(*env)->SetByteArrayRegion(env, byte_a, 0, md[i].arry_n,
						   (jbyte*)(strct+md[i].offset));
			(*env)->SetObjectField(env, retobj, fid, byte_a);
			(*env)->DeleteLocalRef(env, byte_a);
			break;
		case M_SARRY:
			short_a = (jshortArray)(*env)->NewShortArray(env, md[i].arry_n);
			if (!short_a) {
				LOG_ERR(("NewShortArray class(%s) field(%s) n(%d) err\n",
					    mmdata->clsname, md[i].name, md[i].arry_n));
				goto err;
			}
			(*env)->SetShortArrayRegion(env, short_a, 0, md[i].arry_n,
						   (jshort*)(strct+md[i].offset));
			(*env)->SetObjectField(env, retobj, fid, short_a);
			(*env)->DeleteLocalRef(env, short_a);
			break;
		case M_IARRY:
			int_a = (jintArray)(*env)->NewIntArray(env, md[i].arry_n);
			if (!int_a) {
				LOG_ERR(("NewIntArray class(%s) field(%s) n(%d) err\n",
					    mmdata->clsname, md[i].name, md[i].arry_n));
				goto err;
			}
			(*env)->SetIntArrayRegion(env, int_a, 0, md[i].arry_n,
						  (jint*)(strct+md[i].offset));
			(*env)->SetObjectField(env, retobj, fid, int_a);
			(*env)->DeleteLocalRef(env, int_a);
			break;
		case M_LARRY:
			long_a = (jlongArray)(*env)->NewLongArray(env, md[i].arry_n);
			if (!long_a) {
				LOG_ERR(("NewLongArray class(%s) field(%s) n(%d) err\n",
					    mmdata->clsname, md[i].name, md[i].arry_n));
				goto err;
			}
			(*env)->SetLongArrayRegion(env, long_a, 0, md[i].arry_n,
						   (jlong*)(strct+md[i].offset));
			(*env)->SetObjectField(env, retobj, fid, long_a);
			(*env)->DeleteLocalRef(env, long_a);
			break;
		case M_SUBSTRCT:
			if (JU_clsname2mmd(md[i].arryclsname, &a_mmd)) {
				goto err;
			}
			if (JU_convert_c2j(env, a_mmd, strct+md[i].offset, &a_elem)) {
				goto err;
			}
			(*env)->SetObjectField(env, retobj, fid, a_elem);
			(*env)->DeleteLocalRef(env, a_elem);
			break;
		default:
			goto err;
		}
	}
	for (i=0; i<strc; i++) {
		(*env)->DeleteLocalRef(env, val[i].l);
	}
	if (class)
		(*env)->DeleteLocalRef(env, class);
	if (val) {
		DBG(60, ("FREE %d\n", val));
		free(val);
	}
	*obj = retobj;
	return 0;
err:
	if (val) {
		DBG(60, ("FREE %d\n", val));
		free(val);
	}
	return -1;
}

/*****************************************************************************
 * ֐
 *	JU_free: C\̂free
 * @\
 *	C̍\̂̃_vo
 * 
 *	MM_DATA_t	*mmd		I : NX/\̃f[^
 *	char		*rec		I : \̂ւ̃|C^
 * ֐l
 *	 0:	
 *	-1:	ُ
 * 
 *	
 *****************************************************************************/
int
JU_free(MM_DATA_t *mmd, void *recv)
{
	char *rec = (char*)recv;
	int ret;

	DBG(60, ("JU_free(%d[%s], %d) start\n", mmd, mmd->clsname, rec));
	ret = Ju_free_X(mmd, rec);
	DBG(60, ("FREE %d\n", rec));
	free(rec);
	return ret;
}

static int
Ju_free_X(MM_DATA_t *mmd, char *rec)
{
	int i, j;
	M_DATA_t *md = mmd->mdata;
	char str[256];
	char sig[256];
	long long val;
	MM_DATA_t *a_mmd;
	M_DATA_t *a_md;
	long long a_num;
	char *a_rec = NULL;

	DBG(60, ("JU_free_X(%d[%s], %d) start\n", mmd, mmd->clsname, rec));
	for (i=0; i<mmd->fld_n; i++) {
		switch (md[i].type) {
		case M_STR:
		case M_BYTE:
		case M_SHRT:
		case M_INT:
		case M_LONG:
		case M_BOOL:
		case M_BOOLARRY:
		case M_BARRY:
		case M_SARRY:
		case M_IARRY:
		case M_LARRY:
		case M_SUBSTRCT:
			break;
		case M_ARRY:
			a_rec = NULL;
			if (JU_clsname2mmd(md[i].arryclsname, &a_mmd)) {
				LOG_ERR(("Unknown array class %s\n", md[i].arryclsname));
				goto err;
			}
			if (JU_fldname2md(mmd, md[i].arrynumname, &a_md)) {
				LOG_ERR(("Unknown array count field %s\n", md[i].arrynumname));
				goto err;
			}
			if (JU_getnum(rec, a_md->offset, a_md->len, &a_num)) {
				LOG_ERR(("Get a_num err\n"));
				goto err;
			}
			for (j=0; j<a_num; j++) {
				a_rec = *((char**)(rec+md[i].offset));
				if (Ju_free_X(a_mmd, a_rec+(a_mmd->struct_size*j))) {
					goto err;
				}
			}
			if (a_rec) {
				DBG(60, ("FREE %d\n", a_rec));
				free(a_rec);
				DBG(60, ("FreeEnd\n"));
			}
			break;
		default:
			LOG_ERR(("JU_free: Unknown Type(%d)", md[i].type));
			break;
		}
	}
	return 0;
err:
	return -1;
}

