/* %Z%META21 %M% %I% %D% %U% */

#ifndef _JU_CONV_
#define _JU_CONV_

#ifdef __cplusplus
extern "C" {
#endif

#include <jni.h>
#include <stddef.h>

/* tB[g^Cv */
#define M_STR		1	/* 		(String)	*/
#define M_BOOL		2	/* false/true		(boolean)	*/
#define M_BYTE		3	/* 1byte-int		(byte)		*/
#define M_SHRT		4	/* 2byte-int		(short)		*/
#define M_INT		5	/* 4byte-int		(int)		*/
#define M_LONG		6	/* 8byte-int		(long)		*/
#define M_ARRY		7	/* \̔z		(SomeClass[])	*/
#define M_BOOLARRY	8	/* booleanz		(boolean[])	*/
#define M_BARRY		9	/* bytez		(byte[])	*/
#define M_SARRY		10	/* shortz		(short[])	*/
#define M_IARRY		11	/* intz		(int[])		*/
#define M_LARRY		12	/* longz		(long[])	*/
#define M_STRARRY	13	/* z		(String[])	*/
#define M_SUBSTRCT	14	/* TuXgN`	(SomeClass)	*/

/* tB[h^f[^ */
typedef struct M_DATA_t {
        char    *name;          /* tB[h */
        int     type;           /* tB[h^Cv (M_XXX) */
        int     len;            /* f[^ */
        int     offset;         /* tB[hItZbg (C̃XgN`ł) */
        int     arry_n;         /* Œ蒷z̔z */
        char    *arrynumname;   /* z̃R[hLĂtB[h */
        char    *arryclsname;   /* z/TuXgN`̃NX̖O */
} M_DATA_t;

/* NX/\ ^f[^ */
typedef struct MM_DATA_t {
        char            *clsname;       /* Javał̃NX */
        int             *sp_flg;        /* tO(gp) */
        int             fld_n;          /* tB[h */
        int             struct_size;    /* Cł̍\̂̃TCY */
        M_DATA_t        *mdata;         /* M_DATA */
} MM_DATA_t;

/* M_DATA_t쐬p}N */
#define _M_SIZE(fldtype,fldname) (sizeof(((fldtype *)(0))->fldname))
#define M_D(fldtype, fldname, mfldtype) \
{ #fldname, mfldtype, _M_SIZE(fldtype, fldname), offsetof(fldtype, fldname), 0, "", "" }
#define M_DS(fldtype, fldname, mfldtype, size) \
{ #fldname, mfldtype, (size), offsetof(fldtype, fldname , 0, "", ""}
#define M_DA(fldtype, fldname, mfldtype, arrynumname, arryclsname) \
{ #fldname, mfldtype, _M_SIZE(fldtype, fldname), offsetof(fldtype, fldname), 0, arrynumname, arryclsname }
#define M_DB(fldtype, fldname, mfldtype) \
{ #fldname, mfldtype, _M_SIZE(fldtype, fldname[0]), offsetof(fldtype, fldname), (_M_SIZE(fldtype, fldname)/_M_SIZE(fldtype,fldname[0])), "", "" }
#define M_DSS(fldtype, fldname, mfldtype, arryclsname) \
{ #fldname, mfldtype, _M_SIZE(fldtype, fldname), offsetof(fldtype, fldname), 0, "", arryclsname }

/* MM_DATA_t쐬p}N */
#define MM_D(structtype, clsname, mdata) \
{ clsname, 0, sizeof(mdata)/sizeof((mdata)[0]), sizeof(structtype), mdata }

/* M_DATA_t錾 */
#if 0 /* ͎gĂȂȂ̂ŏƂFOTK */
extern M_DATA_t m_ColorReply[];
extern M_DATA_t m_ColorRecord[];
extern M_DATA_t m_StateRequest[];
#endif

/* MM_DATA_t錾 */
#if 0 /* .cXR[v̑ϐ{֐I/FpӁFOTK */
extern MM_DATA_t MM_data[];
extern int MM_LEN;
#else
extern MM_DATA_t *ju_get_MM_data_byindex( int index );
extern int        ju_get_MM_LEN( void );
#endif

/* ֐vg^Cv */
/* jniconv.c */
int JU_obj2classname(JNIEnv *env, jobject obj, char *retstr, int len);
int JU_clsname2mmd(char *clsname, MM_DATA_t **retmmd);
int JU_strname2mmd(char *strname, MM_DATA_t **retmmd);
int JU_fldname2md(MM_DATA_t *mmd, char *fldname, M_DATA_t **retmd);
int JU_mid2sig(int mid, char *optstr, char *ret, int retlen);
int JU_setnum(char *p, int offset, int dlen, long long val);
int JU_getnum(char *p, int offset, int dlen, long long *retval);
int JU_convert_j2c(JNIEnv *env, MM_DATA_t *mmdata, jobject obj, void *ret, char spc);
int JU_convert_c2j(JNIEnv *env, MM_DATA_t *mmdata, void *strct, jobject *obj);
int JU_free(MM_DATA_t *mmd, void *rec);
int JU_dbg_printstruct(MM_DATA_t *mmd, void *rec);

/* ju_exec.c */
int JU_exec_ap(char *apname, MM_DATA_t *req_mmd, void *req, MM_DATA_t *rsp_mmd, void *rsp);
int JU_get_request(char *strname, void **req);
void JU_free_request(char *strname, void *req);
int JU_put_response(char *strname, void *rsp);

/* jnistr.c */
int JU_NewStringSJIS(JNIEnv *env, char *sjis_str, int maxlen, jstring *retstrobj);
int JU_GetCharSJIS(JNIEnv *env, jstring utfstr, char *outbuf, int buflen);

/* ju_color.c */
jobject JU_getColorRec(JNIEnv *env, char *buf, int rec_n);

#ifdef __cplusplus
}
#endif

#endif /* _JU_CONV_ */
