#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>

#include	"life.h"


#define	BUFSIZE		128

typedef struct _q_tag {
	struct _q_tag	*next;
	int		index;
	char		tag[MAX_TAG_LEN];
} q_tag_t;

/* ѥ᡼̾ο */
static int	Param_num;

/*
 * ѥ᡼̾Υơ֥
 */
static char	ParamTab[MAX_PARAM_NUM][MAX_PARAM_LEN];

/*
 * ơ֥
 */
static q_tag_t	*ParamTagTab[MAX_PARAM_NUM];		/* ѥ᡼	*/
static char	VarTagTab[MAX_VAR_NUM][MAX_TAG_LEN];	/* ѿ		*/

static int isparam(int c);


/*****************************************************************************
 * ؿ̾
 *	getParamNum: Ͽѥ᡼
 * ǽ
 *	Ͽѥ᡼֤
 *
 *	
 *	1: 
 * 
 * ؿ
 *	>=0:	ѥ᡼
 * 
 *	"y_force", "y_add", "time_start", "time_end" ޤޤʤ
 *****************************************************************************/
int getParamNum()
{
	return Param_num - 4;
}
/*****************************************************************************
 * ؿ̾
 *	getEventParamNum: Ͽѥ᡼
 * ǽ
 *	Ͽѥ᡼֤
 *
 *	
 *	1: 
 * 
 * ؿ
 *	>=0:	ѥ᡼
 * 
 *	"y_force", "y_add", "time_start", "time_end" ޤࡣ
 *****************************************************************************/
int getEventParamNum()
{
	return Param_num;
}
/*****************************************************************************
 * ؿ̾
 *	Name2Pno: ѥ᡼No.
 * ǽ
 *	ѥ᡼̾Τѥ᡼No.Ĵ٤롣
 *
 *	
 *	1: 
 * 
 *	char *name;        I: ѥ᡼̾
 * ؿ
 *	>0:	ѥ᡼No.
 *	=0:	۾
 * 
 *****************************************************************************/
int Name2Pno(char *name)
{
	int	i, pno = 0;

	for( i = 0 ; i < Param_num ; i++ ){
		if( strcmp(name, &ParamTab[i][0]) != 0 )	continue;
		pno = i + 1;
		break;
	}

	return pno;
}
/*****************************************************************************
 * ؿ̾
 *	Pno2Name: ѥ᡼̾
 * ǽ
 *	ѥ᡼No.ѥ᡼̾ΤĴ٤롣
 *
 *	
 *	1: 
 * 
 *	int pno;        I: ѥ᡼No.
 * ؿ
 *	!=NULL:	ѥ᡼̾
 *	==NULL:	۾
 * 
 *****************************************************************************/
char *Pno2Name(int pno)
{
	if( pno < 1 || pno > Param_num ){
		return NULL;
	}

	return &ParamTab[pno - 1][0];
}
/*****************************************************************************
 * ؿ̾
 *	addParam2Tab: ѥ᡼̾ΤϿ
 * ǽ
 *	ѥ᡼̾Τơ֥Ͽ롣
 *
 *	
 *	1: 
 * 
 *	char *name;        I: ѥ᡼̾
 * ؿ
 *	0 :	
 *	-1:	۾
 * 
 *****************************************************************************/
int addParam2Tab(char *name)
{
	int	i;

	if( name == NULL || strlen(name) == 0 ){
		log_sys("ERROR: No Param Name Def.\n");
		goto err;
	}

	for( i = 0 ; i < MAX_PARAM_LEN ; i++ ){
		if( name[i] == '\0' )	break;

		if( !isparam(name[i]) ){
			log_sys("ERROR: Not Param Name[%s]\n", name);
			goto err;
		}
		ParamTab[Param_num][i] = name[i];
	}

	if( i >= MAX_PARAM_LEN ){
		log_sys("ERROR: Too Long Param Name[%s] > [%d]\n",
						name, MAX_PARAM_LEN - 1);
		goto err;
	}
	Param_num++;

	return 0;
err:
	return -1;
}
static int isparam(int c)
{
	if( isalnum(c) || c == '_' )	return 1;
	return 0;
}
/*****************************************************************************
 * ؿ̾
 *	isPno: ѥ᡼̾ΤΥѥ᡼No.Ǥ뤫Ĵ٤롣
 * ǽ
 *	ѥ᡼̾ΤΥѥ᡼No.Ǥ뤫Ĵ٤롣
 *
 *	
 *	1: 
 * 
 *	char *name;	I: ѥ᡼̾
 *	int pno;	I: ѥ᡼No.
 * ؿ
 *	0 :	԰
 *	1:	
 * 
 *****************************************************************************/
int isPno(char *name, int pno)
{
	if( strcmp(name, &ParamTab[pno - 1][0]) == 0 )	return 1;
	return 0;
}
/*****************************************************************************
 * ؿ̾
 *	getParamTag: ѥ᡼ʸμ
 * ǽ
 *	ѥ᡼Υʸ롣
 *
 *	
 *	1: 
 * 
 *	int pno;	I: ѥ᡼No.
 *	int index;	I: ѥ᡼ǥå
 * ؿ
 *	!=NULL:	ѥ᡼ʸ
 *	==NULL:	۾
 * 
 *****************************************************************************/
char *getParamTag(int pno, int index)
{
	q_tag_t	*q;
	char	*tag = NULL;

	for( q = ParamTagTab[pno - 1] ; q != NULL ; q = q->next ){
		if( q->index == index ){
			tag = q->tag;
			break;
		}
	}

	return tag;
}
/*****************************************************************************
 * ؿ̾
 *	putParamTag: ѥ᡼ʸϿ
 * ǽ
 *	ѥ᡼ΥʸϿ롣
 *
 *	
 *	1: 
 * 
 *	int pno;	I: ѥ᡼No.
 *	int index;	I: ѥ᡼ǥå
 *	char *tag;	I: ѥ᡼ʸ
 * ؿ
 *	0 :	
 *	-1:	۾
 * 
 *	ɬfreeParamTag() Ƥΰ뤳ȡ
 *****************************************************************************/
int putParamTag(int pno, int index, char *tag)
{
	q_tag_t	*topq = ParamTagTab[pno - 1];
	size_t	size;
	q_tag_t	*q = NULL;

	size = sizeof(q_tag_t);
	q = (q_tag_t *) malloc(size);
	if( q == NULL ){
		goto err;
	}
	memset(q, 0, size);
	memcpy(q->tag, tag, MAX_TAG_LEN - 1);
	q->index = index;
	q->next = topq;
	ParamTagTab[pno - 1] = q;

	return 0;
err:
	if( q )	free(q);
	return -1;
}
/*****************************************************************************
 * ؿ̾
 *	freeParamTag: ѥ᡼ʸ¸ΰγ
 * ǽ
 *	ƤΥѥ᡼ʸ¸ΰ롣
 *
 *	
 *	1: 
 * 
 *	̵
 * ؿ
 *	̵
 * 
 *****************************************************************************/
void freeParamTag()
{
	int	i;
	q_tag_t	*q, *tmpq;

	for( i = 0 ; i < MAX_PARAM_NUM ; i++ ){
		for( q = ParamTagTab[i] ; q != NULL ; ){
			tmpq = q->next;
			free(q);
			q = tmpq;
		}
		ParamTagTab[i] = NULL;
	}
}
/*****************************************************************************
 * ؿ̾
 *	getVarTag: ѿʸμ
 * ǽ
 *	ѿΥʸ롣
 *
 *	
 *	1: 
 * 
 *	int index;	I: ѿǥå
 * ؿ
 *	!=NULL:	ѿʸ
 *	==NULL:	۾
 * 
 *****************************************************************************/
char *getVarTag(int index)
{
	return &VarTagTab[index - 1][0];
}
/*****************************************************************************
 * ؿ̾
 *	putVarTag: ѿʸϿ
 * ǽ
 *	ѿΥʸϿ롣
 *
 *	
 *	1: 
 * 
 *	int index;	I: ѿǥå
 *	char *tag;	I: ѿʸ
 * ؿ
 *	0 :	
 *	-1:	۾
 * 
 *****************************************************************************/
int putVarTag(int index, char *tag)
{
	if( index < 1 || index > MAX_VAR_NUM ){
		goto err;
	}
	memcpy(&VarTagTab[index - 1][0], tag, MAX_TAG_LEN - 1);

	return 0;
err:
	return -1;
}
