/* *************************************************************************
 *
 *
 *
 */

#include "life.h"


/* եstaticؿΥץȥ */
static int readInputData(char **fname, double y[], double *t_start,
	double *t_end, double *h, double *dt_save, start_val startParam[], int *n_sval);
static int getInputData(char cdata[][MAX_LINE], FILE *inp_file);
static int makeline(char *aline, FILE *inp_file);
static int checkControlData();
static int setTEventData(char cdata[][MAX_LINE]);
static int setParamData(int n_inp, char cdata[][MAX_LINE],
			   	start_val startParam[], int *n_sval);
static int getStartParam(char cdata[][MAX_LINE], int p_no, start_val startParam[]);
static int checkInputData(double t_start, double t_end, double h, double dt_save);
static void setStartParam(start_val startParam[], int n_sval);
static int tcmp(const Event *x, const Event *y);


/*---------------- Set_data() ------------------------------------------
 *
 * ϥǡɤ߹ǳѿ˳Ǽ롣
 *
 */
int Set_data(double y[], double *t_start, double *t_end, double *h, double *dt_save,
			   							char **fname)
{
	int n_sval;
	start_val startParam[MAX_PARAM_NUM*MAX_VAR_NUM];
	
	 /* ϥǡɤ߹ */
	if (readInputData(fname, y, t_start, t_end, h, dt_save, startParam, &n_sval)) goto err;

	 /* ϥǡΥå */
	if (checkInputData(*t_start, *t_end, *h, *dt_save)) goto err;

	 /* 諒СǤѿ */
	if (SolverNo > 10) ParamT.n_varNR = ParamT.n_var;
	
	Param = ParamT;	 /* ParamT ɤ߹ͤParam˥ԡ */

	 /* Param˥ͤꤹ */
	setStartParam(startParam, n_sval);

	ParamP = Param;	 /* ParamP()Paramͤ򥳥ԡ */

	/* ।٥ȤΥǡˡtime_start/time_end ɲá */
	if( EventsNum < MAX_EVENT_NUM - 2 ){
		Events[EventsNum].p_no	= Name2Pno(TIME_START);
		Events[EventsNum].index	= 0;
		Events[EventsNum].time	= *t_start;
		Events[EventsNum].value	= 0;
		EventsNum++;
		Events[EventsNum].p_no	= Name2Pno(TIME_END);
		Events[EventsNum].index	= 0;
		Events[EventsNum].time	= *t_end;
		Events[EventsNum].value	= 0;
		EventsNum++;
	}else{
		log_sys("## Too many time events!! Max:%3d\n", MAX_EVENT_NUM - 2);
		goto err;
	}

	 /* ।٥ȤΥǡֽ˥Ȥ */
	if (EventsNum > 1) 
		qsort(Events, EventsNum, sizeof(Event), (int(*)(const void*, const void*))tcmp);

	return 0;

err:
	log_sys("## Error!!  in Set_data.\n");
	return -1;
}

/*----------------readInputData------------------------------------------
 *
 * ϥǡե뤫ºݤ˥ǡɤ߹ParamTꤹ
 *
 * I:fname
 * O:y, t_start, t_end, h, dt_save, startParam, n_sval
 */
static int readInputData(char **fname, double y[], double *t_start, double *t_end,
			   	double *h, double *dt_save, start_val startParam[], int *n_sval)
{
	int i, nvar=0, index, n_inp, f_Ystart[MAX_VAR_NUM];
	static char cdata[MAX_CDATA_NUM][MAX_LINE];
	FILE *fp_in;

	 /* ϥǡեΥץ */
	if((fp_in = fopen(fname[FILE_IN], "r")) == NULL){
		printf("Cannot open %s\n", fname[FILE_IN]);
		goto err;
	}
		
	for (;;) {	 /* ȥǡɤ߹롼 */
		n_inp = getInputData(cdata, fp_in);	 /* 1ԤǥߥǶڤäcdataɤ߹ */
		if (n_inp<0) {
			break;
		} else if (n_inp>0) {
#ifdef DBG
			DBGW(1, ("n=%2d:", n_inp));
			for (i=0; i<n_inp; i++) DBGW(1, ("%s;\t", cdata[i]));
			DBGW(1, ("\n"));
#endif
			if (strcmp(cdata[0],"SOLVER")==0)	SolverNo	= atoi(cdata[1]);
			if (strcmp(cdata[0],"P_SURVEY")==0)	F_PSurvey	= atoi(cdata[1]);
			if (strcmp(cdata[0],"PARALLEL")==0)	F_Parallel	= atoi(cdata[1]);
			if (strcmp(cdata[0],"NUMERICAL_JAC")==0)	F_Numerical_Jac	= atoi(cdata[1]);
			if (strcmp(cdata[0],"NR_TRIAL")==0)	Nr_trial	= atoi(cdata[1]);
			if (strcmp(cdata[0],"NR_TOL_F")==0)	Nr_tol_f	= atof(cdata[1]);
			if (strcmp(cdata[0],"NR_TOL_X")==0)	Nr_tol_x	= atof(cdata[1]);
			if (strcmp(cdata[0],"RK_EPS")==0)	Rk_eps	= atof(cdata[1]);
			if (strcmp(cdata[0],"NR_RATIO")==0)	Nr_ratio	= atof(cdata[1]);
			if (strcmp(cdata[0],"NR_SENS_CW")==0)	Nr_sens_cw	= atof(cdata[1]);
			if (strcmp(cdata[0],"Y_DEFAULT")==0)	Y_default	= atof(cdata[1]);
			if (strcmp(cdata[0],"N_VAR")==0)	ParamT.n_var	= atoi(cdata[1]);
			if (strcmp(cdata[0],"N_ALGEBR")==0)	ParamT.n_varNR	= atoi(cdata[1]);
			if (strcmp(cdata[0],"G_VALUE")==0)	GeneConc	= atof(cdata[1]);
			if (strcmp(cdata[0],"PARAM_NAME")==0){
				if( addParam2Tab(cdata[1]) < 0 ){
					log_sys("## Param error!!\n");
					goto err;
				}
			}
		}
	}	 /* end of file read loop. */

	 /* ѥ᡼̾Υơ֥ˡy_force, y_add ɲá */
	if( addParam2Tab(Y_FORCE) < 0 || addParam2Tab(Y_ADD) < 0 ){
		log_sys("## Param error!!\n");
		goto err;
	}

	 /* ѥ᡼̾Υơ֥ˡtime_start, time_end ɲá */
	if( addParam2Tab(TIME_START) < 0 || addParam2Tab(TIME_END) < 0 ){
		log_sys("## Param error!!\n");
		goto err;
	}

	 /* ȥǡΥå */
	if (checkControlData()) goto err;
	
	 /* YνͤåȤƤ뤫ݤΥե饰ե磻 */
	for (i=0; i<MAX_VAR_NUM; i++) f_Ystart[i] = 0;
	rewind(fp_in);

	for (;;) {	 /* ѥ᡼ͤɤ߹롼 */
		n_inp = getInputData(cdata, fp_in);  /* 1ԤǥߥǶڤäcdataɤ߹ */
		if (n_inp<0) {
			break;
		} else if (n_inp>0) {
#ifdef DBG
			DBGW(1, ("n=%2d:", n_inp));
			for (i=0; i<n_inp; i++) DBGW(1, ("%s;\t", cdata[i]));
			DBGW(1, ("\n"));
#endif
			if (SolverNo < 10) {	 /* ȯŸСξ */
				if (strcmp(cdata[0],"T_START")==0)	*t_start	= atof(cdata[1]);
				if (strcmp(cdata[0],"T_END")==0)	*t_end	= atof(cdata[1]);
				if (strcmp(cdata[0],"DELTA_T")==0)	*h	= atof(cdata[1]);
				if (strcmp(cdata[0],"DELTA_M")==0)	*dt_save	= atof(cdata[1]);
				if (strcmp(cdata[0],"T_EVENT")==0)	setTEventData(cdata);
				if (strcmp(cdata[0],"NDF_RTOL")==0)	Ndf_rtol	= atof(cdata[1]);
				if (strcmp(cdata[0],"NDF_ATOL")==0)	Ndf_atol	= atof(cdata[1]);
			}
			if (strcmp(cdata[0],"PARAM")==0) {
				if (setParamData(n_inp, cdata, startParam, n_sval)) goto err;
			}
			if (strcmp(cdata[0],"Y_START")==0)	{	 /* Yνͤɤ߹ */
				index = atoi(cdata[1]);
				if (index < 1 || index > ParamT.n_var) {
					log_sys("## Data error!! Iinappropriate index in Y_START.\n");
					goto err;
				}
				if (strlen(cdata[2]) > 0) {
					y[index] = atof(cdata[2]);
				} else {
					y[index] = Y_default;
				}
				if (f_Ystart[index]) {	 /* Y_START2ŤꤵƤ */
					log_sys("## Data error!! Duplicate Y_START. Index = %d\n", index);
					goto err;
				}
				f_Ystart[index] = 1;	 /* ͤɤ߹Τˤϥե饰ΩƤ */
				/*
				 * ѿ
				 */
				if( putVarTag(index, cdata[3]) < 0 ){
					log_sys("## Data error!! Tag Index = %d\n", index);
					goto err;
				}
				nvar++;
			}
		}
	}	 /* end of file read loop. */

	fclose(fp_in); fp_in = NULL;

	if (nvar < ParamT.n_var) {	 /* Y_START꤬ƤyФƤƤʤ */
		log_sys("This case have %3d variables. Bat initial data has %3d.\n",
					ParamT.n_var, nvar);
		log_sys("fill with default value : %10.3E\n", Y_default);
	} else if (nvar > ParamT.n_var) {	 /* Y_START꤬yο¿ */
		log_sys("## Data error!! too many Y_START.\n");
		goto err;
	}
	
	 /* Y_START * G_VALUEyͤȤ */
	 /* Y_STARTꤵƤʤäyФƤϥǥեͤ */
	for (i=1; i<=ParamT.n_var; i++) {
		if (f_Ystart[i]) {
			y[i] *= GeneConc;
		} else {
			y[i] = Y_default*GeneConc;
		}
	}

	/* NDF abs_tol  G-value 򤫤ΤȤ롣 2003.03.26 */
#if 0	/*  2004.04.10 */
	Ndf_atol = Ndf_atol*GeneConc;
#endif

	return 0;

err:
	log_sys("## Error!!  in readInputData.\n");
	if (fp_in != NULL) fclose(fp_in); fp_in = NULL;
	return -1;
}

#define LT_NORM		0   /* ordinary line */
#define LT_EMPTY	1   /* empty line */
#define LT_EOF		9   /* end of file */

 /*----------------getInputData------------------------------------------
  *
  * ϥǡԤɤ߹ߤǥȤǥߥʬ䤷cdata֤
  *
  *	I:*inp_file
  *	O:cdata
  *	꥿͡cdataǿ
  *
  */
static int getInputData(char cdata[][MAX_LINE], FILE *inp_file)
{
	char aline[MAX_LINE];
	int  ltype;
	int  i=0, j=0;
	char *cp, delim=';';

	ltype = makeline(aline, inp_file);
	if (ltype == LT_EOF) {	 /* եνüξ */
		return -1;
	} else if (ltype == LT_EMPTY) {	 /* ǡΤʤԤξ */
		return 0;
	} else if (ltype == LT_NORM) {	 /* ǡΤԤξ */
		cp = aline;
		i=0;
		j=0;
		for (;;) {	 /* βϥ롼 */
			if (*cp=='\n' || *cp=='\0') {
				if (j>0) {	 /* cdataκǸǤǤкǸNULL­ */
					cdata[i][j] = '\0';
					i++;
				}
				break;
			} else if (*cp==delim) {
				cdata[i][j] = '\0';
				j=0;
				cp++;
				i++;
				if (i > MAX_CDATA_NUM-1) goto err;
			} else {
				cdata[i][j++] = *cp++;
			}
		}
	}
	return i;	 /* ǡԤξϤǿ֤ */

err:
	log_sys("#  line : '%s'.\n", aline);
	log_sys("## ERROR!! Too many data in a line.\n");
	exit(-1);
}

 /*----------------makeline------------------------------------------
  *
  * ϥǡԤɤ߹ߡȡ򡢥֤aline֤
  *
  *	I:*inp_file
  *	O:aline
  *	꥿͡ԤơEOF(LT_EOF),ǡ̵(LT_EMPTY),ǡͭ(LT_NORM)
  *
  */
static int makeline(char *aline, FILE *inp_file)
{
	register char *cpt;
	register char *cpa;
	char tline[MAX_LINE];
	int cnt=0;

	 /* 1ɤ߹ */
	if (fgets(tline, sizeof tline, inp_file) == NULL) return LT_EOF;

	cpt = tline;	 /* ե뤫ɤԤΥݥ */
	cpa = aline;	 /* ̤Ȥ֤ԤΥݥ */

	for (; *cpt; ) {	 /* ϤΥ롼 */
		if (*cpt == '\n' || *cpt == '\0' || *cpt == '#') {
			break;
		} else if (*cpt == ' ' || *cpt == '\t') {	
			cpt++;
		} else {
	   		*(cpa++) = *(cpt++);
			cnt++;
		}
	}

	if (cnt == 0) {	 /* ͭʥǡʤ */
		return LT_EMPTY;
	} else {
		*cpa++ = '\n';
		*cpa   = '\0';
		return LT_NORM;
	}
}

#undef LT_NORM
#undef LT_EMPTY
#undef LT_EOF

 /*----------------checkControlData------------------------------------------
  *
  * ɤ߹ȥǡͤɤå
  *
  *	I:ʤ
  *	O:ʤ
  *	꥿͡(0)۾(-1)
  *
  */
static int checkControlData()
{
	 /* check Solver No. */
	if (SolverNo < 1 || SolverNo > MAX_SOLVER_NO ) {
		log_sys("## Data error!! in SOLVER\n");
		goto err;
	}

	 /* check parameter suevey flag. */
	if (F_PSurvey < 0 || F_PSurvey > 1 ) {
		log_sys("## Data error!! in P_SURVEY\n");
		goto err;
	}

	 /* check parallel flag. */
	if (F_Parallel < 0 || F_Parallel > 1 ) {
		log_sys("## Data error!! in PARALLEL\n");
		goto err;
	}

	 /* check numerical jacobian flag. */
	if (F_Numerical_Jac < 0 || F_Numerical_Jac > 1 ) {
		log_sys("## Data error!! in NUMERICAL_JAC\n");
		goto err;
	}

	 /* check NR_TRIAL. */
	if (Nr_trial < 1) {
		log_sys("## Data error!! in NR_TRIAL\n");
		goto err;
	}

	 /* check NR_TOL_F. */
	if (Nr_tol_f < TINY) {
		log_sys("## Data error!! in NR_TOL_F\n");
		goto err;
	}

	 /* check NR_TOL_X. */
	if (Nr_tol_x < TINY) {
		log_sys("## Data error!! in NR_TOL_X\n");
		goto err;
	}

	 /* check RK_EPS. */
	if (Rk_eps < TINY) {
		log_sys("## Data error!! in RK_EPS\n");
		goto err;
	}

	 /* check NR_RATIO. */
	if (Nr_ratio <= 1.0 || Nr_ratio > 10.0) {
		log_sys("## Data error!! in NR_RATIO\n");
		goto err;
	}

	 /* check Y_DEFAULT. */
	if (Y_default < TINY) {
		log_sys("## Data error!! in Y_DEFAULT\n");
		goto err;
	}

	 /* check number of variables. */
	if (ParamT.n_var < 1 || ParamT.n_var > MAX_VAR_NUM) {
		log_sys("## Data error!! in N_VAR\n");
		goto err;
	}

	 /* check number of variables which is used for algebraic equations in time solver. */
	if (ParamT.n_varNR < 0 || ParamT.n_varNR > MAX_VAR_NUM) {
		log_sys("## Data error!! in N_ALGEBR\n");
		goto err;
	}

	 /* check gene concentration value. */
	if (GeneConc <= 0.0) {
		log_sys("## Data error!! in G_Value\n");
		goto err;
	}
	
	return 0;

err:
	log_sys("## Error!!  in checkControlData.\n");
	return -1;
}

 /*----------------setTEventData------------------------------------------
  *
  * ।٥ȤΥǡEvents¤Τ˥åȤ
  *
  *	I:cdata
  *	O:ʤʥХEvents¤Τ˳Ǽ)
  *
  */
static int setTEventData(char cdata[][MAX_LINE])
{
	int p_no, index;

	if (strlen(cdata[1])==0 || strlen(cdata[2])==0 || 
			strlen(cdata[3])==0 || strlen(cdata[4])==0) {
		log_sys("## Data error!! in T_EVENT.\n");
		goto err;
	}

	 /* ɤΥѥ᡼ФΤǤ뤫Ƚ */
	p_no = Name2Pno(cdata[1]);
	if( p_no == 0 ){
		log_sys("## Wrong input data!! In :%s, %s\n", cdata[0], cdata[1]);
		goto err;
	}

	index = atoi(cdata[2]);
	if (index < 1 ) {
		 /* ꤨʤindexξ */
		log_sys("## Data error!! in T_EVENT. Inappropriate index.\n");
		log_sys("##	 parameter: %s  index: %d \n", cdata[1], index);
		goto err;
	}
	if ((p_no == Name2Pno(Y_FORCE) || p_no == Name2Pno(Y_ADD))
	 && index <= ParamT.n_varNR) {
		 /* ꤨʤindexξ(y_add,y_force) */
		log_sys("## Data error!! in T_EVENT. Index of y must be between N_ALGEBR+1 and N_VAR.\n");
		log_sys("##	 %s  index: %d \n", cdata[1], index);
		goto err;
	}

	 /* ।٥ȤEvents¤Τ˽񤭹 */
	if (EventsNum<MAX_EVENT_NUM) {
		Events[EventsNum].p_no	= p_no;
		Events[EventsNum].index	= index;
		Events[EventsNum].time	= atof(cdata[3]);
		if( strcmp(cdata[1], CONSTANT_PLAYER) == 0 ||
			strcmp(cdata[1], "y_add") == 0 || strcmp(cdata[1], "y_force") == 0 ){
			Events[EventsNum].value	= atof(cdata[4])*GeneConc;
		} else {
			Events[EventsNum].value	= atof(cdata[4]);
		}
		EventsNum++;
	} else {
		log_sys("## Too many time events!! Max:%3d\n", MAX_EVENT_NUM);
		goto err;
	}

	return 0;

err:
	log_sys("## Error!!  in setTEventData.\n");
	return -1;
}

/*----------------setParamData------------------------------------------
 *
 * ƥѥ᡼Υǡcdataɤ߼äParamTstartParam¤Τ˥åȤ
 *
 *	I:n_inp, cdata
 *	O:startParam, n_svalʥХParamT,P_Survey¤ΤˤͤǼ)
 *	꥿͡ʤ
 *
 */
static int
setParamData(int n_inp, char cdata[][MAX_LINE], start_val startParam[], int *n_sval)
{
	int p_no, index, steps, f_isArithmetic=true;
	double value, change_value;

	index = atoi(cdata[2]);
	if (index < 1) {	 /* ꤨʤindex */
		log_sys("## Data error!! Inappropriate index in PARAM.\n");
		log_sys("##	 parameter: %s  index: %d \n", cdata[1], index);
		goto err;
	}
	if (strlen(cdata[3]) == 0) {	 /* ͤʤ */
		log_sys("## Data error!! in PARAM. Missing value.\n");
		goto err;
	}

	 /* ParamT,startParam˥ǡ򥻥å */
	value = atof(cdata[3]);
	p_no = Name2Pno(cdata[1]);
	if( p_no == 0 ){
		log_sys("## Data error!! In :%s, %s\n", cdata[0], cdata[1]);
		goto err;
	}
	if( strcmp(cdata[1], CONSTANT_PLAYER) == 0 ) value *= GeneConc;
	ParamT.val[p_no][index] = value;
	ParamT.n_val[p_no]++;
	*n_sval = getStartParam(cdata, p_no, startParam);

	steps = atoi(cdata[5]);
	if (steps) {	 /* ѥ᡼٥ONξ */
		if (steps < 2) {
			log_sys("## Data error!! Inappropriate parameter survey steps in PARAM.\n");
			goto err;
		}

		 /* ѥ᡼οΥפ */
		if (strncmp(cdata[6], "D", 1) == 0) {		 /* DŪѲ */
			f_isArithmetic = true;
		} else if (strncmp(cdata[6], "R", 1) == 0) {	 /* RŪѲ */
			f_isArithmetic = false;
		} else {								 /* ʳϤʤ */
			log_sys("## Data error!! in PARAM.\n");
			log_sys("   Parameter survey type:'%s' is inappropriate.\n", cdata[6]);
			log_sys("   It must be 'D' or 'R'. (D:Arithmetic, R:Geometric)\n");
			goto err;
		}

		 /* ѹ̵ͤͭΥå */
		if (strlen(cdata[7])==0) {
			log_sys("## Data error!! in PARAM. Lack of parameter survey value.\n");
			goto err;
		}
		change_value = atof(cdata[7]);

		if (F_PSurvey) {
			if (strcmp(cdata[1], CONSTANT_PLAYER) == 0 ) {
				log_sys("#Survey: %14s; Base=%10.3e, %10s=%10.3e, num=%d\n",
						cdata[1], value/GeneConc,
						f_isArithmetic ? "Difference" : "Ratio", change_value, steps);
			} else {
				log_sys("#Survey: %14s; Base=%10.3e, %10s=%10.3e, num=%d\n",
						cdata[1], value,
						f_isArithmetic ? "Difference" : "Ratio", change_value, steps);
			}
		}
		
		if (f_isArithmetic == true && strcmp(cdata[1], CONSTANT_PLAYER) == 0) {
			change_value *= GeneConc;
		}

		 /* ͤΥå */
		if (f_isArithmetic == true && change_value == 0.0) {
			log_sys("## Data error!! in PARAM. Inappropriate parameter survey value.\n");
			log_sys("##	When you specify arithmetic type, the diff-value must not be 0.\n");
			goto err;
		}
		if (f_isArithmetic == false && (change_value == 1.0 || change_value <= 0.0 || value == 0.0)) {
			log_sys("## Data error!! in PARAM. Inappropriate parameter survey value.\n");
			log_sys("##	When you specify geometric type, the ratio must be plus( <>1).\n");
			goto err;
		}

		 /* ٥ͤP_Survey˳Ǽ */
		if (P_SurveyNum<MAX_P_SURVEY) {	 /* ǤХ٥ͤP_Survey˳Ǽ */
			P_Survey[P_SurveyNum].p_no = p_no;
			P_Survey[P_SurveyNum].index = index;
			P_Survey[P_SurveyNum].steps = steps;
			P_Survey[P_SurveyNum].f_isArithmetic = f_isArithmetic;
			P_Survey[P_SurveyNum].start_value = value;
			P_Survey[P_SurveyNum].change_value = change_value;
			P_SurveyNum++;
		} else {
			log_sys("## Too many parameter survey sets!! Max:%2d\n", MAX_P_SURVEY);
			goto err;
		}
	}

	/*
	 * GAΥѥ᡼
	 */
	if (strncmp(cdata[6], "S", 1) == 0){
		double	min_val;		/* ΰκǾ */
		double	max_val;		/* ΰκ	*/
		F_GA = 1;	
	
		/* ѥ᡼٥Բ */
		if(F_PSurvey){
			log_sys("## Parameter survey and GAs cannot concurrent use.\n");
			goto err;
		}

		/* Ǿͤ͡ϾάԲ */
		if(strlen(cdata[8]) == 0 || strlen(cdata[9]) == 0){
			log_sys("## Region's min(max) value cannot be omitted.\n");
			goto err;
		}

		min_val = atof(cdata[8]);
		max_val = atof(cdata[9]);

		/* ͤ¤Τ˳Ǽ */
		if (P_GaNum<MAX_P_GA){
			P_Ga[P_GaNum].p_no = p_no;
			P_Ga[P_GaNum].index = index;
			P_Ga[P_GaNum].min_value = min_val;
			P_Ga[P_GaNum].max_value = max_val;
			P_GaNum++;
		} else {
			log_sys("## Too many parameter to run GAs!! Max:%2d\n", MAX_P_GA);
			goto err;
		}
	}
		
	/*
	 * ѥ᡼
	 */
	if( putParamTag(p_no, index, cdata[10]) < 0 ){
		log_sys("## putParamTag(%s) Failed\n", cdata[10]);
		goto err;
	}

	return 0;

err:
	log_sys("%s\t;\t%s;\t%s;\t%s;\t%s;\t%s;\t%s;\t%s;\t%s;\t%s;\n",
		cdata[0], cdata[1], cdata[2], cdata[3], cdata[4],
		cdata[5], cdata[6], cdata[7], cdata[8], cdata[9], cdata[10]);
	log_sys("## Error!!  in setParamData.\n");

	return -1;
}

/*----------------getStartParam------------------------------------------
 *
 * ѥ᡼˥ͤꤵƤɤ߹startParam֤
 *
 *	I:cdata, p_no
 *	O:startParam
 *	꥿͡cnt(ͤꤵƤ߷)
 *
 */
static int getStartParam(char cdata[][MAX_LINE], int p_no, start_val startParam[])
{
	static int cnt=0;

	if (strlen(cdata[4])) {
		startParam[cnt].p_no = p_no;
		startParam[cnt].index = atoi(cdata[2]);
		startParam[cnt].value = atof(cdata[4]);
		cnt++;
	}
	return cnt;
}

/*----------------checkInputData------------------------------------------
 *
 * ˻ȯŸСѤΥȥǡΥå
 *
 *	I:t_start, t_end, h, dt_save
 *	O:ʤ
 *	꥿͡(0)۾(-1)
 *
 */
static int checkInputData(double t_start, double t_end, double h, double dt_save)
{

	if (SolverNo < 10) {
		 /* check start time. */
		if (t_start != 0.0) {
			log_sys("Start time is not 0.\n");
		}

		 /* check end time. */
		if (t_end <= t_start) {
			log_sys("## Data error!! in T_START or T_END\n");
			goto err;
		}

		 /* check time step width. */
		if (h < TINY) {
			log_sys("## Data error!! in DELTA_T\n");
			goto err;
		}

		 /* check monitoring interval. */
		if (dt_save < h) {
			log_sys("## Data error!! in DELTA_M\n");
			goto err;
		}
	}

	 /* check number of variables which is used for algebraic equations in time solver. */
	if (ParamT.n_varNR < 0 || ParamT.n_varNR > ParamT.n_var) {
		log_sys("## Data error!! in N_ALGEBR\n");
		goto err;
	}

	return 0;

err:
	log_sys("## Error!!  in checkInputData.\n");
	return -1;
}

/*----------------setStartParam------------------------------------------
 *
 * startParamParamǼ롣
 *
 *	I:startParam, n_sval
 *	O:ʤParam¤Τ˳Ǽ)
 *	꥿͡ʤ
 *
 */
static void setStartParam(start_val startParam[], int n_sval)
{
	int i;

	for (i=0; i<n_sval; i++) {
		Param.val[startParam[i].p_no][startParam[i].index]
						= startParam[i].value;
	}
}
					
/*----------------tcmp------------------------------------------
 *
 * Events¤ΤΥȤ
 *
 *	I:x, y
 *	O:ʤ
 *	꥿͡Ӥ2Ĥͤ羮طˤ-1, 0, 1
 *
 */
static int tcmp(const Event *x, const Event *y)
{
	return (x->time < y->time ? -1 :
			x->time > y->time ?  1 : 0);
}
