#include <stdio.h>
#include <stdlib.h>

#include "utl_alloc.h"
#include "logUtil.h"
/*-----
 * IntVectorAllocؿ
 * 	ǻꤵ줿礭int
 * 	ΰݤƬΥݥ󥿤֤
 */
int *IntVectorAlloc(int vector_size)
{
	int	*temp;

#ifdef DBG
	DBGW(10, ("IntVectorAlloc enter.\n"));
#endif /* DBG */

	temp = (int *)malloc((size_t)vector_size * sizeof(int));
	if (temp == NULL) {
		log_sys(" ## Error: Cannot allocate memory(In IntVectorAlloc).\n");
	}

#ifdef DBG
	DBGW(10, ("IntVectorAlloc exit\n"));
#endif /* DBG */

	return temp;
}

/*-----
 * FreeIntVectorؿ
 * 	ǻꤵ줿ΰ
 */
void FreeIntVector(int *int_vector)
{
#ifdef DBG
	DBGW(10, ("FreeIntVector enter.\n"));
#endif /* DBG */
	free(int_vector);
#ifdef DBG
	DBGW(10, ("FreeIntVector exit\n"));
#endif /* DBG */

}

/*-----
 * IntMatrixAllocؿ
 * 	ǻꤵ줿礭intι
 * 	ΰݤƬΥݥ󥿤֤
 */
int **IntMatrixAlloc(int num_row, int num_col)
{
	int	i;
	int	**temp = NULL;

#ifdef DBG
	DBGW(10, ("IntMatrixAlloc enter.\n"));
#endif /* DBG */

	temp = (int **)malloc((size_t)num_row * sizeof(int*));
	if(temp == NULL) {
		log_sys(" ## Error: Cannot allocate memory(In IntMatrixAlloc 1).\n");
		goto err;
	}

	temp[0] = (int *)malloc((size_t)(num_row*num_col)*sizeof(int));
	if(temp[0] == NULL){
		log_sys(" ## Error: Cannot allocate memory(In IntMatrixAlloc 2).\n");
		goto err;
	}

	for(i = 1; i < num_row; i++) temp[i] = temp[i-1] + num_col;

#ifdef DBG
	DBGW(10, ("IntMatrixAlloc exit\n"));
#endif /* DBG */

	return temp;
err:
	if(temp != NULL) free(temp);

#ifdef DBG
	DBGW(10, ("IntMatrixAlloc error exit\n"));
#endif /* DBG */

	return NULL;
}

/*-----
 * FreeIntMatrixؿ
 * 	ǻꤵ줿ΰ
 */
void FreeIntMatrix(int **int_mat)
{
#ifdef DBG
	DBGW(10, ("FreeIntMatrix enter.\n"));
#endif /* DBG */

	free(int_mat[0]);
	free(int_mat);

#ifdef DBG
	DBGW(10, ("FreeIntMatrix exit\n"));
#endif /* DBG */
}

/*-----
 * DoubleVectorAllocؿ
 * 	ǻꤵ줿礭GaGene_T
 * 	ΰݤƬΥݥ󥿤֤
 */
double *DoubleVectorAlloc(int vector_size)
{
	double	*temp;

#ifdef DBG
	DBGW(10, ("DoubleVectorAlloc enter.\n"));
#endif /* DBG */

	temp = (double *)malloc((size_t)vector_size * sizeof(double));
	if (temp == NULL) {
		log_sys(" ## Error: Cannot allocate memory(In DoubleVectorAlloc).\n");
	}

#ifdef DBG
	DBGW(10, ("DoubleVectorAlloc exit\n"));
#endif /* DBG */

	return temp;
}

/*-----
 * FreeDoubleVectorؿ
 * 	ǻꤵ줿ΰ
 */
void FreeDoubleVector(double *double_vector)
{
#ifdef DBG
	DBGW(10, ("FreeDoubleVector enter.\n"));
#endif /* DBG */

	free(double_vector);

#ifdef DBG
	DBGW(10, ("FreeDoubleVector exit\n"));
#endif /* DBG */

}
	
/*-----
 * DoubleMatrixAllocؿ
 * 	ǻꤵ줿礭GaGene_Tι
 * 	ΰݤƬΥݥ󥿤֤
 */
double **DoubleMatrixAlloc(int num_row, int num_col)
{
	int	i;
	double	**temp = NULL;

#ifdef DBG
	DBGW(10, ("DoubleMatrixAlloc enter.\n"));
#endif /* DBG */

	temp = (double **)malloc((size_t)num_row * sizeof(double*));
	if(temp == NULL) {
		log_sys(" ## Error: Cannot allocate memory(In DoubleMatrixAlloc 1).\n");
		goto err;
	}

	temp[0] = (double *)malloc((size_t)(num_row*num_col)*sizeof(double));
	if(temp[0] == NULL){
		log_sys(" ## Error: Cannot allocate memory(In DoubleMatrixAlloc 2).\n");
		goto err;
	}

	for(i = 1; i < num_row; i++) temp[i] = temp[i-1] + num_col;

#ifdef DBG
	DBGW(10, ("DoubleMatrixAlloc exit\n"));
#endif /* DBG */

	return temp;
err:
	if(temp != NULL) free(temp);

#ifdef DBG
	DBGW(10, ("DoubleMatrixAlloc error exit\n"));
#endif /* DBG */

	return NULL;
}

/*-----
 * FreeDoubleMatrixؿ
 * 	ǻꤵ줿ΰ
 */
void FreeDoubleMatrix(double **double_mat)
{
#ifdef DBG
	DBGW(10, ("FreeDoubleMatrix enter.\n"));
#endif /* DBG */

	free(double_mat[0]);
	free(double_mat);

#ifdef DBG
	DBGW(10, ("FreeDoubleMatrix exit\n"));
#endif /* DBG */
}
