#ifndef lint
static char *cvsid = "@(#) C $Id: c_que.c,v 1.1.1.1 2001/03/13 04:32:11 osss Exp $";
#endif

#include <stdlib.h>

/*
 * c_que.c
 *      Queue library.
 */

#include "c_que.h"

/*
 * Initialize queue.
 */
void
c_initque(c_que_t *h)
{
	h->q_forw = h->q_back = h;
}

/*
 * Entry queue to head(*h).
 */
void
c_enque(c_que_t *h, c_que_t *q)
{
	if(h == q) {
		abort();
	}
	q->q_forw = h;
	q->q_back = h->q_back;
	h->q_back->q_forw = q;
	h->q_back = q;
}

/*
 * Delete FIRST queue element.
 * Return deleted queue's pointer.
 */
c_que_t	*
c_deque(c_que_t *h)
{
	c_que_t	*q;

	if(h->q_forw == h)
		return (c_que_t *)0;

	q = h->q_forw;
	c_remque(q);
	return q;
}

/*
 * Remove queue element from lists.
 */
void
c_remque(c_que_t *q)
{
	q->q_forw->q_back = q->q_back;
	q->q_back->q_forw = q->q_forw;
	c_initque(q);
}

/*
 * Peek FIRST queue element.
 * If (*h) is isolate, return 0.
 */
c_que_t *
c_peekque(c_que_t *h)
{
	return ((h->q_forw == h)? 0: h->q_forw);
}

/*
 * Return number of queue elements.
 * (exclude header(*h))
 */
int
c_quelen(c_que_t *h)
{
	register int i;
	register c_que_t *q;

	for (i = 0, q = h->q_forw; q != h; q = q->q_forw)
		i++;
	return (i);
}
