#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

#include	"logUtil.h"

#define	ALLOC_MAX	256

static char	*magic = "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa";
static int	count;
static int	total;
static void	*alloc_ptr[ALLOC_MAX];

typedef struct _ut_alloc {
	size_t	size;
	char	*file;
	int	line;
} ut_alloc_t;

/*****************************************************************************
 * ؿ̾
 *	ut_alloc: 򥢥ݥȤ롣
 * ǽ
 *	ǥХåĤơ򥢥ݥȤ롣
 *
 *	
 *	1:򥢥ݥȤ롣
 * 
 *	size_t size;	I: ᥤΰΥ
 *	char *file;	I: ե̾
 *	int line;	I: ֹ
 * ؿ
 *	!=NULL:	ʥץꥱ󤬻ȤᥤΰؤΥݥ󥿡
 *	==NULL:	۾
 * 
 *	ǥХå
 *	[ debug info ][ main area for application ][ over run check area]
 *	debug info:	եֹ̾
 *	main area:	ץ꤬Ȥΰ
 *	check area:	ΰϤ߽ФʥХˤƤʤΥåΰ
 *****************************************************************************/
void *ut_alloc(size_t size, char *file, int line)
{
	size_t	s, hlen;
	char	*ptr;
	ut_alloc_t	hdr;
	int	i;

	hlen = sizeof(ut_alloc_t);
	s = hlen + size + strlen(magic);
	ptr = (char *) malloc(s);
	if( ptr == NULL )	return NULL;

	hdr.size = size;
	hdr.file = file;
	hdr.line = line;
	memcpy(ptr, &hdr, hlen);
	memcpy(ptr + hlen + size, magic, strlen(magic));

	for( i = 0 ; i < ALLOC_MAX ; i++ ){
		if( alloc_ptr[i] != NULL )	continue;
		alloc_ptr[i] = ptr + hlen;
		break;
	}
	total++;
	count++;

	return ptr + hlen;
}

/*****************************************************************************
 * ؿ̾
 *	ut_free: 롣
 * ǽ
 *	ǥХåޤ롣
 *
 *	
 *	1:롣
 * 
 *	void *vptr;   I: ᥤ󥨥ꥢΥݥ
 * ؿ
 *	̵
 * 
 *	ǥХå
 *	[ debug info ][ main area for application ][ over run check area]
 *	debug info:	եֹ̾
 *	main area:	ץ꤬Ȥΰ
 *	check area:	ΰϤ߽ФʥХˤƤʤΥåΰ
 *****************************************************************************/
void ut_free(void *vptr)
{
	char	*ptr = (char *) vptr;
	size_t	hlen;
	ut_alloc_t	*hdr;
	int	i;

	hlen = sizeof(ut_alloc_t);
	hdr = (ut_alloc_t *)(ptr - hlen);
	if( memcmp(ptr + (hdr->size), magic, strlen(magic)) != 0 ){
		DBGW(1, ("ut_free(): Pointer[%p] allocated at [%s, l.%d] is Over Run!!!\n", ptr, hdr->file, hdr->line));
	}
	count--;
	DBGW(1, ("ut_free(): Rest [%d]\n", count));

	for( i = 0 ; i < ALLOC_MAX ; i++ ){
		if( alloc_ptr[i] == ptr ){
			alloc_ptr[i] = NULL;
			break;
		}
	}

	free(ptr - hlen);
}

/*****************************************************************************
 * ؿ̾
 *	ut_alloc_info: ɽ
 * ǽ
 *	ΥǥХåɽ롣
 *
 *	
 *	1: ΥǥХåɽ롣
 * 
 * ؿ
 *	̵
 * 
 *	ǥХå
 *	[ debug info ][ main area for application ][ over run check area]
 *	debug info:	եֹ̾
 *	main area:	ץ꤬Ȥΰ
 *	check area:	ΰϤ߽ФʥХˤƤʤΥåΰ
 *****************************************************************************/
void ut_alloc_info()
{
	size_t	hlen;
	ut_alloc_t	*hdr;
	int	i;

	DBGW(1, ("Total alloc pointers [%d]\n", total));
	DBGW(1, ("No free pointers [%d]\n", count));
	hlen = sizeof(ut_alloc_t);
	for( i = 0 ; i < ALLOC_MAX ; i++ ){
		if( alloc_ptr[i] == NULL )	continue;
		hdr = (ut_alloc_t *)((char *) alloc_ptr[i] - hlen);
		DBGW(1, ("	FILE[%s] LINE[%d] SIZE[%d]\n", hdr->file, hdr->line, hdr->size));
	}
}
