/***********************************************************************
 *
 *     ̿ߥ졼
 *
 *         ConvertPHP : ̿ȿǥ뤫 PHP Ѥ XML Ѵ
 *
 ***********************************************************************/

#include "parsedae.h"

/**
 * ʸΥ˥
 *
 * Ϥ줿ʸΥפ٤ʸ򥨥פ֤
 * ߤΤȤ &, <, >, ", ' оݡ
 *
 * @param src ˥ʸ
 * @return ˥줿ʸ󡣻 free() 뤳ȡ
 */
static char* sanitize (char *src) {
	int	i;
	int	length;
	char	*buff;
	char	*dest;
	char	*ret;

	if (src == NULL)
		return NULL;

	/* Ͻʸκ 6  (&quot;) ˤʤ (ץ饹 \0) */
	length = strlen (src);
	buff = (char*) calloc (1, length * 6 + 1);
	dest = buff;

	for (i = 0; i < length; i++) {
		switch (src[i]) {
		case '&':
			sprintf (dest, "&amp;");
			dest = dest + 5;
			break;
		case '<':
			sprintf (dest, "&lt;");
			dest = dest + 4;
			break;
		case '>':
			sprintf (dest, "&gt;");
			dest = dest + 4;
			break;
		case '"':
			sprintf (dest, "&quot;");
			dest = dest + 6;
			break;
		case '\'':
			sprintf (dest, "&#39;");
			dest = dest + 5;
			break;
		default:
			sprintf (dest, "%c", src[i]);
			dest++;
			break;
		}
	}

	ret = strdup (buff);
	free (buff);

	return ret;
}

/**
 * ؼ򥰥롼 ID Ӥ (qsort )
 */
static int formulaCmp (const void *f1, const void *f2) {
	return ((Formula_t*)f1)->groupID - ((Formula_t*)f2)->groupID;
}

/**
 * convertPHPInfo ν
 */
static void printConvertPHPInfo (FILE *fp, ConvertPHPInfo_t *convertPHPInfo) {
	int			i, j;
	CListOfReactions_t	*listOfReactions;
	Formulae_t		*formulae;
	CReaction_t		*reaction;
	Formula_t		*formula;

#ifdef DEBUG
	fprintf (stdout, "printConvertPHPInfo: start.\n");
	fflush (stdout);
#endif

	fprintf (fp, "<chemical_eqs>\n");
	fprintf (fp, "    <title>%s</title>\n", convertPHPInfo->title);
	fprintf (fp, "    <memo>%s</memo>\n", convertPHPInfo->memo);
	free (convertPHPInfo->title);
	free (convertPHPInfo->memo);

	for (i = 0; i < convertPHPInfo->formulae_n; i++) {
		formulae = &(convertPHPInfo->listOfFormulae[i]);

		switch (formulae->layer) {
		case LISTOFREACTIONS_LAYER_GENE:
		case LISTOFREACTIONS_LAYER_PROTEIN:
			fprintf (fp, "    <equations layer=\"Gene-Protein\">\n");
			break;
		case LISTOFREACTIONS_LAYER_METABOLIC:
			fprintf (fp, "    <equations layer=\"Metabolic\">\n");
			break;
		}

		for (j = 0; j < formulae->numberOfFormulae; j++) {
			formula = &(formulae->formulae[j]);

			/* isPrintable  false ʤ鼡 */
			if (formula->isPrintable == PARSEDAE_FALSE)
				continue;

			fprintf (fp, "        <equation>\n");
			fprintf (fp, "            %s\n", formula->formula);
			fprintf (fp, "        </equation>\n");
			free (formula->formula);
		}

		fprintf (fp, "    </equations>\n");
		free (formulae->formulae);
	}
	fprintf (fp, "</chemical_eqs>\n");
	free (convertPHPInfo->listOfFormulae);

#ifdef DEBUG
	fprintf (stdout, "printConvertPHPInfo: end.\n");
	fflush (stdout);
#endif
}

/**
 * ǥ뤫 ConvertPHPInfo ؤѴ
 */
static void makeConvertPHPInfo (ConvertPHPInfo_t *convertPHPInfo, CModel_t *model) {
	int			i, j;
	CListOfReactions_t	*listOfReactions;
	Formulae_t		*formulae;
	CReaction_t		*reaction;
	Formula_t		*formula;

#ifdef DEBUG
	fprintf (stdout, "makeConvertPHPInfo: start.\n");
	fflush (stdout);
#endif
	/* إå */
	convertPHPInfo->title = sanitize (model->name);
	convertPHPInfo->memo = sanitize (model->modelInfo);

	/* ؼ */
	convertPHPInfo->formulae_n = model->listOfReactions_n;
	convertPHPInfo->listOfFormulae = (Formulae_t*) calloc (convertPHPInfo->formulae_n, sizeof(Formulae_t));

	for (i = 0; i < model->listOfReactions_n; i++) {
		listOfReactions = &(model->listOfReactions[i]);
		formulae = &(convertPHPInfo->listOfFormulae[i]);
		formulae->layer = listOfReactions->layer;
		formulae->numberOfFormulae = listOfReactions->numberOfReactions;
		formulae->formulae = (Formula_t*) calloc (formulae->numberOfFormulae, sizeof(Formula_t));

		/* ؼ */
		for (j = 0; j < listOfReactions->numberOfReactions; j++) {
			reaction = &(listOfReactions->reaction[j]);
			formula = &(formulae->formulae[j]);
			formula->groupID = reaction->groupID;
			formula->isPrintable = reaction->isConvertible;
			formula->formula = sanitize (reaction->modifierReactionEquation);
		}

		qsort (formulae->formulae, formulae->numberOfFormulae, sizeof(Formula_t), formulaCmp);

	}

#ifdef DEBUG
	fprintf (stdout, "makeConvertPHPInfo: end.\n");
	fflush (stdout);
#endif
}

/**
 * ConvertPHP : ̿ȿǥ뤫 PHP Ѥ XML Ѵ
 */
void ConvertPHP (FILE *fp, OutputInfo_t *outputInfo, CModel_t *model) {
#ifdef DEBUG
	fprintf (stdout, "ConvertPHP: start.\n");
	fflush (stdout);
#endif

	/* ǥ뤫 ConvertPHPInfo ؤѴ */
	makeConvertPHPInfo (&(outputInfo->convertPHPInfo), model);

	/* ConvertPHPInfo ν */
	printConvertPHPInfo (fp, &(outputInfo->convertPHPInfo));

#ifdef DEBUG
	fprintf (stdout, "ConvertPHP: end.\n");
	fflush (stdout);
#endif
}
