/***********************************************************************
 *
 *     ̿ߥ졼
 *
 *         եؤν
 *
 ***********************************************************************/

#include "parsedae.h"

/**
 * Ϥ٤̵ͭĴ٤롣
 *
 * @param term ĴоݤȤʤΥꥹȤƬǡ
 * @return Ϥ٤ब PARSEDAE_TRUE ʤ PARSEDAE_FALSE
 */
static int isTermBlank (Term_t *term) {
	int			ret = PARSEDAE_FALSE;
	Term_t			*current;

	current = term;

	while (current) {
		if (current->coefficient.coefficient != 0) {
			ret = PARSEDAE_TRUE;
			break;
		}
		current = current->next;
	}

	return ret;
}

/**
 * Player_t ΥꥹȤ specieID ǻꤵ줿 player õ 
 */
static Player_t* searchPlayerBySpecieID_list (Player_t *players, int specieID) {
	Player_t	*current;
	
	current = players;

	while (current) {
		if (current->specieID == specieID) {
			break;
		}
		current = current->next;
	}

	return current;
}

/* ---------------------------------------------------------------------- */
/* ---------------------------------------------------------------------- */
/* ---------------------------------------------------------------------- */

/**
 * ʪ̤θʪν
 */
static void printPlayer (FILE *fp, Player_t *player, char *prefix) {
	switch (player->variableType) {
	case VARIABLE_TYPE_CONST:
		fprintf (fp, "constantPlayer[%d]", player->constantIndex);
		break;
	case VARIABLE_TYPE_ALGE_MONOMER:
	case VARIABLE_TYPE_ALGE_COMPLEX:
		fprintf (fp, "x[%s%s.%s]", prefix, player->name, player->compartment_suffix);
		break;
	case VARIABLE_TYPE_DIFF_CMA:
		fprintf (fp, "y[%s%s.%s]", prefix, player->name, player->compartment_suffix);
		break;
	}

	return;
}

/**
 * ѿʬν (gene1)
 */
static void printVariate_gene1 (FILE *fp, Term_t *term) {
	Variate_t	*current;
	Variate_t	*current_total;
	int		groupID;
	Variate_t	*activators;
	Variate_t	*activators_total;
	Variate_t	*inhibitors;
	Variate_t	*inhibitors_total;
	Variate_t	*gene;

	groupID = term->groupID;
	activators = term->activators;
	activators_total = term->activators_total;
	inhibitors = term->inhibitors;
	inhibitors_total = term->inhibitors_total;
	gene = term->gene;

	/* ҷν */
	current = activators;
	current_total = activators_total;
	if (current && current_total) {
		fprintf (fp, "*(");
		while (current && current_total) {
			printPlayer (fp, current->player, "");
			fprintf (fp, "/");
			printPlayer (fp, current_total->player, "T");
			current = current->next;
			current_total = current_total->next;
			if (current && current_total)
				fprintf (fp, " + ");
		}
		fprintf (fp, ")");
	}

	/* ҷν */
	current = inhibitors;
	current_total = inhibitors_total;
	if (current && current_total) {
		while (current && current_total) {
			fprintf (fp, "*(1 - ");
			printPlayer (fp, current->player, "");
			fprintf (fp, "/");
			printPlayer (fp, current_total->player, "T");
			fprintf (fp, ")");
			current = current->next;
			current_total = current_total->next;
		}
	}

	/* gene ν */
	fprintf (fp, "*");
	printPlayer (fp, gene->player, "");

	return;
}

/**
 * ѿʬν (̾)
 */
static void printVariate_CMA (FILE *fp, Variate_t *root, int isFirstFactor) {
	Variate_t	*current;
	Player_t	*player;
	double		powerCoefficient;

	current = root;

	while (current) {
		player = current->player;

		if (isFirstFactor == PARSEDAE_FALSE)
			fprintf (fp, "*");

		/* ̾ιαդѿϤʤȤ */
		printPlayer (fp, player, "");

		powerCoefficient = current->powerCoefficient;
		if (powerCoefficient != 1)
			fprintf (fp, "^%g", powerCoefficient);

		current = current->next;
	}

	return;
}

/**
 * ν
 */
static void printEquation (FILE *fp, Equation_t *equation, int equationType, int convType, int *index, OutputInfo_t *outputInfo) {
	Equation_t		*current;
	Player_t		*leftPart;
	Player_t		*totalPlayer;
	CSpecie_t		*specie;
	char			*name;
	char			*compartment_suffix;
	Term_t			*currentTerm;
	int			isFirstTerm;
	int			isFirstFactor;
	Coefficient_t		*coefficient;
	double			coefficientValue;
	int			paramType;
	int			paramIndex;
	Variate_t		*currentVariate;
	double			powerCoefficient;
	FluxEq_t		*fluxEq;
	Player_t		*player;
	int			constantIndex;
	Variate_t		*gene;
	
#ifdef DEBUG_MOF
	fprintf (stdout, "printEquation: start.\n");
	fflush (stdout);
#endif
	current = equation;

	while (current) {
		leftPart = current->leftPart;
		currentTerm = current->rightPartTerms;
		isFirstTerm = PARSEDAE_TRUE;

		/* बҤȤĤʤФʤˤϤʤ */
		if (isTermBlank (currentTerm) != PARSEDAE_TRUE) {
			current = current->next;
			continue;
		}

		name = leftPart->name;
		compartment_suffix = leftPart->compartment_suffix;

		switch (equationType) {
		case EQUATION_TYPE_ALGE_MONOMER:
			if ((totalPlayer = searchPlayerBySpecieID_list (outputInfo->variableInfo.constants_total, leftPart->specieID))) {
				fprintf (fp, "aeq_%d: constantPlayer[%d] =", *index, totalPlayer->constantIndex);
			} else {
				fprintf (fp, "aeq_%d: y[T%s.%s] =", *index, name, compartment_suffix);
			}
			break;
		case EQUATION_TYPE_ALGE_COMPLEX:
			fprintf (fp, "aeq_%d: ", *index);
			break;
		case EQUATION_TYPE_DIFF:
			fprintf (fp, "deq_%d: dydt[%s.%s] =", *index, name, compartment_suffix);
			break;
		case EQUATION_TYPE_DIFF_TOTAL:
			fprintf (fp, "deq_%d: dydt[T%s.%s] =", *index, name, compartment_suffix);
			break;
		}

		/*  */
		while (currentTerm) {
			isFirstFactor = PARSEDAE_TRUE;

			/*  */
			coefficient = &(currentTerm->coefficient);
			coefficientValue = coefficient->coefficient;
			paramType = coefficient->paramType;
			paramIndex = coefficient->paramIndex;
			powerCoefficient = coefficient->powerCoefficient;

			if (convType == CONVTYPE_TPP_RAPID) {
				/* TPP_RAPID ΤȤ ka ι Kb ȤƽϤkd ϽϤʤ */
				switch (paramType) {
				case PARAM_TYPE_KA:
					paramType = PARAM_TYPE_KB;
					break;
				case PARAM_TYPE_KD:
					paramType = PARAM_TYPE_NONE;
					break;
				}
			}

			if (coefficientValue == 0) {
				/* ο 0 ʤФιϽϤʤ */
				currentTerm = currentTerm->next;
				continue;
			} else if (coefficientValue == 1.0) {
				if (isFirstTerm == PARSEDAE_TRUE) {
					fprintf (fp, " ");
				} else {
					fprintf (fp, " + ");
				}
			} else if (coefficientValue == -1.0) {
				fprintf (fp, " - ");
			} else if (coefficientValue < 0) {
				fprintf (fp, " - %g*", -coefficientValue);
			} else {
				if (isFirstTerm == PARSEDAE_TRUE) {
					fprintf (fp, " %g*", coefficientValue);
				} else {
					fprintf (fp, " + %g*", coefficientValue);
				}
			}

			isFirstTerm = PARSEDAE_FALSE;

			/* ѥ᡼ */
			if (paramType == PARAM_TYPE_KB &&
			    powerCoefficient != 1.0) {
				/* Kb ιǤ٤ؿ 1 ʳʤȤ */
				fprintf (fp, "%s[%d]^%g", paramTypeStr[paramType], paramIndex, powerCoefficient);
				isFirstFactor = PARSEDAE_FALSE;
			} else if (paramType != PARAM_TYPE_NONE) {
				fprintf (fp, "%s[%d]", paramTypeStr[paramType], paramIndex);
				isFirstFactor = PARSEDAE_FALSE;
			}

			/* ѿ */
			currentVariate = currentTerm->variates;
			fluxEq = currentTerm->fluxEq;
			gene = currentTerm->gene;

			/* gene1 ιϤ */
			if (gene)
				printVariate_gene1 (fp, currentTerm);

			/* ̾ѿιϤ */
			if (currentVariate)
				printVariate_CMA (fp, currentVariate, isFirstFactor);

			/* Flux ιϤ */
			if (fluxEq)
				fprintf (fp, "%s", currentTerm->fluxEq->leftPart);

			currentTerm = currentTerm->next;
		}

		if (equationType == EQUATION_TYPE_ALGE_COMPLEX) {
			fprintf (fp, " = 0");
		}

		fprintf (fp, ";\n");
		(*index)++;

		current = current->next;
	}

#ifdef DEBUG_MOF
	fprintf (stdout, "printEquation: end.\n");
	fflush (stdout);
#endif
	return;
}

/**
 * ꥹȤν
 */
static void printEquations (FILE *fp, OutputInfo_t *outputInfo) {
	Equations_t		*equations;
	int			convType_GeneProtein;
	int			index;

#ifdef DEBUG_MOF
	fprintf (stdout, "printEquations: start.\n");
	fflush (stdout);
#endif

	equations = &(outputInfo->equations);
	convType_GeneProtein = outputInfo->headerInfo.convType_GeneProtein;

	/* ꥹ */
	fprintf (fp, "== Algebraic Eqs. ==\n\n");
	index = 1;

	if (equations->algeEqs_monomer)
		printEquation (fp, equations->algeEqs_monomer, EQUATION_TYPE_ALGE_MONOMER, convType_GeneProtein, &index, outputInfo);

	if (equations->algeEqs_complex)
		printEquation (fp, equations->algeEqs_complex, EQUATION_TYPE_ALGE_COMPLEX, convType_GeneProtein, &index, outputInfo);

	fprintf (fp, "\n");

	/* ʬꥹ */
	fprintf (fp, "== Differencial Eqs. ==\n\n");
	index = 1;

	if (equations->diffEqs)
		printEquation (fp, equations->diffEqs, EQUATION_TYPE_DIFF, convType_GeneProtein, &index, outputInfo);

	if (equations->diffEqs_total)
		printEquation (fp, equations->diffEqs_total, EQUATION_TYPE_DIFF_TOTAL, convType_GeneProtein, &index, outputInfo);

#ifdef DEBUG_MOF
	fprintf (stdout, "printEquations: end.\n");
	fflush (stdout);
#endif

	return;
}

/**
 * ɽν
 */
static void printTemporaryEqs (FILE *fp, OutputInfo_t *outputInfo) {
	TemporaryEqs_t		*tempEqs;
	TotalEnzymeEq_t		*currentEnz;
	FluxEq_t		*currentFlux;

	tempEqs = &(outputInfo->temporaryEqs);

	/* ɽ */
	fprintf (fp, "== Temporary Expressions ==\n\n");

	/* ̼ */
	currentEnz = tempEqs->totalEnzymeEqs;
	if (currentEnz) {
		fprintf (fp, "= Total enzyme =\n");
		while (currentEnz) {
			if (currentEnz->inUse)
				fprintf (fp, "%s = %s;\n", currentEnz->leftPart, currentEnz->rightPart);
			currentEnz = currentEnz->next;
		}
		fprintf (fp, "\n");
	}

	/* Flux  */
	currentFlux = tempEqs->fluxEqs;
	if (currentFlux) {
		fprintf (fp, "= Flux =\n");
		while (currentFlux) {
			fprintf (fp, "%s = %s;\n", currentFlux->leftPart, currentFlux->rightPart);
			currentFlux = currentFlux->next;
		}
		fprintf (fp, "\n");
	}
}

/**
 * ѥ᡼νϥᥤ
 */
static void printParameter_main (FILE *fp, Parameter_t *parameter, int paramType) {
	if (parameter) {
		printParameter_main (fp, parameter->next, paramType);
		fprintf (fp, "%s[%d] = ; %s%s\n", paramTypeStr[paramType], parameter->index, paramLabel[paramType], parameter->name);
	}
}

/**
 * ѥ᡼ν
 */
static void printParameter (FILE *fp, Parameter_t *parameter, int paramType, int printType) {
	Parameter_t		*current = NULL;
	int			index;
	char			*name;

#ifdef DEBUG_MOF
	fprintf (stdout, " printParameter: start.\n");
	fflush (stdout);
#endif
	/* ѥѥ᡼Ϥ硢Ϥ¨λ */
	switch (printType) {
	case PRINTPARAMETERS_USEDPARAMS:
		fprintf (fp, "%s;\n", paramTypeStr[paramType]);
		goto end;
	case PRINTPARAMETERS_PARAMS:
		break;
	}

	fprintf (fp, "### %s: %s\n", paramTypeStr[paramType], paramLabel[paramType]);

	printParameter_main (fp, parameter, paramType);

	fprintf (fp, "\n");
  end:
#ifdef DEBUG_MOF
	fprintf (stdout, " printParameter: start.\n");
	fflush (stdout);
#endif
	return;
}

/**
 * ѥ᡼ꥹȤν
 */
static void printParameters (FILE *fp, OutputInfo_t *outputInfo, int printType) {
	int			i;
	Parameters_t		*parameters;
	int			convType_GeneProtein;

#ifdef DEBUG_MOF
	fprintf (stdout, " printParameters: start.\n");
	fflush (stdout);
#endif
	parameters = &(outputInfo->parameters);
	convType_GeneProtein = outputInfo->headerInfo.convType_GeneProtein;

	switch (printType) {
	case PRINTPARAMETERS_USEDPARAMS:
		fprintf (fp, "== Used Parameters ==\n\n");
		break;
	case PRINTPARAMETERS_PARAMS:
		fprintf (fp, "== Parameters ==\n\n");
		break;
	}

#ifdef DEBUG_MOF
/*
	fprintf (stdout, "convType_GeneProtein: %d\n", convType_GeneProtein);
	fprintf (stdout, "param_num: \n");
	for (i = PARAM_TYPE_KA; i < PARAM_TYPE_MAXPARAM; i++) {
		fprintf (stdout, "%d, ", parameters->param_num[i]);
	}
	fprintf (stdout, "\n");
	fflush (stdout);
*/
#endif
	/* ѥ᡼ꥹ */
	if (convType_GeneProtein != CONVTYPE_TPP_RAPID) {
		/* ka */
		if (parameters->param_num[PARAM_TYPE_KA] > 0)
			printParameter (fp, parameters->param[PARAM_TYPE_KA], PARAM_TYPE_KA, printType);
		/* kd */
		if (parameters->param_num[PARAM_TYPE_KD] > 0)
			printParameter (fp, parameters->param[PARAM_TYPE_KD], PARAM_TYPE_KD, printType);
	} else {
		/* TPP_RAPID Ǥ ka  Kb ȤƽϤ */
		/* Kb */
		if (parameters->param_num[PARAM_TYPE_KA] > 0)
			printParameter (fp, parameters->param[PARAM_TYPE_KA], PARAM_TYPE_KB, printType);
	}
	/* kx - Kmich */
	for (i = PARAM_TYPE_KX; i < PARAM_TYPE_MAXPARAM; i++) {
		if (parameters->param_num[i] > 0)
			printParameter (fp, parameters->param[i], i, printType);
	}

	fprintf (fp, "\n");

#ifdef DEBUG_MOF
	fprintf (stdout, " printParameters: end.\n");
	fflush (stdout);
#endif
	return;
}

/**
 * ѿν
 *
 * @param fp եݥ
 * @param variables Ϥޤѿ
 * @param variableType variables μ
 * @param prefix ʪ̾ղäƬ̤ʤ "T" 
 */
static void printVariables (FILE *fp, Player_t *variables, int variableType, char *prefix) {
	int			constantIndex;
	char			*compartment_suffix;
	char			*name;
	int			initialAmount_isValid;
	double			initialAmount;
	Player_t		*current;

	current = variables;

	while (current) {
		name = current->name;
		compartment_suffix = current->compartment_suffix;
		initialAmount_isValid = current->initialAmount_isValid;
		initialAmount = current->initialAmount;
		constantIndex = current->constantIndex;

		switch (variableType) {
		case VARIABLE_TYPE_CONST:
			if (initialAmount_isValid == PARSEDAE_TRUE) {
				fprintf (fp, "constantPlayer[%d] = %g; %s%s.%s\n", constantIndex, initialAmount, prefix, name, compartment_suffix);
			} else {
				fprintf (fp, "constantPlayer[%d] = ; %s%s.%s\n", constantIndex, prefix, name, compartment_suffix);
			}
			break;
		case VARIABLE_TYPE_ALGE_MONOMER:
		case VARIABLE_TYPE_ALGE_COMPLEX:
			if (initialAmount_isValid == PARSEDAE_TRUE) {
				fprintf (fp, "x[%s%s.%s] = %g;\n", prefix, name, compartment_suffix, initialAmount);
			} else {
				fprintf (fp, "x[%s%s.%s] = ;\n", prefix, name, compartment_suffix);
			}
			break;
		case VARIABLE_TYPE_DIFF_CMA:
		case VARIABLE_TYPE_DIFF_GMA:
			if (initialAmount_isValid == PARSEDAE_TRUE) {
				fprintf (fp, "y[%s%s.%s] = %g;\n", prefix, name, compartment_suffix, initialAmount);
			} else {
				fprintf (fp, "y[%s%s.%s] = ;\n", prefix, name, compartment_suffix);
			}
			break;
		}

		current = current->next;
	}

	return;
}

/**
 * Player ΥꥹȤ constantIndex Ǹ롣
 *
 * @param variables Player Υꥹ
 * @param index оݤ constantIndex
 * @return Ĥä Player ޤ NULL 
 */
static Player_t* printConstants_searchConstatIndex (Player_t *variables, int index) {
	Player_t	*current;

	current = variables;
	while (current) {
		if (current->constantIndex == index)
			break;
		current = current->next;
	}

	return current;
}

/**
 * constants  constants_total  index ˽Ϥ롣
 */
static void printConstants (FILE *fp, Player_t *variables, Player_t *variables_total) {
	int		i, index;
	Player_t	*v, *vt, *p;

	v = variables;
	vt = variables_total;
	index = 1;

	while (true) {
		if (p = printConstants_searchConstatIndex (v, index)) {
			p = PlayerDup (p);
			printVariables (fp, p, VARIABLE_TYPE_CONST, "");
			free (p);
			index++;
			continue;
		}
		if (p = printConstants_searchConstatIndex (vt, index)) {
			p = PlayerDup (p);
			printVariables (fp, p, VARIABLE_TYPE_CONST, "T");
			free (p);
			index++;
			continue;
		}
		break;
	}
}

/**
 * ѿν
 */
static void printVariableInfo (FILE *fp, OutputInfo_t *outputInfo) {
	VariableInfo_t		*variableInfo;

#ifdef DEBUG_MOF
	fprintf (stdout, "printVariableInfo: start.\n");
	fflush (stdout);
#endif

	variableInfo = &(outputInfo->variableInfo);

	/*  */
	fprintf (fp, "== Constant Players ==\n\n");
	printConstants (fp, variableInfo->constants, variableInfo->constants_total);
/*
	printVariables (fp, variableInfo->constants, VARIABLE_TYPE_CONST, "");
	printVariables (fp, variableInfo->constants_total, VARIABLE_TYPE_CONST, "T");
*/
	fprintf (fp, "\n");

	/* ѿ */
	fprintf (fp, "== Variables ==\n\n");
	/* ѿ */
	fprintf (fp, "= Algebraic Equation =\n\n");
	printVariables (fp, variableInfo->algeEqVars_monomer, VARIABLE_TYPE_ALGE_MONOMER, "");
	printVariables (fp, variableInfo->algeEqVars_complex, VARIABLE_TYPE_ALGE_COMPLEX, "");
	fprintf (fp, "\n");

	/* ʬѿ */
	fprintf (fp, "= Differencial Equation =\n\n");
	printVariables (fp, variableInfo->diffEqVars_cma, VARIABLE_TYPE_DIFF_CMA, "");
	printVariables (fp, variableInfo->diffEqVars_gma, VARIABLE_TYPE_DIFF_GMA, "");
	printVariables (fp, variableInfo->diffEqVars_total, VARIABLE_TYPE_DIFF_CMA, "T");
	fprintf (fp, "\n");

#ifdef DEBUG_MOF
	fprintf (stdout, "printVariableInfo: end.\n");
	fflush (stdout);
#endif

	return;
}

/**
 * إåν
 */
static void printHeaderInfo (FILE *fp, HeaderInfo_t *headerInfo) {

#ifdef DEBUG_MOF
	fprintf (stdout, "printHeaderInfo: start.\n");
	fflush (stdout);
#endif

	/* إå */
	fprintf (fp, "== Model ==\n\n");
	/* title - ǥ̾ */
	fprintf (fp, "TITLE:%s\n", headerInfo->title);
	/* info - ǥ */
	fprintf (fp, "INFO:%s\n", headerInfo->info);
	/* Ѵ */
	fprintf (fp, "CONVERSION TYPE\n");
	fprintf (fp, "    GENE-PROTEIN:%s\n", convTypeStr[headerInfo->convType_GeneProtein]);
	fprintf (fp, "    METABOLIC:%s\n", convTypeStr[headerInfo->convType_Metabolic]);
	fprintf (fp, "\n");

#ifdef DEBUG_MOF
	fprintf (stdout, "printHeaderInfo: end.\n");
	fflush (stdout);
#endif

	return;
}

/**
 * եؤν
 */
void MakeOutputFile (FILE *fp, OutputInfo_t *outputInfo, int fileType, int outputType) {
#ifdef DEBUG_MOF
	fprintf (stdout, "MakeOutputFile: start.\n");
	fflush (stdout);
#endif

	/* إåν */
	printHeaderInfo(fp, &(outputInfo->headerInfo));

	/* ѿν */
	printVariableInfo (fp, outputInfo);

	/* ѥѥ᡼ν */
	printParameters (fp, outputInfo, PRINTPARAMETERS_USEDPARAMS);

	/* ѥ᡼ꥹȤν */
	printParameters (fp, outputInfo, PRINTPARAMETERS_PARAMS);

	if (outputType == OUTPUT_TYPE_DAE) {
		/* ɽꥹȤν */
		printTemporaryEqs (fp, outputInfo);

		/* ꥹȤν */
		printEquations (fp, outputInfo);
	}

#ifdef DEBUG_MOF
	fprintf (stdout, "MakeOutputFile: end.\n");
	fflush (stdout);
#endif
	return;
}
