/***********************************************************************
 *
 *     ̿ߥ졼
 *
 *         ̿ȿǥѴϾơ֥ۤ롣
 *
 ***********************************************************************/

#include "parsedae.h"

/**
 * ѥ᡼ʣ (next  NULL ˥ꥻåȤ) Ĥ롣
 */
static Parameter_t* paramdup (Parameter_t *src) {
	Parameter_t	*dest;

	dest = (Parameter_t*) calloc (1, sizeof(Parameter_t));
	memcpy (dest, src, sizeof(Parameter_t));
	dest->next = NULL;

	return dest;
}

/**
 * ʣ (next  NULL ˥ꥻåȤ) Ĥ롣
 */
static Equation_t* eqdup (Equation_t *src) {
	Equation_t	*dest;

	dest = (Equation_t*) calloc (1, sizeof(Equation_t));
	memcpy (dest, src, sizeof(Equation_t));
	dest->next = NULL;

	return dest;
}

/**
 * ꤵ줿 index ʪӤʪʪ椫žĴҤ򸡺롣
 *
 * @param variables ϰϤȤʤ Player 
 * @param numberOfSpecies variables Υ
 * @param index оݤȤʤʪ variables ˤ륤ǥå
 * @return ĤäϥǥåĤʤä -1
 */
static int searchTranscriptionalRegulator (Player_t *variables, int numberOfSpecies, int index) {
	int			i;
	Player_t		*modifier;
	int			specieClass;
	CSpecieReference_t	*specieReference;
	int			elementIndex;
	int			ret;

	/* ꤵ줿ʪ */
	modifier = &(variables[index]);

	/* ʪ index ֤ */
	specieClass = modifier->specieClass;
	if (specieClass == SPECIEATTRIBUTE_SPECIECLASS_DNA_PROMOTER ||
	    specieClass == SPECIEATTRIBUTE_SPECIECLASS_DNA_ENHANCER) {
		return index;
	}

	/* ʪϳʤΤǹǷƵŪõ */
	for (i = 0; i < modifier->numberOfElements; i++) {
		/* Ǥ specieReference 饤ǥå */
		specieReference = &(modifier->specieReference[i]);
		elementIndex = SearchPlayerBySpecieID (variables, numberOfSpecies, specieReference->specieID);
		/* ǤΥǥåǺƵŪõĤФ֤ */
		if ((ret = searchTranscriptionalRegulator (variables, numberOfSpecies, elementIndex)) != -1)
			return ret;
	}

	/* ĤʤäΤ -1 ֤ */
	return -1;
}

/**
 * Player ꤷƿ Variate Ĥ롣
 */
static Variate_t* makeNewVariate (Player_t *player, double powerCoefficient, int modifierType) {
	Variate_t	*variate;

	variate = (Variate_t*) calloc (1, sizeof(Variate_t));
	variate->player = player;
	variate->powerCoefficient = powerCoefficient;
	variate->modifierType = modifierType;

	return variate;
}

/**
 * ListOfPlayers ɤߡȤ specieID б Player  Variate  Term ɲä롣
 * 
 * @param term ɲιࡣɬܡ
 * @param tempInfo  ()
 * @param listOfPlayers ɲø ListOfPlayers 
 * @param playerType Ȥʪ () μ̡list бΤ򥻥åȤ뤳ȡ
 */
static void addVariatesToTerm (Term_t *term, TempInfo_t *tempInfo, CListOfPlayers_t *listOfPlayers) {
	int				i, index;
	int				numberOfSpecies = 0;
	Player_t			*variables = NULL;
	CSpecieReference_t		*specieReference = NULL;
	double				stoichiometry;

#ifdef DEBUG_MOI
	fprintf (stdout, "  addVariatesToTerm: start.\n");
	fflush (stdout);
#endif
	/*  */
	numberOfSpecies	= tempInfo->numberOfSpecies;
	variables	= tempInfo->variables;

	/* ѿɲ */
	for (i = 0; i < listOfPlayers->numberOfPlayers; i++) {
		specieReference = &(listOfPlayers->specieReference[i]);
		stoichiometry = specieReference->stoichiometry;
		index = SearchPlayerBySpecieID (variables, numberOfSpecies, specieReference->specieID);
		AddVariateToTerm (term, &(variables[index]), stoichiometry);
	}

#ifdef DEBUG_MOI
	fprintf (stdout, "  addVariatesToTerm: end.\n");
	fflush (stdout);
#endif
	return;
}


/* ---------------------------------------------------------------------- */
/* ---------------------------------------------------------------------- */
/* ---------------------------------------------------------------------- */

/**
 * equations  tempInfo  outputInfo ˥ԡ롣
 */
static void convertTempInfoToEquations (OutputInfo_t *outputInfo, TempInfo_t *tempInfo) {
	int			i;
	int			numberOfSpecies;
	Player_t		*variable;
	Equation_t		*equation;
	Equation_t		*equation_total;
	Equations_t		*equations;

	Equation_t		*algeEqs_monomer;
	Equation_t		*algeEqs_complex;
	Equation_t		*diffEqs;
	Equation_t		*diffEqs_total;

	numberOfSpecies = tempInfo->numberOfSpecies;
	equations = &(outputInfo->equations);

	for (i = 0; i < numberOfSpecies; i++) {
		variable = &(tempInfo->variables[i]);
		equation = &(tempInfo->equations[i]);
		equation_total = &(tempInfo->equations_total[i]);
		switch (variable->variableType) {
		case VARIABLE_TYPE_ALGE_MONOMER:
			Enqueue ((Queue_t**)&(equations->algeEqs_monomer), (Queue_t*)eqdup(equation));
			Enqueue ((Queue_t**)&(equations->diffEqs_total), (Queue_t*)eqdup(equation_total));
			break;
		case VARIABLE_TYPE_ALGE_COMPLEX:
			Enqueue ((Queue_t**)&(equations->algeEqs_complex), (Queue_t*)eqdup(equation));
			break;
		case VARIABLE_TYPE_DIFF_CMA:
			Enqueue ((Queue_t**)&(equations->diffEqs), (Queue_t*)eqdup(equation));
			break;
		case VARIABLE_TYPE_DIFF_GMA:
			Enqueue ((Queue_t**)&(equations->diffEqs), (Queue_t*)eqdup(equation));
			break;
		}
	}

	return;
}

/**
 * variables  tempInfo  outputInfo ˥ԡ롣
 */
static void convertTempInfoToVariableInfo (OutputInfo_t *outputInfo, TempInfo_t *tempInfo) {
	int			i;
	int			numberOfSpecies;
	VariableInfo_t		*variableInfo;
	Player_t		*variables;
	Player_t		*variable;
	Player_t		*variables_total;

	numberOfSpecies = tempInfo->numberOfSpecies;
	variableInfo = &(outputInfo->variableInfo);
	variables = tempInfo->variables;
	variables_total = tempInfo->variables_total;

	for (i = 0; i < numberOfSpecies; i++) {
		variable = &(tempInfo->variables[i]);
		switch (variable->variableType) {
		case VARIABLE_TYPE_CONST:
			Enqueue ((Queue_t**)&(variableInfo->constants), (Queue_t*)variable);
			break;
		case VARIABLE_TYPE_ALGE_MONOMER:
			Enqueue ((Queue_t**)&(variableInfo->algeEqVars_monomer), (Queue_t*)variable);
			break;
		case VARIABLE_TYPE_ALGE_COMPLEX:
			Enqueue ((Queue_t**)&(variableInfo->algeEqVars_complex), (Queue_t*)variable);
			break;
		case VARIABLE_TYPE_DIFF_CMA:
			Enqueue ((Queue_t**)&(variableInfo->diffEqVars_cma), (Queue_t*)variable);
			break;
		case VARIABLE_TYPE_DIFF_GMA:
			Enqueue ((Queue_t**)&(variableInfo->diffEqVars_gma), (Queue_t*)variable);
			break;
		}
	}
	for (i = 0; i < numberOfSpecies; i++) {
		variable = &(tempInfo->variables_total[i]);
		switch (variable->variableType) {
		case VARIABLE_TYPE_CONST:
			Enqueue ((Queue_t**)&(variableInfo->constants_total), (Queue_t*)variable);
			break;
		case VARIABLE_TYPE_DIFF_CMA:
		case VARIABLE_TYPE_DIFF_GMA:
			Enqueue ((Queue_t**)&(variableInfo->diffEqVars_total), (Queue_t*)variable);
			break;
		}
	}

	return;
}

/**
 * դ¸ߤʤʪѴ
 *
 * @param tempInfo 
 */
static void convertVariablesToConstants (TempInfo_t *tempInfo, int convType) {
	int			i;
	Player_t		*v;
	Equation_t		*eq;

	for (i = 0; i < tempInfo->numberOfSpecies; i++) {
		v = &(tempInfo->variables[i]);
		eq = &(tempInfo->equations[i]);

		if (eq->rightPartTerms == NULL) {
			switch (v->variableType) {
			case VARIABLE_TYPE_ALGE_COMPLEX:
			case VARIABLE_TYPE_ALGE_MONOMER:
			case VARIABLE_TYPE_DIFF_CMA:
				if (convType == CONVTYPE_CMA)
					v->variableType = VARIABLE_TYPE_CONST;
				break;
			case VARIABLE_TYPE_DIFF_GMA:
				if (convType == CONVTYPE_GMA)
					v->variableType = VARIABLE_TYPE_CONST;
				break;
			}
		}
	}
}

/**
 * ʬ: ʬͯФʣΤιǤ˺ƵŪɲä롣
 */
static int execDecomposition_recursive (TempInfo_t *tempInfo, Player_t *r, Parameter_t *param, int specieID, double stoichiometry) {
	int			i, index;
	Player_t		*v;
	Equation_t		*eq;
	Term_t			*term;
	CSpecieReference_t	*sr;

	/* specieID  index 򸡺 */
	index = SearchPlayerBySpecieID (tempInfo->variables, tempInfo->numberOfSpecies, specieID);
	v = &(tempInfo->variables[index]);
	eq = &(tempInfo->equations[index]);

	/* CMA/TPP ѿǤʤХ顼 */
	if (v->variableType == VARIABLE_TYPE_UNKNOWN) {
		log_sys ("Decomposition: The element of complex '%s.%s(specieID=%d)' must be a variable of 'CMA/TPP'.\n", v->name, v->compartment_suffix, v->specieID);
		goto err;
	}

	/* decomposition  OFF ʤͯФɲä
	   decomposition  ON ʤƵԤ */
	if (v->decomposition == SPECIEATTRIBUTE_DECOMPOSITION_OFF) {
		term = MakeNewTerm (stoichiometry, paramdup(param));
		AddVariateToTerm (term, r, +1.0);
		AddTermToEquation (eq, term);
	} else {
		for (i = 0; i < v->numberOfElements; i++) {
			sr = &(v->specieReference[i]);
			if (execDecomposition_recursive (tempInfo, r, param, sr->specieID, sr->stoichiometry * stoichiometry))
				goto err;
		}
	}

	return 0;
  err:
	return -1;
}

/**
 * ʬν
 *
 * @param tempInfo 
 */
static int execDecomposition (TempInfo_t *tempInfo, int convType) {
	int			i, j;
	Player_t		*v;
	Equation_t		*eq;
	int			paramType;
	Parameter_t		*param = NULL;
	Term_t			*term;
	CSpecieReference_t	*sr;
	FluxEq_t		*fluxEq = NULL;

#ifdef DEBUG_MOI
	fprintf (stdout, " execDecomposition: start.\n");
	fflush (stdout);
#endif
	for (i = 0; i < tempInfo->numberOfSpecies; i++) {
		v = &(tempInfo->variables[i]);
		eq = &(tempInfo->equations[i]);

		/* decomposition  OFF ʪˤĤƤϥåפ */
		if (v->decomposition == SPECIEATTRIBUTE_DECOMPOSITION_OFF)
			continue;

		/* convType ߤ CMA/TPP μʬ
		   GMA/MM μʬΤɤԤꤹ */
		switch (convType_rough[convType]) {
		case CONVTYPE_CMA:
			/* CMA/TPP ѿǤʤмʬϹԤʤ */
			if (v->variableType == VARIABLE_TYPE_UNKNOWN ||
			    v->variableType == VARIABLE_TYPE_CONST)
				continue;

			/* ѥ᡼κ: RNA ʤ kmd, ¾ kpd */
			if (v->specieClass == SPECIEATTRIBUTE_SPECIECLASS_RNA)
				paramType = PARAM_TYPE_KMD;
			else
				paramType = PARAM_TYPE_KPD;
			param = MakeParam(tempInfo, paramType, NULL, NULL, NULL, v);
			/* κʪϿؤɲ */
			term = MakeNewTerm ((-1.0), param);
			AddVariateToTerm (term, v, 1.0);
			AddTermToEquation (eq, term);

			/* ǤкƵŪ˹ɲäƤ */
			for (j = 0; j < v->numberOfElements; j++) {
				sr = &(v->specieReference[j]);
				if (execDecomposition_recursive (tempInfo, v, param, sr->specieID, sr->stoichiometry)) {
					log_sys ("Decomposition: '%s.%s(specieID=%d)' has a element which is not a variable of 'CMA/TPP'.\n", v->name, v->compartment_suffix, v->specieID);
					goto err;
				}
			}
			break;
		case CONVTYPE_GMA:
			/* GMA ѿǤʤмʬϹԤʤ */
			if (v->variableType != VARIABLE_TYPE_DIFF_GMA)
				continue;

			/* Flux κȤʪؤɲ */
			MakeFluxEq_decomp (tempInfo, v, convType);

			/* GMA ǤʣΤ򰷤ʤƵϤʤ */
			break;
		}
	}
#ifdef DEBUG_MOI
	fprintf (stdout, " execDecomposition: end.\n");
	fflush (stdout);
#endif
	return 0;
  err:
	return -1;
}

/**
 * elementList  specieID  Player ̤Ͽʤ stoichiometry ȥåȤϿ롣ϿѤʤг Player  stoichiometry  stoichiometry û롣
 */
static void addStoichiometryToPlayerList (int specieID, double stoichiometry, Player_t **elementList, int *elementList_length) {
	Player_t		*current;
	Player_t		*player;

#ifdef DEBUG_MOI
	fprintf (stdout, "   addStoichiometryToPlayerList: start.\n");
	fflush (stdout);
#endif
	current = *elementList;
	while (current) {
		if (current->specieID == specieID)
			break;
		current = current->next;
	}
	if (current) {
		/* NULL Ǥʤ  ϿѤʤΤǲû */
		current->stoichiometry += stoichiometry;
	} else {
		/* NULL  ̤ϿʤΤɲ */
		player = (Player_t*) calloc (1, sizeof(Player_t));
		player->specieID = specieID;
		player->stoichiometry = stoichiometry;
		player->next = *elementList;
		*elementList = player;
		(*elementList_length)++;
	}
#ifdef DEBUG_MOI
	fprintf (stdout, "   addStoichiometryToPlayerList: end.\n");
	fflush (stdout);
#endif
}

/**
 * ʣΤñΤʬ򤹤롣
 */
static void breakdownComplex (Player_t *variables, int numberOfSpecies, int index, Player_t **elementList, int *elementList_length) {
	int			i;
	int			numberOfElements;
	CSpecieReference_t	*elements;
	int			elementIndex;
	Player_t		*element;
	Player_t		*current;
	Player_t		*player;

#ifdef DEBUG_MOI
	fprintf (stdout, "  breakdownComplex: start.\n");
	fflush (stdout);
#endif
	numberOfElements = variables[index].numberOfElements;
	elements = variables[index].specieReference;
	for (i = 0; i < numberOfElements; i++) {
		elementIndex = SearchPlayerBySpecieID (variables, numberOfSpecies, elements[i].specieID);
		element = &(variables[elementIndex]);
		if (element->specieClass == SPECIEATTRIBUTE_SPECIECLASS_COMPLEX) {
			/* ʣΤäƵ */
			breakdownComplex (variables, numberOfSpecies, elementIndex, elementList, elementList_length);
		} else {
			/* ñΤʤнʣåΤΤɲ */
			addStoichiometryToPlayerList (elements[i].specieID, elements[i].stoichiometry, elementList, elementList_length);
		}
	}

#ifdef DEBUG_MOI
	fprintf (stdout, "  breakdownComplex: end.\n");
	fflush (stdout);
#endif
}

/**
 * Ūå롣
 */
static int checkStoichiometricDiscordance2 (TempInfo_t *tempInfo, CListOfPlayers_t *left1, CListOfPlayers_t *left2, CListOfPlayers_t *right1) {
	int				i, j, n, index;
	int				specieID;
	double				stoichiometry;
	int				specieClass;
	int				numberOfSpecies;
	Player_t			*variables;
	int				leftPart_length;
	int				rightPart_length;
	CSpecieReference_t		*specieReference;
	CSpecieReference_t		*leftPart;
	CSpecieReference_t		*rightPart;
	Player_t			*elementList = NULL;
	int				elementList_length = 0;
	int				rightElementIndex;
	Player_t			*v;
	Player_t			*current;

#ifdef DEBUG_MOI
	fprintf (stdout, " checkStoichiometricDiscordance2: start.\n");
	fflush (stdout);
#endif
	/*  */
	numberOfSpecies	= tempInfo->numberOfSpecies;
	variables	= tempInfo->variables;

	/* դʪ뤿ΰ */
	leftPart_length = left1->numberOfPlayers;
	if (left2)
		leftPart_length += left2->numberOfPlayers;
	leftPart = (CSpecieReference_t*) calloc (leftPart_length, sizeof(CSpecieReference_t));		/*  leftPart_length ʤΤǤݤƤ */

	/* դʪ leftPart  */
	n = 0;
	for (i = 0; i < left1->numberOfPlayers; i++) {
		specieReference = &(left1->specieReference[i]);
		specieID = specieReference->specieID;
		stoichiometry = specieReference->stoichiometry;
		for (j = 0; j < n; j++) {
			/* ʪ leftPart ϿѤ */
			if (leftPart[j].specieID == specieID)
				break;
		}
		if (j == n) {
			/* ̤Ͽʪ  leftPart Ͽ */
			leftPart[n].specieID = specieID;
			leftPart[n].stoichiometry = stoichiometry;
			n++;
		} else {
			/* ϿѤʪ  stoichiometry 绻 */
			leftPart[j].stoichiometry += stoichiometry;
		}
	}
	if (left2) {
		for (i = 0; i < left2->numberOfPlayers; i++) {
			specieReference = &(left2->specieReference[i]);
			specieID = specieReference->specieID;
			stoichiometry = specieReference->stoichiometry;
			for (j = 0; j < n; j++) {
				/* ʪ leftPart ϿѤ */
				if (leftPart[j].specieID == specieID)
					break;
			}
			if (j == n) {
				/* ̤Ͽʪ  leftPart Ͽ */
				leftPart[n].specieID = specieID;
				leftPart[n].stoichiometry = stoichiometry;
				n++;
			} else {
				/* ϿѤʪ  stoichiometry 绻 */
				leftPart[j].stoichiometry += stoichiometry;
			}
		}
	}
	leftPart_length = n;	/* դʪͤѹ */

	/* դʪññ̤ʬ򤷤 */
	n = 0;
	for (i = 0; i < leftPart_length; i++) {
		specieID = leftPart[i].specieID;
		stoichiometry = leftPart[i].stoichiometry;
		index = SearchPlayerBySpecieID (variables, numberOfSpecies, specieID);
		specieClass = variables[index].specieClass;
		if (specieClass == SPECIEATTRIBUTE_SPECIECLASS_COMPLEX) {
			index = SearchPlayerBySpecieID (variables, numberOfSpecies, specieID);
			/* ʣΤʤйǤʬ򤹤 */
			breakdownComplex (variables, numberOfSpecies, index, &elementList, &elementList_length);
		} else {
			/* ñΤʤнʣåΤΤɲ */
			addStoichiometryToPlayerList (specieID, stoichiometry, &elementList, &elementList_length);
		}
	}

	/* դʣΤ */
	specieID = right1->specieReference[0].specieID;
	stoichiometry = right1->specieReference[0].stoichiometry;
	index = SearchPlayerBySpecieID (variables, numberOfSpecies, specieID);

	/* դǤʬ򡢺դ */
	rightPart_length = variables[index].numberOfElements;
	rightPart        = variables[index].specieReference;
	if (rightPart_length != elementList_length) {
		/* ǤθĿä饨顼 */
		log_sys ("checkStoichiometricDiscordance2: rightpart has %d elements of complex, but leftpart has %d monomerized players.)\n", rightPart_length, elementList_length);
		goto err;
	}

	/* դιǤҤȤĤĺդӤ */
	for (i = 0; i < rightPart_length; i++) {
		current = elementList;
		while (current) {
			if (current->specieID == rightPart[i].specieID &&
			    current->stoichiometry == rightPart[i].stoichiometry)
				break;
			current = current->next;
		} 
		if (! current) {
			/* NULL ʤƱ ID  stoichiometry Τ
			   ʤäΤǥ顼 */
			index = SearchPlayerBySpecieID (variables, numberOfSpecies, rightPart[i].specieID);
			v = &(variables[index]);
			log_sys ("checkStoichiometricDiscordance2: '%s.%s(specieID=%d)', element of rightpart complex matches for no leftpart monomerized players.\n", v->name, v->compartment_suffix, v->specieID);
			goto err;
		}
	}

#ifdef DEBUG_MOI
	fprintf (stdout, " checkStoichiometricDiscordance2: end.\n");
	fflush (stdout);
#endif
	return 0;
  err:
	return -1;
}

/**
 * Ūå롣
 */
static int checkStoichiometricDiscordance (TempInfo_t *tempInfo, CListOfPlayers_t *left1, CListOfPlayers_t *left2, CListOfPlayers_t *right1) {
	int				i, j, index;
	int				specieID;
	double				stoichiometry;
	int				numberOfSpecies;
	Player_t			*variables;
	int				leftPart_length;
	int				rightPart_length;
	CSpecieReference_t		*leftPart;
	CSpecieReference_t		*rightPart;
	int				variableIndex;

#ifdef DEBUG_MOI
	fprintf (stdout, " checkStoichiometricDiscordance: start.\n");
	fflush (stdout);
#endif
	/*  */
	numberOfSpecies	= tempInfo->numberOfSpecies;
	variables	= tempInfo->variables;

	/* դʪ뤿ΰ */
	leftPart_length = left1->numberOfPlayers;
	if (left2)
		leftPart_length += left2->numberOfPlayers;
	leftPart = (CSpecieReference_t*) calloc (leftPart_length, sizeof(CSpecieReference_t));		/*  leftPart_length ʤΤǤݤƤ */

	/* դʪ leftPart  */
	index = 0;
	for (i = 0; i < left1->numberOfPlayers; i++) {
		specieID = left1->specieReference[i].specieID;
		stoichiometry = left1->specieReference[i].stoichiometry;
		for (j = 0; j < index; j++) {
			/* ʪ leftPart ϿѤ */
			if (leftPart[j].specieID == specieID)
				break;
		}
		if (j == index) {
			/* ̤Ͽʪ  leftPart Ͽ */
			leftPart[index].specieID = specieID;
			leftPart[index].stoichiometry = stoichiometry;
			index++;
		} else {
			/* ϿѤʪ  stoichiometry 绻 */
			leftPart[j].stoichiometry += stoichiometry;
		}
	}
	if (left2) {
		for (i = 0; i < left2->numberOfPlayers; i++) {
			specieID = left2->specieReference[i].specieID;
			stoichiometry = left2->specieReference[i].stoichiometry;
			for (j = 0; j < index; j++) {
				/* ʪ leftPart ϿѤ */
				if (leftPart[j].specieID == specieID)
					break;
			}
			if (j == index) {
				/* ̤Ͽʪ  leftPart Ͽ */
				leftPart[index].specieID = specieID;
				leftPart[index].stoichiometry = stoichiometry;
				index++;
			} else {
				/* ϿѤʪ  stoichiometry 绻 */
				leftPart[j].stoichiometry += stoichiometry;
			}
		}
	}
	leftPart_length = index;	/* դʪͤѹ */

	/* դʣΤ */
	if (right1->numberOfPlayers == 1) {
		specieID = right1->specieReference[0].specieID;
		stoichiometry = right1->specieReference[0].stoichiometry;
	} else {
		/* modifierComplex  products ʤ */
		/* ɤ褦ʤΤ̿Ū顼 */
		log_sys ("checkStoichiometricDiscordance: No products and modifierComplex: rightpart of binding reaction must include modifierComplex or one product.\n");
		goto fatal;
	}
	index = SearchPlayerBySpecieID (variables, numberOfSpecies, specieID);

	/* դǤʬ򡢺դ */
	rightPart_length = variables[index].numberOfElements;
	rightPart = variables[index].specieReference;
	if (leftPart_length != rightPart_length) {
		/* դȱդǿ㤦  ñ̤ȤƤΥå */
		goto err;
	}
	for (i = 0; i < rightPart_length; i++) {
		for (j = 0; j < leftPart_length; j++) {
			if (rightPart[i].specieID == leftPart[j].specieID) {
				if (stoichiometry * rightPart[i].stoichiometry == leftPart[j].stoichiometry) {
					break;
				} else {
					/* դȱդƱʪäۤʤ  ñ̤ȤƤΥå */
					goto err;
				}
			}
		}
		if (j == leftPart_length) {
			/* դȱդǶ̤Ǥʤʪä  ñ̤ȤƤΥå */
			goto err;
		}
	}

#ifdef DEBUG_MOI
	fprintf (stdout, " checkStoichiometricDiscordance: end.\n");
	fflush (stdout);
#endif
	return 0;
  err:
	return -1;
  fatal:
	return -2;
}

/**
 * gene1  reaction Ѵ롣
 *
 * @param tempInfo 
 * @param reaction ȿ
 * @param convType Ѵ
 * @return ｪλʤ 0 顼ʤ -1 
 */
static int convertReaction_CMA_gene1 (TempInfo_t *tempInfo, CReaction_t *reaction, int convType) {
	int			i, index;
	int			numberOfSpecies;
	Player_t		*variables;
	Player_t		*variables_total;
	Equation_t		*equations;
	CListOfPlayers_t	*listOfReactants = NULL;
	CListOfPlayers_t	*listOfProducts  = NULL;
	CListOfPlayers_t	*listOfModifiers = NULL;
	CListOfPlayers_t	*modifierComplex = NULL;
	int			reactionType;
	int			numberOfReactants = 0;
	int			numberOfProducts = 0;
	int			numberOfModifiers = 0;
	int			numberOfModifierComplex = 0;
	Equation_t		*eq;
	Parameter_t		*param;
	Term_t			*term;
	int			specieID;
	CSpecieReference_t	*sr;
	Player_t		*v;
	int			modifierType;
	int			trIndex;
	Player_t		*transcriptionalRegulator_total;
	double			stoichiometry;

#ifdef DEBUG_MOI
	fprintf (stdout, " convertReaction_CMA_gene1: start.\n");
	fflush (stdout);
#endif
	/*  */
	numberOfSpecies = tempInfo->numberOfSpecies;
	variables = tempInfo->variables;
	variables_total = tempInfo->variables_total;
	equations = tempInfo->equations;
	ReadMemberOfReaction (reaction,
			      &listOfReactants, &numberOfReactants,
			      &listOfProducts, &numberOfProducts,
			      &listOfModifiers, &numberOfModifiers,
			      &modifierComplex, &numberOfModifierComplex,
			      &reactionType);

	/* Reaction ǤΥå: Reactant  Product  1 Ĥɬס
	   Modifier  1 İʾɬפǤ˥å */
	if (numberOfReactants != 1 || numberOfProducts != 1) {
		log_sys ("convertReaction_CMA_gene1: gene1 reaction needs 1 reactant and 1 product.\n");
		goto err;
	}

	/* Product Ȥ򸡺 */
	specieID = listOfProducts->specieReference[0].specieID;
	stoichiometry = listOfProducts->specieReference[0].stoichiometry;
	index = SearchPlayerBySpecieID (variables, numberOfSpecies, specieID);
	eq = &(equations[index]);
	v = &(variables[index]);

	/* Product  variableType ꤹ */
	if (v->variableType == VARIABLE_TYPE_UNKNOWN)
		v->variableType = VARIABLE_TYPE_DIFF_CMA;

	/* ѥ᡼κ */
	param = MakeParam(tempInfo, PARAM_TYPE_KM, listOfModifiers, listOfReactants, NULL, NULL);

	/* κ */
	term = MakeNewTerm (stoichiometry * (+1.0), param);

	/* Reactant (gene) 򸡺 */
	specieID = listOfReactants->specieReference[0].specieID;
	index = SearchPlayerBySpecieID (variables, numberOfSpecies, specieID);
	v = &(variables[index]);
	term->gene = makeNewVariate (v, 1.0, 0);

	/* Reactant  variableType ꤹ */
	if (v->variableType == VARIABLE_TYPE_UNKNOWN)
		v->variableType = VARIABLE_TYPE_DIFF_CMA;

	/* activator, inhibitor θ */
	for (i = 0; i < numberOfModifiers; i++) {
		/* modifier θ */
		sr = &(listOfModifiers->specieReference[i]);
		index = SearchPlayerBySpecieID (variables, numberOfSpecies, sr->specieID);
		v = &(variables[index]);

		/* Modifier  variableType ꤹ */
		if (v->variableType == VARIABLE_TYPE_UNKNOWN)
			v->variableType = VARIABLE_TYPE_DIFF_CMA;

		/* modifier ӤιǷ Enhancer ޤ
		   Promoter (žĴ: transcriptional regulator) õ */
		if ((trIndex = searchTranscriptionalRegulator (variables, numberOfSpecies, index)) < 0) {
			/* Ĥʤä饨顼ˤƤΤ */
			log_sys ("convertReaction_CMA_gene1: modifier '%s.%s(specieID=%d)' includes no transcriptional regulator.\n", v->name, v->compartment_suffix, v->specieID);
			goto err;
		}
		/* žĴҤѿ */
		transcriptionalRegulator_total = &(variables_total[trIndex]);
		transcriptionalRegulator_total->variableType = VARIABLE_TYPE_CONST;

		/* modifier žĴҤѿ activator ޤ inhibitor ɲ */
		modifierType = sr->modifierType;
		switch (modifierType) {
		case MODIFIERSPECIEREFERENCE_MODIFIERTYPE_ACTIVATOR:
			Enqueue ((Queue_t**)&term->activators, (Queue_t*)makeNewVariate (v, 1.0, modifierType));
			Enqueue ((Queue_t**)&term->activators_total, (Queue_t*)makeNewVariate (transcriptionalRegulator_total, 1.0, modifierType));
			break;
		case MODIFIERSPECIEREFERENCE_MODIFIERTYPE_INHIBITOR:
			Enqueue ((Queue_t**)&term->inhibitors, (Queue_t*)makeNewVariate (v, 1.0, modifierType));
			Enqueue ((Queue_t**)&term->inhibitors_total, (Queue_t*)makeNewVariate (transcriptionalRegulator_total, 1.0, modifierType));
			break;
		case MODIFIERSPECIEREFERENCE_MODIFIERTYPE_ENZYME:
			log_sys ("convertReaction_CMA_gene1: modifier '%s.%s(specieID=%d)' has illegal modifierType 'enzyme' for gene1 reaction.\n", v->name, v->compartment_suffix, v->specieID);
			goto err;
		}
	}

	/* ؤɲ */
	AddTermToEquation (eq, term);

#ifdef DEBUG_MOI
	fprintf (stdout, " convertReaction_CMA_gene1: end.\n");
	fflush (stdout);
#endif
	return 0;
  err:
	return -1;
}

/**
 * CMA ʪѴ
 */
static int convertPlayer_CMA (TempInfo_t *tempInfo, Parameter_t *parameter, int specieID, double stoichiometry, int playerType, int playerOrigType, CListOfPlayers_t *left1, CListOfPlayers_t *left2, int reactionType, int convType) {
	int		i, index;
	Player_t	*v;
	Equation_t	*eq;
	Term_t		*term;

#ifdef DEBUG_MOI
	fprintf (stdout, " convertPlayer_CMA: start.\n");
	fflush (stdout);
#endif
	/* variable  equation μ */
	index = SearchPlayerBySpecieID (tempInfo->variables, tempInfo->numberOfSpecies, specieID);
	v = &(tempInfo->variables[index]);
	eq = &(tempInfo->equations[index]);

	/* ѿ̤ */
	/* ̤Ǥʤϸ§ȤƺԲġ DIFF_CMA 
	   ALGE_* ˺뤳Ȥϲǽ */
	switch (v->variableType) {
	case VARIABLE_TYPE_UNKNOWN:
		/* ̤ʤɤΥåԤ */
		/* totalAmount:on  massBalance:off ʤ */
		if (v->totalAmount == SPECIEATTRIBUTE_TOTALAMOUNT_CONSTANT &&
		    v->massBalance == SPECIEATTRIBUTE_MASSBALANCE_OFF) {
			/* ѿ̤ˤ */
			v->variableType = VARIABLE_TYPE_CONST;
			/*  decomposition:off ǤʤХ顼 */
			if (v->decomposition == SPECIEATTRIBUTE_DECOMPOSITION_ON) {
				log_sys ("convertPlayer_CMA: constant variable '%s.%s(specieID=%d)' is must be decomposition:off.\n", v->name, v->compartment_suffix, v->specieID);
				goto err;
			}
			break;
		}
		/* Ǥʤ DIFF_CMA ȤƤȤꤢå */
		v->variableType = VARIABLE_TYPE_DIFF_CMA;
		/* DIFF_CMA ȤΤΥåή */
	case VARIABLE_TYPE_DIFF_CMA:
		/* ȿ˴طʪѴ TPP  */
		if ((parameter->type == PARAM_TYPE_KA ||
		     parameter->type == PARAM_TYPE_KD) &&
		    convType != CONVTYPE_CMA) {
			if (v->specieClass == SPECIEATTRIBUTE_SPECIECLASS_COMPLEX) {
				v->variableType = VARIABLE_TYPE_ALGE_COMPLEX;
			} else if (v->massBalance == SPECIEATTRIBUTE_MASSBALANCE_ON) {
				v->variableType = VARIABLE_TYPE_ALGE_MONOMER;
			}
		}
	}

	/* reactant å */
	if (playerOrigType == PLAYER_TYPE_REACTANT &&
	    (reactionType == REACTION_REACTIONTYPE_TRANSCRIPTION ||
	     reactionType == REACTION_REACTIONTYPE_TRANSLATION))
		goto end;

	/* κ */
	if (playerType == PLAYER_TYPE_REACTANT) {
		term = MakeNewTerm (stoichiometry * (-1.0), parameter);
	} else {
		term = MakeNewTerm (stoichiometry * (+1.0), parameter);
	}

	/* κ */
	if (left1)
		addVariatesToTerm (term, tempInfo, left1);
	if (left2)
		addVariatesToTerm (term, tempInfo, left2);

	/* ؤɲ */
	AddTermToEquation (eq, term);

  end:
#ifdef DEBUG_MOI
	fprintf (stdout, " convertPlayer_CMA: end.\n");
	fflush (stdout);
#endif
	return 0;
  err:
#ifdef DEBUG_MOI
	fprintf (stdout, "convertPlayer_CMA: failed.\n");
	fflush (stdout);
#endif
	return -1;
}

/**
 * CMA  CListOfPlayers ˴ޤޤʪѴ
 */
static int convertPlayers_CMA (TempInfo_t *tempInfo, Parameter_t *parameter, CListOfPlayers_t *players, int playerType, int playerOrigType, CListOfPlayers_t *left1, CListOfPlayers_t *left2, int reactionType, int convType) {
	int			i;
	CSpecieReference_t	*specieReference;

#ifdef DEBUG_MOI
	fprintf (stdout, " convertPlayers_CMA: start.\n");
	fflush (stdout);
#endif
	for (i = 0; i < players->numberOfPlayers; i++) {
		specieReference = &(players->specieReference[i]);
		if (convertPlayer_CMA (tempInfo, parameter,
				       specieReference->specieID,
				       specieReference->stoichiometry,
				       playerType, playerOrigType,
				       left1, left2,
				       reactionType, convType)) {
			goto err;
		}
	}

#ifdef DEBUG_MOI
	fprintf (stdout, " convertPlayers_CMA: end.\n");
	fflush (stdout);
#endif
	return 0;
  err:
	return -1;
}

/**
 * CMA  Reaction Ѵ
 */
static int convertReaction_CMA (TempInfo_t *tempInfo,
				CListOfPlayers_t *left1,  int left1Type,
				CListOfPlayers_t *left2,  int left2Type,
				CListOfPlayers_t *right1, int right1Type,
				CListOfPlayers_t *right2, int right2Type,
				Parameter_t *parameter,
				int reactionType, int convType
) {
	int 	i;
	int	ret;

#ifdef DEBUG_MOI
	fprintf (stdout, " convertReaction_CMA: start.\n");
	fflush (stdout);
#endif

	/* ȿդʪ 1 Ѵ */
	if (convertPlayers_CMA (tempInfo, parameter,
				left1, PLAYER_TYPE_REACTANT, left1Type,
				left1, left2, reactionType, convType)) {
		goto err;
	}

	/* ⤷Сȿդʪ 2 Ѵ */
	if (left2) {
		if (convertPlayers_CMA (tempInfo, parameter,
					left2, PLAYER_TYPE_REACTANT, left2Type,
					left1, left2, reactionType, convType)) {
			goto err;
		}
	}

	/* ȿդʪ 1 Ѵ */
	if (right1) {
		if (convertPlayers_CMA (tempInfo, parameter,
					right1, PLAYER_TYPE_PRODUCT, right1Type,
					left1, left2, reactionType, convType)) {
			goto err;
		}
	}

	/* ⤷Сȿդʪ 2 Ѵ */
	if (right2) {
		if (convertPlayers_CMA (tempInfo, parameter,
					right2, PLAYER_TYPE_PRODUCT, right2Type,
					left1, left2, reactionType, convType)) {
			goto err;
		}
	}

	/* ȿȿΰʤвŪ顼åԤ */
	/* ȿ®ٷ ka  kd Ĥᡢ
	   Ǥ ka ξΤߥåԤ */
	if (parameter->type == PARAM_TYPE_KA) {
		/* դʣΤιǤȺդʪñӤ */
		if (ret = checkStoichiometricDiscordance (tempInfo, left1, left2, right1)) {
			/* ͤɾ */
			if (ret < -1) {
				/* -1 꾮̿Ū顼Ƥ */
				log_sys ("checkStoichiometricDescordance failed.\n");
				goto err;
			}
			/* ñӤǰפʤ硢դʣΤñΤ
			   ʬ򤷤ǥåԤ */
			if (checkStoichiometricDiscordance2 (tempInfo, left1, left2, right1)) {
				/* Υåˤ̤ʤХ顼 */
				log_sys ("checkStoichiometricDescordance2 failed.\n");
				goto err;
			}
		}
	}

#ifdef DEBUG_MOI
	fprintf (stdout, " convertReaction_CMA: end.\n");
	fflush (stdout);
#endif
	return 0;
  err:
	return -1;
}

/**
 * CMA ʬ (3)  Reaction ɤ߹
 */
static int breakdownReaction_CMA_3 (TempInfo_t *tempInfo, CReaction_t *reaction, int convType) {
	int 				i;
	Parameter_t			*parameter[3];
	CListOfPlayers_t		*listOfReactants = NULL;
	CListOfPlayers_t		*listOfProducts  = NULL;
	CListOfPlayers_t		*listOfModifiers = NULL;
	CListOfPlayers_t		*modifierComplex = NULL;
	int				reactionType;
	int				numberOfReactants = 0;
	int				numberOfProducts = 0;
	int				numberOfModifiers = 0;
	int				numberOfModifierComplex = 0;
	int 				errflg = false;

#ifdef DEBUG_MOI
	fprintf (stdout, " breakdownReaction_CMA_3: start.\n");
	fprintf (stdout, " reactionID = %d\n", reaction->reactionID);
	fflush (stdout);
#endif

	/*  */
	ReadMemberOfReaction (reaction,
			      &listOfReactants, &numberOfReactants,
			      &listOfProducts, &numberOfProducts,
			      &listOfModifiers, &numberOfModifiers,
			      &modifierComplex, &numberOfModifierComplex,
			      &reactionType);

	/* ȿ˴Ϳʪ¸ߥå */
	/* degradation Ǥ Product ̵Ƥ⤤¾ǤϤ٤ɬ */
	if (numberOfReactants == 0) {
		log_sys ("no reactants exists.\n");
		errflg = true;
	} 
	if (numberOfProducts == 0 &&
	    reactionType != REACTION_REACTIONTYPE_DEGRADATION) {
		log_sys ("no products exists.\n");
		errflg = true;
	}
	if (numberOfModifiers == 0) {
		log_sys ("no modifiers exists.\n");
		errflg = true;
	}
	if (numberOfModifierComplex == 0) {
		log_sys ("no modifierComplex exists.\n");
		errflg = true;
	}
	if (errflg)
		goto err;

	/* ѥ᡼ --- ka, kd, kx Ϳȿ */
	parameter[0] = MakeParam(tempInfo, PARAM_TYPE_KA, listOfModifiers, listOfReactants, NULL, NULL);
	parameter[1] = MakeParam(tempInfo, PARAM_TYPE_KD, listOfModifiers, listOfReactants, NULL, NULL);
	parameter[2] = MakeParam(tempInfo, PARAM_TYPE_KX, listOfModifiers, listOfReactants, NULL, NULL);

	/* οʬ */
	if (convertReaction_CMA (tempInfo,
				 listOfReactants, PLAYER_TYPE_REACTANT,
				 listOfModifiers, PLAYER_TYPE_MODIFIER,
				 modifierComplex, PLAYER_TYPE_MODIFIER_COMPLEX,
				 NULL,	          PLAYER_TYPE_NONE,
				 parameter[0], reactionType, convType) ||
	    convertReaction_CMA (tempInfo,
				 modifierComplex, PLAYER_TYPE_MODIFIER_COMPLEX,
				 NULL,	          PLAYER_TYPE_NONE,
				 listOfReactants, PLAYER_TYPE_REACTANT,
				 listOfModifiers, PLAYER_TYPE_MODIFIER,
				 parameter[1], reactionType, convType) ||
	    convertReaction_CMA (tempInfo,
				 modifierComplex, PLAYER_TYPE_MODIFIER_COMPLEX,
				 NULL,	          PLAYER_TYPE_NONE,
				 listOfProducts,  PLAYER_TYPE_PRODUCT,
				 listOfModifiers, PLAYER_TYPE_MODIFIER,
				 parameter[2], reactionType, convType)) {
		goto err;
	}

  end:
#ifdef DEBUG_MOI
	fprintf (stdout, " breakdownReaction_CMA_3: end.\n");
	fflush (stdout);
#endif

	return 0;
  err:
	return -1;
}

/**
 * CMA ʬ (2)  Reaction ɤ߹
 */
static int breakdownReaction_CMA_2 (TempInfo_t *tempInfo, CReaction_t *reaction, int convType) {
	int 				i;
	Parameter_t			*parameter[2];
	CListOfPlayers_t		*listOfReactants = NULL;
	CListOfPlayers_t		*listOfProducts  = NULL;
	CListOfPlayers_t		*listOfModifiers = NULL;
	CListOfPlayers_t		*modifierComplex = NULL;
	int				reactionType;
	int				numberOfReactants = 0;
	int				numberOfProducts = 0;
	int				numberOfModifiers = 0;
	int				numberOfModifierComplex = 0;
	int 				errflg = false;

#ifdef DEBUG_MOI
	fprintf (stdout, " breakdownReaction_CMA_2: start.\n");
	fflush (stdout);
#endif

	/*  */
	ReadMemberOfReaction (reaction,
			      &listOfReactants, &numberOfReactants,
			      &listOfProducts, &numberOfProducts,
			      &listOfModifiers, &numberOfModifiers,
			      &modifierComplex, &numberOfModifierComplex,
			      &reactionType);

	/* ȿ˴Ϳʪ¸ߥå */
	/* reactants  products Τ¸ߤ뤳 */
	if (numberOfReactants == 0) {
		log_sys ("no reactants exists.\n");
		errflg = true;
	} 
	if (numberOfProducts == 0) {
		log_sys ("no products exists.\n");
		errflg = true;
	}
	if (numberOfModifiers > 0) {
		log_sys ("modifiers exists.\n");
		errflg = true;
	}
	if (numberOfModifierComplex > 0) {
		log_sys ("modifierComplex exists.\n");
		errflg = true;
	}
	if (errflg)
		goto err;

	/* ѥ᡼ */
	switch (paramTypeOfReactionType[reactionType]) {
	case PARAM_TYPE_KA:
		/* ka, kd Ϳȿ */
		parameter[0] = MakeParam(tempInfo, PARAM_TYPE_KA, listOfModifiers, listOfReactants, NULL, NULL);
		parameter[1] = MakeParam(tempInfo, PARAM_TYPE_KD, listOfModifiers, listOfReactants, NULL, NULL);
		break;
	case PARAM_TYPE_KX:
		/* kx1, kx2 Ϳȿ */
		parameter[0] = MakeParam(tempInfo, PARAM_TYPE_KX, listOfModifiers, listOfReactants, NULL, NULL);
		parameter[1] = MakeParam(tempInfo, PARAM_TYPE_KX, listOfModifiers, listOfReactants, NULL, NULL);
		break;
	}

	/* οʬ */
	if (convertReaction_CMA (tempInfo,
				 listOfReactants, PLAYER_TYPE_REACTANT,
				 NULL,	          PLAYER_TYPE_NONE,
				 listOfProducts,  PLAYER_TYPE_PRODUCT,
				 NULL,	          PLAYER_TYPE_NONE,
				 parameter[0], reactionType, convType) ||
	    convertReaction_CMA (tempInfo,
				 listOfProducts,  PLAYER_TYPE_PRODUCT,
				 NULL,	          PLAYER_TYPE_NONE,
				 listOfReactants, PLAYER_TYPE_REACTANT,
				 NULL,	          PLAYER_TYPE_NONE,
				 parameter[1], reactionType, convType)) {
		goto err;
	}

  end:
#ifdef DEBUG_MOI
	fprintf (stdout, " breakdownReaction_CMA_2: end.\n");
	fflush (stdout);
#endif

	return 0;
  err:
	return -1;
}

/**
 * CMA ʬ (1)  Reaction ɤ߹
 */
static int breakdownReaction_CMA_1 (TempInfo_t *tempInfo, CReaction_t *reaction, int convType) {
	int 				i;
	Parameter_t			*parameter;
	CListOfPlayers_t		*listOfReactants = NULL;
	CListOfPlayers_t		*listOfProducts  = NULL;
	CListOfPlayers_t		*listOfModifiers = NULL;
	CListOfPlayers_t		*modifierComplex = NULL;
	int				reactionType;
	int				numberOfReactants = 0;
	int				numberOfProducts = 0;
	int				numberOfModifiers = 0;
	int				numberOfModifierComplex = 0;
	int 				errflg = false;

#ifdef DEBUG_MOI
	fprintf (stdout, " breakdownReaction_CMA_1: start.\n");
	fflush (stdout);
#endif

	/*  */
	ReadMemberOfReaction (reaction,
			      &listOfReactants, &numberOfReactants,
			      &listOfProducts, &numberOfProducts,
			      &listOfModifiers, &numberOfModifiers,
			      &modifierComplex, &numberOfModifierComplex,
			      &reactionType);

	/* ȿ˴Ϳʪ¸ߥå */
	/* reactants  products Τ¸ߤ뤳ȡ
	   degradation Ǥ product ʤƤ褤 */
	if (numberOfReactants == 0) {
		log_sys ("no reactants exists.\n");
		errflg = true;
	} 
	if (numberOfProducts == 0 &&
	    reactionType != REACTION_REACTIONTYPE_DEGRADATION) {
		log_sys ("no products exists.\n");
		errflg = true;
	}
	if (numberOfModifiers > 0) {
		log_sys ("modifiers exists.\n");
		errflg = true;
	}
	if (numberOfModifierComplex > 0) {
		log_sys ("modifierComplex exists.\n");
		errflg = true;
	}
	if (errflg)
		goto err;

	/* ѥ᡼ */
	parameter = MakeParam(tempInfo, paramTypeOfReactionType[reactionType], listOfModifiers, listOfReactants, NULL, NULL);

	/* οʬ */
	if (convertReaction_CMA (tempInfo,
				 listOfReactants, PLAYER_TYPE_REACTANT,
				 NULL,	          PLAYER_TYPE_NONE,
				 listOfProducts,  PLAYER_TYPE_PRODUCT,
				 NULL,	          PLAYER_TYPE_NONE,
				 parameter, reactionType, convType)) {
		goto err;
	}

  end:
#ifdef DEBUG_MOI
	fprintf (stdout, " breakdownReaction_CMA_1: end.\n");
	fflush (stdout);
#endif

	return 0;
  err:
	return -1;
}

/**
 * Reaction ʬ
 */
static int classifyReaction_CMA (TempInfo_t *tempInfo, CReaction_t *reaction, int convType) {
	int 				i;
	Parameter_t			*parameter[3];
	CListOfPlayers_t		*listOfReactants = NULL;
	CListOfPlayers_t		*listOfProducts  = NULL;
	CListOfPlayers_t		*listOfModifiers = NULL;
	CListOfPlayers_t		*modifierComplex = NULL;
	int				reactionClass;
	int				numberOfReactants = 0;
	int				numberOfProducts = 0;
	int				numberOfModifiers = 0;
	int				numberOfModifierComplex = 0;
	Player_t			*reactants;
	Player_t			*products;
	Player_t			*modifiers;
	Player_t			*complex;

#ifdef DEBUG_MOI
	fprintf (stdout, " classifyReaction_CMA: start.\n");
	fflush (stdout);
#endif

	/* isConvertible == FALSE ʤѴʤ */
	if (reaction->isConvertible == PARSEDAE_FALSE) {
		goto end;
	}

	/* modifier ̵ͭ reactionType  reaction ʬह */
	if (reaction->listOfModifiers &&
	    reaction->listOfModifiers[0].numberOfPlayers > 0) {
		/* modifier  */
		switch (reactionClassWithModifier[reaction->reactionType]) {
		case REACTION_CLASS_3:
			/* ʬ (3) */
			if (breakdownReaction_CMA_3 (tempInfo, reaction, convType))
				goto err;
			break;
		case REACTION_CLASS_gene1:
			/* ʬ gene1 */
			if (convertReaction_CMA_gene1 (tempInfo, reaction, convType))
				goto err;
			break;
		default:
			log_sys ("classifyReaction_CMA: invalid reactionType for reaction with modifier.\n");
			goto err;
		}
	} else {
		/* modifier ʤ */
		switch (reactionClassWithoutModifier[reaction->reactionType]) {
		case REACTION_CLASS_1:
			/* ʬ (1) */
			if (breakdownReaction_CMA_1 (tempInfo, reaction, convType))
				goto err;
			break;
		case REACTION_CLASS_2:
			/* ʬ (2) */
			if (breakdownReaction_CMA_2 (tempInfo, reaction, convType))
				goto err;
			break;
		default:
			log_sys ("classifyReaction_CMA: invalid reactionType for reaction without modifier.\n");
			goto err;
		}
	}

  end:
#ifdef DEBUG_MOI
	fprintf (stdout, " classifyReaction_CMA: end.\n");
	fflush (stdout);
#endif
	return 0;
  err:
#ifdef DEBUG_MOI
	fprintf (stdout, " classifyReaction_CMA: failed.\n");
	fflush (stdout);
#endif
	return -1;
}

/**
 * CMA ˤѴ - ᥤ (listOfReactions Ÿ)
 *
 * listOfReactions  layer ѴꤷCMA/TPP ʤ
 * listOfReactions  reaction ҤȤĤ classifyReaction_CMA Ϥ
 * GMA/MM ʤФʤˤ⤷ʤ
 */
static int readReactions_CMA (TempInfo_t *tempInfo, CModel_t *model) {
	int 			i, j;
	CListOfReactions_t	*listOfReactions;
	int 			layer;
	int 			convType;
	CReaction_t		*r;

#ifdef DEBUG_MOI
	fprintf (stdout, "readReactions_CMA: start.\n");
	fflush (stdout);
#endif

	for (i = 0; i < model->listOfReactions_n; i++) {
		listOfReactions = &(model->listOfReactions[i]);

		/* layer Ѵꤹ */
		layer = listOfReactions->layer;
		switch (layer) {
		case LISTOFREACTIONS_LAYER_GENE:
		case LISTOFREACTIONS_LAYER_PROTEIN:
			convType = tempInfo->convType_GeneProtein;
			break;
		case LISTOFREACTIONS_LAYER_METABOLIC:
			convType = tempInfo->convType_Metabolic;
			break;
		}

		switch (convType) {
		case CONVTYPE_CMA:
		case CONVTYPE_TPP_SS1:
		case CONVTYPE_TPP_SS2:
		case CONVTYPE_TPP_RAPID:
			/* ȿʬ */
			for (j = 0; j < listOfReactions->numberOfReactions; j++) {
				r = &(listOfReactions->reaction[j]);
				if (classifyReaction_CMA (tempInfo, r, convType)) {
					log_sys ("reacReactions_CMA: reaction conversion failed.(reactionID=%d,reactionType=%s)\n", r->reactionID, reactionTypeStr[r->reactionType]);
					goto err;
				}
			}
		}
	}

#ifdef DEBUG_MOI
	fprintf (stdout, "readReactions_CMA: end.\n");
	fflush (stdout);
#endif

	return 0;
  err:
	return -1;
}

/**
 * Player  compartment  ListOfCompartments  suffix 롣
 */
static void getCompartmentSuffix (Player_t *player, CListOfCompartments_t *listOfCompartments) {
	int		i;
	CCompartment_t	*compartment;

	for (i = 0; i < listOfCompartments->numberOfCompartments; i++) {
		compartment = &(listOfCompartments->compartment[i]);
		if (player->compartment == compartment->compartmentID)
			memcpy (&(player->compartment_suffix), &(compartment->suffix), SUFFIX_LENGTH);
	}

	return;
}

/**
 * Specie ʲξ Player 롣
 */
static void initPlayer (Player_t *p, CSpecie_t *s, CListOfCompartments_t *loc) {
	CSpecieAttribute_t	*sa;
	int			loe_n;
	CListOfPlayers_t	*loe;

	/* ν */
	sa = &(s->specieAttribute);
	loe_n = s->listOfElements_n;
	loe = s->listOfElements;

	/* Specie ͳξ (suffix  ListOfCompartments 򻲾) */
	p->specieID = s->specieID;
	memcpy (p->name, s->name, NAME_LENGTH);
	p->compartment = s->compartment;
	getCompartmentSuffix (p, loc);

	/* SpecieAttribute ͳξ */
	p->specieClass = sa->specieClass;
	p->massBalance = sa->massBalance;
	p->totalAmount = sa->totalAmount;
	p->decomposition = sa->decomposition;
	p->initialAmount_isValid = sa->initialAmount_isValid;
	p->initialAmount = sa->initialAmount;

	/* listOfElements ͳξ */
	if (loe_n == 1 && loe) {
		p->numberOfElements = loe[0].numberOfPlayers;
		p->specieReference = loe[0].specieReference;
	} else {
		p->numberOfElements = 0;
		p->specieReference = NULL;
	}

	/* ե饰ν */
	p->isRP_GMA = false;
	p->isTotal = false;
}

/**
 * listOfSpecies Ÿ
 */
static void readSpecies (TempInfo_t *tempInfo, CListOfSpecies_t *listOfSpecies) {
	int 			i;
	CSpecie_t		*s = NULL;
	Player_t		*v = NULL;
	Player_t		*vt = NULL;
	Equation_t		*eq = NULL;
	Equation_t		*eqt = NULL;

	for (i = 0; i < listOfSpecies->numberOfSpecies; i++) {
		/* Specie */
		s = &(listOfSpecies->specie[i]);

		/* ѿꥹ */
		/* Player ν */
		v = &(tempInfo->variables[i]);
		initPlayer (v, s, tempInfo->listOfCompartments);

		/* ѿ̤ UNKNOWN ˽ */
		v->variableType = VARIABLE_TYPE_UNKNOWN;

		/* ѿꥹ */
		vt = &(tempInfo->variables_total[i]);
		initPlayer (vt, s, tempInfo->listOfCompartments);
		vt->initialAmount_isValid = PARSEDAE_FALSE;

		/* ꥹ */
		eq = &(tempInfo->equations[i]);
		eq->leftPart = v;

		/* ѿμꥹ */
		eqt = &(tempInfo->equations_total[i]);
		eqt->leftPart = vt;
	}

	return;
}

/**
 * إåơ֥ι
 */
static void makeHeaderInfo (CModel_t *model, HeaderInfo_t *headerInfo) {
	/* title - ǥ̾ */
	memcpy (headerInfo->title, model->name, sizeof(headerInfo->title));
	/* info - ǥ */
	memcpy (headerInfo->info, model->modelInfo, sizeof(headerInfo->info));
}

/**
 * ν
 */
static void initTempInfo (TempInfo_t *tempInfo, OutputInfo_t *outputInfo, CModel_t *model) {
	int			numberOfSpecies;
	CListOfSpecies_t	*listOfSpecies;

	listOfSpecies = &(model->listOfSpecies);
	numberOfSpecies = listOfSpecies->numberOfSpecies;

	/* Ѵ */
	tempInfo->convType_GeneProtein = outputInfo->headerInfo.convType_GeneProtein;
	tempInfo->convType_Metabolic = outputInfo->headerInfo.convType_Metabolic;

	/* ѿ */
	tempInfo->numberOfSpecies = numberOfSpecies;
	tempInfo->variables = (Player_t*) calloc (numberOfSpecies, sizeof(Player_t));
	tempInfo->equations = (Equation_t*) calloc (numberOfSpecies, sizeof(Equation_t));
	tempInfo->variables_total = (Player_t*) calloc (numberOfSpecies, sizeof(Player_t));
	tempInfo->equations_total = (Equation_t*) calloc (numberOfSpecies, sizeof(Equation_t));

	/* Ⱦ */
	tempInfo->listOfSpecies = listOfSpecies;
	tempInfo->listOfCompartments = &(model->listOfCompartments);
}

/**
 * ̿ȿǥѴϾơ֥ۤ롣
 */
int MakeOutputInfo (CModel_t *model, OutputInfo_t *outputInfo, int filetype) {
	TempInfo_t 	tempInfo;
	int i;

	/* ν */
	memset (&tempInfo, 0, sizeof(TempInfo_t));
	initTempInfo (&tempInfo, outputInfo, model);

	/* إåơ֥ι */
	makeHeaderInfo (model, &(outputInfo->headerInfo));

	/* listOfSpecies Ÿ */
	readSpecies (&tempInfo, &(model->listOfSpecies));

	/* CMA/TPP ˤѴ */
	if (readReactions_CMA (&tempInfo, model)) {
		log_sys ("readReactions_CMA failed.\n");
		goto err;
	}

	/* CMA/TPP ξѴʬΥ */
	switch (convType_rough[tempInfo.convType_GeneProtein]) {
	case CONVTYPE_CMA:
		/* ʬν */
		if (execDecomposition (&tempInfo, tempInfo.convType_GeneProtein)) {
			log_sys ("execDecomposition(CMA) failed.\n");
			goto err;
		}

		/* դ¸ߤʤʪѴ */
		convertVariablesToConstants (&tempInfo, CONVTYPE_CMA);

		if (tempInfo.convType_GeneProtein != CONVTYPE_CMA) {
			/* ʬΥ */
			if (SetTPP(&tempInfo)) {
				log_sys ("TPP conversion failed.\n");
				goto err;
			}
		}
	}

	/* ˥ǥåդ */
	NumberConstantPlayers (&tempInfo);

	/* GMA/MM ˤѴ */
	if (ReadReactions_GMA (&tempInfo, model)) {
                log_sys ("ReadReactions_GMA failed.\n");
		goto err;
	}

	/* GMA/MM Ѵ */
	switch (convType_rough[tempInfo.convType_Metabolic]) {
	case CONVTYPE_GMA:
		/* ʬν */
		if (execDecomposition (&tempInfo, tempInfo.convType_Metabolic)) {
			log_sys ("execDecomposition(GMA) failed.\n");
			goto err;
		}
		/* դ¸ߤʤʪѴ */
		convertVariablesToConstants (&tempInfo, CONVTYPE_GMA);
	}

	/* tempInfo  parameters ˥ԡ */
	memcpy (&(outputInfo->parameters), &(tempInfo.parameters), sizeof(Parameters_t));

	/* tempInfo  variableInfo ˥ԡ */
	convertTempInfoToVariableInfo (outputInfo, &tempInfo);

	/* tempInfo  temporaryEqs ˥ԡ */
	memcpy (&(outputInfo->temporaryEqs), &(tempInfo.temporaryEqs), sizeof(TemporaryEqs_t));

	/* tempInfo  equations ˥ԡ */
	convertTempInfoToEquations (outputInfo, &tempInfo);

	return 0;
err:
	return -1;
}
