/***********************************************************************
 *
 *     ̿ߥ졼
 *
 *         parsedae ѥ桼ƥƥؿ
 *
 ***********************************************************************/

#include "parsedae.h"

/**
 * qsort Ӵؿ: Player_t  name Ӥ롣
 */
static int playerCmp (const void *p1, const void *p2) {
	return strcmp ((*(Player_t**)p1)->name, (*(Player_t**)p2)->name);
}

/**
 * ʪʣ (next  NULL ˥ꥻåȤ)
 */
Player_t* PlayerDup (Player_t *src) {
	Player_t	*dest;

	dest = (Player_t*) calloc (1, sizeof(Player_t));
	memcpy (dest, src, sizeof(Player_t));
	dest->next = NULL;

	return dest;
}

/**
 * 󥯥ꥹȤ˥Фɲä롣
 *
 * @param root 󥯥ꥹȤΥ롼ȤؤΥݥ
 * @param newMember ɲä
 * @return 롼
 */
Queue_t* Enqueue (Queue_t **root, Queue_t *newMember) {
	Queue_t *current = NULL;
	Queue_t *prev = NULL;

	current = *root;

	while (current) {
		prev = current;
		current = current->next;
	}

	if (prev) {
		prev->next = newMember;
	} else {
		*root = newMember;
	}

	return *root;
}

/**
 * Player_t 󤫤 specieID ǻꤵ줿 player õ
 * variables  specieReference->specieID Ǹ¤ɬĤ롣
 *
 * @param players оݤȤʤ Player_t 
 * @param players_n оݤȤʤ Player_t θĿ
 * @param specieID åȤ specieID
 * @return Ĥäϳ player ΥǥåĤʤ -1
 */
int SearchPlayerBySpecieID (Player_t *players, int players_n, int specieID) {
	int		i;
	int		ret = -1;

	for (i = 0; i < players_n; i++) {
		if (players[i].specieID == specieID) {
			ret = i;
			break;
		}
	}

	return ret;
}

/**
 * αդ˹ɲä롣
 */
void AddTermToEquation (Equation_t *equation, Term_t *term) {
	Enqueue ((Queue_t**)&(equation->rightPartTerms), (Queue_t*)term);
}

/**
 * ѿʬ Variate ɲä롣
 */
void AddVariateToTerm (Term_t *term, Player_t *player, double stoichiometry) {
	Variate_t	*variate;

#ifdef DEBUG_PU
	fprintf (stdout, "   AddVariateToTerm: start.\n");
	fflush (stdout);
#endif
	variate = (Variate_t*) calloc (1, sizeof(Variate_t));
	variate->powerCoefficient = stoichiometry;
	variate->player = player;

	Enqueue ((Queue_t**)&(term->variates), (Queue_t*)variate);

#ifdef DEBUG_PU
	fprintf (stdout, "   AddVariateToTerm: end.\n");
	fflush (stdout);
#endif
	return;
}

/**
 * Coefficient Ƥꤷƿ Term Ĥ롣
 */
Term_t* MakeNewTerm (double stoichiometry, Parameter_t *parameter) {
	Term_t *term = NULL;
	Coefficient_t *coefficient = NULL;

	term = (Term_t*) calloc (1, sizeof(Term_t));
	coefficient = &(term->coefficient);
	coefficient->coefficient = stoichiometry;
	coefficient->paramType = parameter->type;
	coefficient->paramIndex = parameter->index;
	coefficient->powerCoefficient = 1.0;

	return term;
}

/**
 * ʪ̤θʪν
 *
 * ʪ̤
 * - CONST ʤ constantPlayer[index]
 * - ALGE_* ʤ x[name.compartment]
 * - DIFF_* ʤ y[name.compartment]
 * ȤƻΥХåե˽񤭽Ф
 * ΤȤ CONST ʳǤ name  prefix ǻꤵ줿ʸղä롣
 * Ūˤ total ѿϤ prefix Ȥ "T" ꤷ
 * - ALGE_* ʤ x[Tname.compartment]
 * - DIFF_* ʤ y[Tname.compartment]
 * Ϥ褦ˤ롣
 *
 * աδؿǤ ret  alloc ؤΥݥ󥿤֤ᡢ
 * ƤӽФ¦Ŭڤ free ɬפ롣
 */
int WritePlayer (char **ret, Player_t *player, char *prefix) {
	*ret = (char*) calloc (1, BUFFSIZE);

	switch (player->variableType) {
	case VARIABLE_TYPE_CONST:
		snprintf (*ret, BUFFSIZE, "constantPlayer[%d]", player->constantIndex);
		break;
	case VARIABLE_TYPE_ALGE_MONOMER:
	case VARIABLE_TYPE_ALGE_COMPLEX:
		snprintf (*ret, BUFFSIZE, "x[%s%s.%s]", prefix, player->name, player->compartment_suffix);
		break;
	case VARIABLE_TYPE_DIFF_CMA:
	case VARIABLE_TYPE_DIFF_GMA:
		snprintf (*ret, BUFFSIZE, "y[%s%s.%s]", prefix, player->name, player->compartment_suffix);
		break;
	case VARIABLE_TYPE_UNKNOWN:
		goto err;
	}

	return true;
  err:
	return false;
}

/**
 * Reaction ˴ͿƤʪΥꥹȤ롣
 *
 * reaction  ListOfPlayers Ȥ numberOfPlayers, 
 * reactionType ʤɤ롣
 */
void ReadMemberOfReaction (CReaction_t *reaction, 
		CListOfPlayers_t **listOfReactants, int *numberOfReactants, 
		CListOfPlayers_t **listOfProducts, int *numberOfProducts,
		CListOfPlayers_t **listOfModifiers, int *numberOfModifiers,
		CListOfPlayers_t **modifierComplex, int *numberOfModifierComplex,
		int *reactionType) {

	if (listOfReactants && numberOfReactants) {
		*listOfReactants = NULL;
		*numberOfReactants = 0;
		if (reaction->listOfReactants) {
			*listOfReactants = &(reaction->listOfReactants[0]);
			*numberOfReactants = (*listOfReactants)->numberOfPlayers;
		}
	}

	if (listOfProducts && numberOfProducts) {
		*listOfProducts = NULL;
		*numberOfProducts = 0;
		if (reaction->listOfProducts) {
			*listOfProducts = &(reaction->listOfProducts[0]);
			*numberOfProducts = (*listOfProducts)->numberOfPlayers;
		}
	}

	if (listOfModifiers && numberOfModifiers) {
		*listOfModifiers = NULL;
		*numberOfModifiers = 0;
		if (reaction->listOfModifiers) {
			*listOfModifiers = &(reaction->listOfModifiers[0]);
			*numberOfModifiers = (*listOfModifiers)->numberOfPlayers;
		}
	}

	if (modifierComplex && numberOfModifierComplex) {
		*modifierComplex = NULL;
		*numberOfModifierComplex = 0;
		if (reaction->modifierComplex) {
			*modifierComplex = &(reaction->modifierComplex[0]);
			*numberOfModifierComplex = 1;
		}
	}

	/* reactionType */
	if (reactionType)
		*reactionType = reaction->reactionType;
}

/**
 * ListOfPlayers ѥ᡼̾ Reactants / Modifier 롣
 */
static void makeParamNameFromPlayers (TempInfo_t *tempInfo, char **buff, CListOfPlayers_t *listOfPlayers) {
	int		i, index;
	int		specieID;
	int		numberOfSpecies;
	Player_t	*variables;
	int		numberOfPlayers;
	Player_t	**players;
	char		*buff_orig;

	/*  */
	numberOfSpecies	= tempInfo->numberOfSpecies;
	variables	= tempInfo->variables;
	numberOfPlayers = listOfPlayers->numberOfPlayers;
	players = (Player_t**) calloc (numberOfPlayers, sizeof(Player_t*));

	for (i = 0; i < numberOfPlayers; i++) {
		specieID = listOfPlayers->specieReference[i].specieID;
		index = SearchPlayerBySpecieID (variables, numberOfSpecies, specieID);
		players[i] = PlayerDup (&(variables[index]));
	}

	qsort (players, numberOfPlayers, sizeof(Player_t*), playerCmp);

	for (i = 0; i < listOfPlayers->numberOfPlayers; i++) {
		buff_orig = strdup (*buff);
		snprintf (*buff, BUFFSIZE, "%s_%s.%s", buff_orig, players[i]->name, players[i]->compartment_suffix);
		free (buff_orig);
	}

	free (players);

	return;
}

/**
 * Parameter ̾Ĥ롣
 */
static void nameParameter (TempInfo_t *tempInfo, Parameter_t *param, int paramType, CListOfPlayers_t *listOfModifiers, CListOfPlayers_t *listOfReactants, Player_t *target, Player_t *reactant) {
	int		i, id, length;
	int		with_target = 0;
	char		*buff;
	char		*buff_orig;
	Player_t	*player;
	Player_t	**root;
	Player_t	**array;

	buff = (char*) calloc (1, BUFFSIZE);

	/* reactant ʤꤵƤ餽Τޤ̾ĤƤޤ */
	if (reactant) {
		snprintf (buff, BUFFSIZE, "_%s.%s", reactant->name, reactant->compartment_suffix);
		goto end;
	}

	/* f ޤ Kmich ʤ target ̾Ĥ */
	if (paramType == PARAM_TYPE_F || paramType == PARAM_TYPE_KMICH)
		snprintf (buff, BUFFSIZE, "(%s.%s)", target->name, target->compartment_suffix);

	/* Modifiers  Reactants ̾Ĥ */
	if (listOfModifiers)
		makeParamNameFromPlayers (tempInfo, &buff, listOfModifiers);
	makeParamNameFromPlayers (tempInfo, &buff, listOfReactants);

	buff_orig = strdup (buff);

	/* GMA ˴ؤΤʤ _GMA Ĥ */
	if (paramType == PARAM_TYPE_F || paramType == PARAM_TYPE_KXG)
		snprintf (buff, BUFFSIZE, "%s_GMA", buff_orig);

	/* MM ˴ؤΤʤ _MM Ĥ */
	if (paramType == PARAM_TYPE_Q || paramType == PARAM_TYPE_KMICH)
		snprintf (buff, BUFFSIZE, "%s_MM", buff_orig);

	free (buff_orig);

  end:
	param->name = strdup (buff);
	free (buff);

	return;
}

/**
 * ѥ᡼̤ꤷƿǥåʧФParameter 롣
 *
 * ʬξʬ򤹤ʪ reactant ˡf ޤ Kmich ξоݤȤʤ
 * ʪ target ˡʳξȿ˴Ϳʪʪ
 * listOfReactants  listOfModifiers ˻ꤷʤФʤʤ
 * ʤlistOfModifiers ϤʤƤ褤
 *
 * @param tempInfo ơ֥
 * @param paramType ѥ᡼μ
 * @param listOfModifiers ȿʪΥꥹ
 * @param listOfReactants ȿʪΥꥹ
 * @param target оʪ
 * @param reactant ȿʪ
 * @return ѥ᡼
 */
Parameter_t* MakeParam (TempInfo_t *tempInfo, int paramType, CListOfPlayers_t *listOfModifiers, CListOfPlayers_t *listOfReactants, Player_t *target, Player_t *reactant) {
	Parameters_t	*parameters;
	Parameter_t	**root;
	Parameter_t	*param;
	Parameter_t	*current;
	int		*param_num;

	parameters = &(tempInfo->parameters);

	root = &(parameters->param[paramType]);
	param_num = &(parameters->param_num[paramType]);

	param = (Parameter_t*) calloc (1, sizeof(Parameter_t));

	/* reactant ľܻꤹ kmd/kpd ξ¸ߥåɬ */
	/* (complex Ǥʣǽ뤿) */
	if (reactant) {
		current = *root;
		while (current) {
			if (current->reactantID == reactant->specieID) {
				free (param);
				param = current;
				goto end;
			}
			current = current->next;
		}
		param->reactantID = reactant->specieID;
	}

	param->index = ++(*param_num);
	param->type = paramType;
	nameParameter (tempInfo, param, paramType, listOfModifiers, listOfReactants, target, reactant);
	param->next = *root;
	*root = param;

  end:
	return param;
}

/**
 * ꤵ줿ѿʤХǥåʧФ
 */
void NumberConstantPlayer (TempInfo_t *ti, Player_t *v) {
	/* ѿ̤ CONST  constantIndex ̤ʤ */
	/* ti->numberOfConstants 饤ǥåʧФ */
	if (v->variableType == VARIABLE_TYPE_CONST &&
	    v->constantIndex == 0) {
		v->constantIndex = ti->numberOfConstants + 1;
		(ti->numberOfConstants)++;
	}
}

/**
 * ǥåΤĤƤʤ٤Ƥ˥ǥåʧФ
 */
void NumberConstantPlayers (TempInfo_t *ti) {
	int		i;

	for (i = 0; i < ti->numberOfSpecies; i++)
		NumberConstantPlayer (ti, &(ti->variables[i]));
	for (i = 0; i < ti->numberOfSpecies; i++)
		NumberConstantPlayer (ti, &(ti->variables_total[i]));
}



/*** ================== D E B U G ================== ***/

#ifdef DEBUG
void Debug_printListOfPlayers (CListOfPlayers_t *listOfPlayers) {
	int k;
	CSpecieReference_t	*specieReference;

	printf ("      numberOfPlayers = %d\n", listOfPlayers->numberOfPlayers);

	for (k = 0; k < listOfPlayers->numberOfPlayers; k++) {
		specieReference = &(listOfPlayers->specieReference[k]);

		printf ("      [specieReference]\n");
		printf ("        specieID = %d, name = %s, compartment = %d, stoichiometry = %f, modifierType = %d, isTotal = %d\n", specieReference->specieID, specieReference->name, specieReference->compartment, specieReference->stoichiometry, specieReference->modifierType, specieReference->isTotal);
	}
}

void Debug_printListOfReactions (CListOfReactions_t *listOfReactions) {
	int i, j;
	CReaction_t	*reaction;
	
	printf ("[listOfReactions]\n");
	printf ("  layer = %d, numberOfReactions = %d\n", listOfReactions->layer, listOfReactions->numberOfReactions);
	for (i = 0; i < listOfReactions->numberOfReactions; i++) {
		reaction = &(listOfReactions->reaction[i]);

		printf ("  [Reaction]\n");
		printf ("    reactionID = %d, groupID = %d, reactionType = %d, isConvertible = %d, modifierReactionEquation = %s\n", reaction->reactionID, reaction->groupID, reaction->reactionType, reaction->isConvertible, reaction->modifierReactionEquation);

		printf ("    listOfReactants_n = %d\n", reaction->listOfReactants_n);
		for (j = 0; j < reaction->listOfReactants_n; j++) {
			printf ("    [listOfReactants]\n");
			Debug_printListOfPlayers (&(reaction->listOfReactants[j]));
		}
		printf ("    listOfProducts_n = %d\n", reaction->listOfProducts_n);
		for (j = 0; j < reaction->listOfProducts_n; j++) {
			printf ("    [listOfProducts]\n");
			Debug_printListOfPlayers (&(reaction->listOfProducts[j]));
		}
		printf ("    listOfModifiers_n = %d\n", reaction->listOfModifiers_n);
		for (j = 0; j < reaction->listOfModifiers_n; j++) {
			printf ("    [listOfModifiers]\n");
			Debug_printListOfPlayers (&(reaction->listOfModifiers[j]));
		}
		printf ("    modifierComplex_n = %d\n", reaction->modifierComplex_n);
		for (j = 0; j < reaction->modifierComplex_n; j++) {
			printf ("    [modifierComplex]\n");
			Debug_printListOfPlayers (&(reaction->modifierComplex[j]));
		}
	}
}
#endif /* DEBUG */
